SystemOrganization addCategory: #'TPV-Model'!

QCParentObject subclass: #POSObject
	instanceVariableNames: ''
	classVariableNames: 'Session1'
	poolDictionaries: ''
	category: 'TPV-Model'!

POSObject subclass: #Cuit
	instanceVariableNames: 'cuit'
	classVariableNames: 'CuitCero'
	poolDictionaries: ''
	category: 'TPV-Model'!

!Cuit class methodsFor: 'creation' stamp: 'PabloDigonzelli 6/15/2014 17:46'!
cero
	CuitCero isNil ifTrue: [CuitCero := super new initialize cuit: '00000000000'].
	^ CuitCero	! !

!Cuit class methodsFor: 'accessing - properties' stamp: 'PRD 7/22/2014 21:19'!
hasUserRights
	^ false! !

!Cuit methodsFor: 'accessing' stamp: 'PabloDigonzelli 6/15/2014 17:38'!
cuit: aString 
	cuit := aString! !

POSObject subclass: #Direccion
	instanceVariableNames: 'calle numero piso departamento codigoPostal localidad provincia pais'
	classVariableNames: 'Anonima'
	poolDictionaries: ''
	category: 'TPV-Model'!

!Direccion class methodsFor: 'creation' stamp: 'PRD 9/17/2014 19:50'!
anonima
	Anonima isNil ifTrue: [ Anonima := self initializeAnonima].
	^ Anonima! !

!Direccion class methodsFor: 'as yet unclassified' stamp: 'PRD 9/17/2014 15:45'!
collection 
	^ OrderedCollection new! !

!Direccion class methodsFor: 'as yet unclassified' stamp: 'PRD 12/3/2014 00:48'!
from: aDireccion
	^ super new initialize copyFrom: aDireccion.
! !

!Direccion class methodsFor: 'accessing properties' stamp: 'PRD 7/22/2014 21:20'!
hasUserRights
	^ false! !

!Direccion class methodsFor: 'initialization' stamp: 'PRD 9/17/2014 21:00'!
initializeAnonima
	^ super new initialize
		codigoPostal: '4000';
		pais: Pais argentina;
		provincia: Provincia default;
		localidad: 'Anonima';
		calle: 'Anonima';
		numero: 'Anonimo';
		piso: 'Anonimo';
		departamento: 'Anonimo';
		yourself! !

!Direccion class methodsFor: 'initialization' stamp: 'PRD 9/17/2014 19:51'!
reset
	Anonima := nil! !

!Direccion methodsFor: 'as yet unclassified' stamp: 'PRD 12/14/2014 16:41'!
= anObject
	(anObject isKindOf: self class)
		ifFalse: [ ^ false ].
	^ anObject calle = self calle
		and: [ 
			anObject numero = self numero
				and: [ 
					anObject piso = self piso
						and: [ anObject localidad = self localidad and: [ anObject provincia = self provincia and: [ anObject pais = self pais ] ] ] ] ]! !

!Direccion methodsFor: 'accessing' stamp: 'PRD 9/16/2014 12:15'!
calle
	^ calle! !

!Direccion methodsFor: 'accessing' stamp: 'PabloDigonzelli 6/15/2014 17:00'!
calle: aString 
	calle := aString! !

!Direccion methodsFor: 'accessing' stamp: 'PabloDigonzelli 6/15/2014 18:33'!
codigoPostal
	^ codigoPostal! !

!Direccion methodsFor: 'accessing' stamp: 'PRD 9/17/2014 20:54'!
codigoPostal: aCodigoPostal
	codigoPostal := aCodigoPostal! !

!Direccion methodsFor: 'as yet unclassified' stamp: 'PRD 12/3/2014 00:43'!
copyFrom: anotherObject
	super copyFrom: anotherObject! !

!Direccion methodsFor: 'accessing' stamp: 'PRD 9/16/2014 12:15'!
departamento
	^ departamento! !

!Direccion methodsFor: 'accessing' stamp: 'PabloDigonzelli 6/15/2014 17:01'!
departamento: aString 
	departamento := aString! !

!Direccion methodsFor: 'accessing' stamp: 'PRD 11/28/2014 09:14'!
descriptionCalle
	<magritteDescription>
	^ MAStringDescription new 
		priority: 100;
		label: 'Calle';
		accessor: #calle;
		comment: 'Calle';
		beRequired ;
		yourself! !

!Direccion methodsFor: 'accessing' stamp: 'PRD 11/28/2014 09:15'!
descriptionCodigoPostal	
	<magritteDescription>
	^ MAStringDescription new 
		priority: 500;
		label: 'CP';
		accessor: #codigoPostal ;
		comment: 'Codigo Postal';
		beRequired ;
		yourself! !

!Direccion methodsFor: 'accessing' stamp: 'PRD 11/28/2014 09:14'!
descriptionDepartamento
	<magritteDescription>
	^ MAStringDescription new 
		priority: 400;
		label: 'Dpto';
		accessor: #departamento;
		comment: 'Departamento';
		yourself! !

!Direccion methodsFor: 'accessing' stamp: 'PRD 11/28/2014 09:14'!
descriptionLocalidad
	<magritteDescription>
	^ (MAStringDescription new )
		priority: 800;
		accessor: #localidad ;
		label: 'Localidad';
		comment: 'Localidad';
		yourself .
! !

!Direccion methodsFor: 'accessing' stamp: 'PRD 11/28/2014 09:14'!
descriptionNumero
	<magritteDescription>
	^ MAStringDescription new 
		priority: 200;
		label: 'Numero';
		accessor: #numero;
		comment: 'Numero';
		yourself! !

!Direccion methodsFor: 'accessing' stamp: 'PRD 11/28/2014 09:14'!
descriptionPais
	<magritteDescription>
	^ MASingleOptionDescription  new
		label: 'Pais';
		accessor: #pais;
		priority: 600;
		optionsAndLabels: ( Pais collection  collect: [:each | Association key: each value: each nombre ] ) ;
		default: Pais default;
		comment: 'Pais';
		yourself! !

!Direccion methodsFor: 'accessing' stamp: 'PRD 11/28/2014 09:14'!
descriptionPiso
	<magritteDescription>
	^ MAStringDescription new 
		priority: 300;
		label: 'Piso';
		accessor: #piso;
		comment: 'Piso';
		yourself! !

!Direccion methodsFor: 'accessing' stamp: 'PRD 11/28/2014 09:14'!
descriptionProvincia
	<magritteDescription>
	^ (MASingleOptionDescription new )
		accessor: #provincia ;
		label: 'Provincia';
		priority: 700;
		optionsAndLabels: (self pais provincias collect: [:each | Association key: each value: each nombre ] );
		default: (self pais provincias first);
		comment: 'Provincia';
		yourself .
! !

!Direccion methodsFor: 'as yet unclassified' stamp: 'PRD 12/14/2014 16:41'!
hash
	^ calle hash + numero hash + piso hash + localidad hash + provincia hash + pais hash! !

!Direccion methodsFor: 'as yet unclassified' stamp: 'PRD 10/28/2014 03:05'!
initialize
	super initialize.
	codigoPostal := '4000'.
	pais := Pais default.
	provincia := Provincia default.
! !

!Direccion methodsFor: 'accessing' stamp: 'PabloDigonzelli 6/15/2014 19:57'!
localidad
	^ localidad! !

!Direccion methodsFor: 'accessing' stamp: 'PRD 9/17/2014 20:54'!
localidad: aLocalidad 
	localidad := aLocalidad! !

!Direccion methodsFor: 'accessing' stamp: 'PRD 9/16/2014 12:15'!
numero
	^ numero! !

!Direccion methodsFor: 'accessing' stamp: 'PabloDigonzelli 6/15/2014 18:47'!
numero: aString 
	numero := aString! !

!Direccion methodsFor: 'accessing' stamp: 'PRD 9/17/2014 15:34'!
pais
	^ pais! !

!Direccion methodsFor: 'accessing' stamp: 'PRD 9/17/2014 15:34'!
pais: anObject
	pais := anObject! !

!Direccion methodsFor: 'accessing' stamp: 'PRD 9/16/2014 12:15'!
piso
	^ piso! !

!Direccion methodsFor: 'accessing' stamp: 'PabloDigonzelli 6/15/2014 17:01'!
piso: aString 
	piso := aString! !

!Direccion methodsFor: 'accessing' stamp: 'PRD 9/16/2014 12:15'!
provincia
	^ provincia! !

!Direccion methodsFor: 'accessing' stamp: 'PabloDigonzelli 6/15/2014 17:11'!
provincia: aProvincia
	provincia := aProvincia.! !

Direccion subclass: #DireccionCliente
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!DireccionCliente class methodsFor: 'as yet unclassified' stamp: 'PRD 12/10/2014 11:56'!
anonima
	^ (super from: Direccion anonima)! !

Direccion subclass: #DireccionComprobante
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!DireccionComprobante class methodsFor: 'as yet unclassified' stamp: 'PRD 12/10/2014 11:57'!
anonima
	^ (super from: Direccion anonima)! !

Direccion subclass: #DireccionEmpresa
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!DireccionEmpresa class methodsFor: 'as yet unclassified' stamp: 'PRD 12/10/2014 11:58'!
anonima
	^ (super from: Direccion anonima)! !

POSObject subclass: #Localidad
	instanceVariableNames: 'provincia nombre'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!Localidad class methodsFor: 'as yet unclassified' stamp: 'PRD 9/17/2014 11:21'!
provincia: aProvincia
	^ aProvincia localidades! !

!Localidad methodsFor: 'accessing' stamp: 'PRD 9/17/2014 11:28'!
descriptionNombre
	<magritteDescription>
	^ Provincia new descriptionNombre label: 'Nombre'! !

!Localidad methodsFor: 'as yet unclassified' stamp: 'PRD 9/17/2014 20:04'!
initialize
	super initialize .
	provincia := Provincia default.
	! !

!Localidad methodsFor: 'accessing' stamp: 'PRD 9/17/2014 10:26'!
nombre
	^ nombre! !

!Localidad methodsFor: 'accessing' stamp: 'PRD 9/17/2014 10:26'!
nombre: anObject
	nombre := anObject! !

!Localidad methodsFor: 'accessing' stamp: 'PRD 9/17/2014 10:26'!
provincia
	^ provincia! !

!Localidad methodsFor: 'accessing' stamp: 'PRD 9/17/2014 10:26'!
provincia: anObject
	provincia := anObject! !

!POSObject class methodsFor: 'as yet unclassified' stamp: 'PRD 12/11/2014 00:30'!
getSession
	"Return the session to be used for the current query. In general, we don't know how to find our session. Callers can catch the CannotFindSession exception and resume it, or subclasses can implement this method to find the session using mechanisms like process environment, a global, or whatever else they have available."
	^ self session gsession	! !

!POSObject class methodsFor: 'as yet unclassified' stamp: 'PRD 4/17/2015 16:37'!
requestContext
	"Return the session to be used for the current query. In general, we don't know how to find our session. Callers can catch the CannotFindSession exception and resume it, or subclasses can implement this method to find the session using mechanisms like process environment, a global, or whatever else they have available."
	
	"Session1 isNil ifTrue: [  ^ POSSession noSeaside  ] ifFalse: [^ Session1]." "PRD10"
	
	[ ^ WACurrentRequestContext value ] on: WARequestContextNotFound do: [ :ex | ^ nil ]	! !

!POSObject class methodsFor: 'as yet unclassified' stamp: 'PRD 4/17/2015 18:41'!
session
	"Return the session to be used for the current query. In general, we don't know how to find our session. Callers can catch the CannotFindSession exception and resume it, or subclasses can implement this method to find the session using mechanisms like process environment, a global, or whatever else they have available."
	
	"Session1 isNil ifTrue: [  ^ POSSession noSeaside  ] ifFalse: [^ Session1]." "PRD10"
	
	self requestContext ifNil: [ ^ POSSession noSeaside ].
	^ self requestContext session! !

!POSObject methodsFor: 'as yet unclassified' stamp: 'PRD 12/1/2014 15:35'!
add
	^ true! !

!POSObject methodsFor: 'validating' stamp: 'PRD 1/29/2015 17:35'!
basicValidateAdd
	^ self validate
! !

!POSObject methodsFor: 'validating' stamp: 'PRD 1/29/2015 17:34'!
basicValidateEdit
	^ self validate! !

!POSObject methodsFor: 'validating' stamp: 'PRD 1/29/2015 17:35'!
basicValidateRemove
	^ true! !

!POSObject methodsFor: 'pos-qc-integration' stamp: 'PRD 2/4/2015 14:33'!
canEdit
	^ true! !

!POSObject methodsFor: 'pos-qc-integration' stamp: 'PRD 8/6/2014 11:51'!
canQuery
	^ true! !

!POSObject methodsFor: 'pos-qc-integration' stamp: 'PRD 8/6/2014 11:41'!
canRemove
	^ true! !

!POSObject methodsFor: 'pos-qc-integration' stamp: 'PRD 2/4/2015 14:27'!
canShowDetails
	^ true! !

!POSObject methodsFor: 'as yet unclassified' stamp: 'PRD 9/13/2014 21:46'!
defaultComponentClass
	^POSQCMultipartComponent! !

!POSObject methodsFor: 'as yet unclassified' stamp: 'PRD 4/23/2015 14:31'!
descriptionDisplayString
	^ nil! !

!POSObject methodsFor: 'as yet unclassified' stamp: 'PRD 12/9/2014 02:21'!
displayName
	^ self printName! !

!POSObject methodsFor: 'as yet unclassified' stamp: 'PRD 4/23/2015 11:26'!
displayStringVisibleInLabel
	^ false! !

!POSObject methodsFor: 'as yet unclassified' stamp: 'PRD 4/23/2015 11:26'!
displayStringVisibleInReport
	^ false! !

!POSObject methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/6/2015 18:21'!
initialize
	super initialize.

	! !

!POSObject methodsFor: 'as yet unclassified' stamp: 'PRD 1/19/2015 09:13'!
mementoClass
	^POSQCAjaxMemento! !

!POSObject methodsFor: 'as yet unclassified' stamp: 'PRD 9/17/2014 01:56'!
nombre
	^ self class name! !

!POSObject methodsFor: 'as yet unclassified' stamp: 'PRD 9/17/2014 12:55'!
printName
	^ self nombre ifNil: [  self class name ]! !

!POSObject methodsFor: 'as yet unclassified' stamp: 'PRD 9/18/2014 18:20'!
printOn: aStream
	"Append to the argument, aStream, a sequence of characters that  
	identifies the receiver."

	| title |
	title := self class name.
	aStream
		nextPutAll: title.! !

!POSObject methodsFor: 'as yet unclassified' stamp: 'PRD 4/17/2015 13:15'!
session
	super session ifNil: [ ^ POSSession noSeaside  ].
	^ super session
	! !

!POSObject methodsFor: 'as yet unclassified' stamp: 'PRD 12/1/2014 18:18'!
validate
	^ true! !

!POSObject methodsFor: 'validating' stamp: 'PRD 1/29/2015 17:35'!
validateAdd
	^ self basicValidateAdd! !

!POSObject methodsFor: 'validating' stamp: 'PRD 1/29/2015 17:34'!
validateEdit
	^ self basicValidateEdit! !

!POSObject methodsFor: 'validating' stamp: 'PRD 1/29/2015 17:37'!
validateRemove
	^ self basicValidateRemove! !

POSObject subclass: #POSPersistentObject
	instanceVariableNames: 'creacion idUnico pid usuariodbpid usuariodbname ultimaModificacion version'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

POSPersistentObject subclass: #Almacen
	instanceVariableNames: 'nombre almacenes almacenOrigen existencias empresa virtual cajas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!Almacen class methodsFor: 'as yet unclassified' stamp: 'PRD 4/10/2015 09:51'!
aboutClearCollectionInSession: aPOSSession
	aPOSSession clearCollection: Caja.
		! !

!Almacen class methodsFor: 'creation' stamp: 'PRD 4/28/2015 09:10'!
almacen1
	^ self creaAlmacen1 .! !

!Almacen class methodsFor: 'creation' stamp: 'PRD 4/28/2015 09:11'!
almacen2
	^ self creaAlmacen2.! !

!Almacen class methodsFor: 'as yet unclassified' stamp: 'PRD 12/11/2014 10:05'!
clearCollection
	self getSession clearCollection: Caja.
	self getSession clearCollection: ExistenciaItem.
	super clearCollection .! !

!Almacen class methodsFor: 'creation' stamp: 'PRD 4/28/2015 09:10'!
creaAlmacen1

	|a|
	a :=  super new initialize nombre: 'Almacen1'.
	a addCaja: Caja uno.
	^ a ! !

!Almacen class methodsFor: 'creation' stamp: 'PRD 4/28/2015 09:10'!
creaAlmacen2

	|a|
	a :=  super new initialize nombre: 'Almacen2'.
	a addCaja: Caja uno.
	^ a ! !

!Almacen class methodsFor: 'creation' stamp: 'PRD 11/24/2014 02:09'!
creaPrueba1

	|a|
	a :=  super new initialize nombre: 'Prueba1'.
	a addCaja: Caja uno.
	^ a ! !

!Almacen class methodsFor: 'creation' stamp: 'PRD 11/24/2014 02:09'!
creaPrueba2
	| a |
	a :=  super new initialize nombre: 'Prueba2'.
	a addCaja: Caja uno.
	^ a! !

!Almacen class methodsFor: 'as yet unclassified' stamp: 'PRD 11/25/2014 14:29'!
empresa: aEmpresa nombre: aNombre
	| a |
	a := aEmpresa almacenName: aNombre.
	a	ifNil: [ ^ aEmpresa
				addAlmacen:
					(super new initialize
						nombre: aNombre;
						yourself) ]
		ifNotNil: [ ^ a ].! !

!Almacen class methodsFor: 'accessing' stamp: 'PRD 11/24/2014 18:41'!
paraEmpresa: anEmpresa 
	
	^ anEmpresa almacenes
! !

!Almacen class methodsFor: 'creation' stamp: 'PRD 11/24/2014 01:53'!
prueba1
	^ self creaPrueba1 .! !

!Almacen class methodsFor: 'creation' stamp: 'PRD 11/24/2014 01:53'!
prueba2
	^ self creaPrueba2.! !

!Almacen methodsFor: 'accessors' stamp: 'PRD 11/24/2014 00:48'!
addAlmacen: anAlmacen 
	( self almacenes includes: anAlmacen ) ifFalse: [ 
		self almacenes add: anAlmacen.
		anAlmacen almacenOrigen: self.
		anAlmacen existencias do: [:each | self addExistencia: each ] ]! !

!Almacen methodsFor: 'accessors' stamp: 'PRD 11/13/2014 10:47'!
addCaja: aCaja 
	self cajas add: aCaja.
! !

!Almacen methodsFor: 'calculo' stamp: 'PRD 11/20/2014 01:16'!
addExistencia: aExistenciaItem
"
	| existencia |
	existencia :=  ( existencias at:  aExistenciaItem identificadorUnico ifAbsent: [ nil ] ).	
	existencia isNil ifTrue: [ existencia := aExistenciaItem ]
			            ifFalse: [ existencia addExistencia: aExistenciaItem ].
	existencias at: aExistenciaItem identificadorUnico put: existencia.

	self almacenOrigen ifNotNil:[ self almacenOrigen addExistencia: aExistenciaItem ].

	| i e c |
	i := aExistenciaItem identificadorUnico .
	c := aExistenciaItem cantidad.
	(e := self existencias at: i ifAbsent: [ nil ])
		ifNil: [ self existencias at: i  put: aExistenciaItem  ]
		ifNotNil: [ e addExistencia: aExistenciaItem  ]	.
"

	self addExistenciaItem: aExistenciaItem item cantidad: aExistenciaItem cantidad.! !

!Almacen methodsFor: 'calculating' stamp: 'PRD 11/20/2014 01:09'!
addExistenciaItem: anItem cantidad: anInteger 
	| ex |
	ex := existencias at: anItem identificadorUnico ifAbsent: [ nil ].
	ex ifNil: [ ex := ExistenciaItem new item: anItem ; cantidad: anInteger ; yourself . existencias at: anItem identificadorUnico put: ex ]
	     ifNotNil: [ ex addCantidad: anInteger].
	
	! !

!Almacen methodsFor: 'accessors' stamp: 'PabloDigonzelli 5/20/2014 04:37'!
almacenOrigen
	^ almacenOrigen! !

!Almacen methodsFor: 'accessors' stamp: 'PabloDigonzelli 5/20/2014 01:53'!
almacenOrigen: anAlmacen 
	almacenOrigen := anAlmacen.! !

!Almacen methodsFor: 'accessors' stamp: 'PabloDigonzelli 5/20/2014 01:50'!
almacenes
	^ almacenes! !

!Almacen methodsFor: 'accessing' stamp: 'PRD 10/1/2014 12:06'!
almacenes: anObject
	almacenes := anObject! !

!Almacen methodsFor: 'accessors' stamp: 'PRD 10/4/2014 11:15'!
almacenesEmpresa: anEmpresa
	^ anEmpresa isNil
		ifFalse: [ anEmpresa almacenes reject: [ :each | each nombre = self nombre ] ]
		ifTrue: [ OrderedCollection new ]! !

!Almacen methodsFor: 'accessing' stamp: 'PRD 10/9/2014 19:07'!
cajas
	^ cajas! !

!Almacen methodsFor: 'accessing' stamp: 'PRD 10/9/2014 19:07'!
cajas: anObject
	cajas := anObject! !

!Almacen methodsFor: 'as yet unclassified' stamp: 'PRD 11/18/2014 02:45'!
delete
	super delete.
! !

!Almacen methodsFor: 'accessors' stamp: 'PRD 11/28/2014 09:11'!
descriptionAlmacenOrigen
	<magritteDescription>
	^ MASingleOptionDescription new 
		priority: 300;
		label: 'Almacen Origen';
		accessor: #almacenOrigen;
		comment: 'Almacen Origen';
		optionsAndLabels: ( (self almacenesEmpresa: self empresa) collect: [:each | Association key: each value: each nombre ] );
		yourself! !

!Almacen methodsFor: 'as yet unclassified' stamp: 'PRD 10/9/2014 19:18'!
descriptionCajas
	<magritteDescription>
	^ MAToManyRelationDescription new
		priority: 600;
		label: 'Cajas';
		accessor: #cajas;
		classes: {Caja};
		ordered: true;
		comment: 'Caja';
		yourself	
		
! !

!Almacen methodsFor: 'accessors' stamp: 'PRD 11/28/2014 09:11'!
descriptionEmpresa
	<magritteDescription>
	^ MASingleOptionDescription new 
		priority: 100;
		label: 'Empresa';
		accessor: #empresa;
		comment: 'Empresa';
		optionsAndLabels: ( Empresa collection collect: [:each | Association key: each value: each nombre  ] );
		yourself! !

!Almacen methodsFor: 'as yet unclassified' stamp: 'PRD 9/22/2014 08:31'!
descriptionNombre
	<magritteDescription>
	^ MAStringDescription new
		accessor: #nombre;
		label: 'Nombre';
		priority: 200;
		beRequired;
		yourself! !

!Almacen methodsFor: 'as yet unclassified' stamp: 'PRD 11/28/2014 09:11'!
descriptionVirtual
	<magritteDescription>
	^ MABooleanDescription new
		priority: 200; 	
		accessor: #virtual;
		default: false;
		checkboxLabel: 'Virtual';
		trueString: 'Si';
		falseString: 'No';
		label: 'Virtual';
		yourself			
! !

!Almacen methodsFor: 'accessing' stamp: 'PRD 9/9/2014 13:53'!
empresa
	^ empresa! !

!Almacen methodsFor: 'accessing' stamp: 'PRD 4/28/2015 07:19'!
empresa: aEmpresa
	empresa := aEmpresa.	
	! !

!Almacen methodsFor: 'as yet unclassified' stamp: 'PRD 9/25/2014 04:07'!
existenciaItem: anItem
	^ self existenciaItemIdentificadorUnico: anItem identificadorUnico .
! !

!Almacen methodsFor: 'calculo' stamp: 'PRD 11/3/2014 01:03'!
existenciaItemIdentificadorUnico: anIdentificadorUnico 
	| existencia |
	existencia := existencias at: anIdentificadorUnico ifAbsent:   [ nil ].
	^ existencia isNil ifTrue: [ 0 ] ifFalse: [ existencia cantidad ].! !

!Almacen methodsFor: 'calculo' stamp: 'PabloDigonzelli 5/20/2014 03:08'!
existenciaTotal
	 ^ existencias isEmpty ifTrue: [ 0 ] ifFalse: [ existencias]! !

!Almacen methodsFor: 'accessors' stamp: 'PabloDigonzelli 5/20/2014 04:41'!
existencias
	^ existencias! !

!Almacen methodsFor: 'accessing' stamp: 'PRD 10/1/2014 12:06'!
existencias: anObject
	existencias := anObject! !

!Almacen methodsFor: 'accessing' stamp: 'PRD 4/12/2015 22:58'!
firstCaja
	self cajas isEmpty  ifTrue: [ self addCaja: Caja uno ].
	^ self cajas first! !

!Almacen methodsFor: 'accessors' stamp: 'PRD 4/12/2015 22:55'!
initialize
	super initialize.
	almacenes  := OrderedCollection new.
	cajas := OrderedCollection new. 
	nombre := ''.
	existencias := Dictionary new.
	virtual := false.
	self addCaja: Caja uno.! !

!Almacen methodsFor: 'accessors' stamp: 'PRD 10/1/2014 14:37'!
nombre
	^ nombre! !

!Almacen methodsFor: 'accessors' stamp: 'PabloDigonzelli 5/20/2014 01:26'!
nombre: aString 
	nombre := aString! !

!Almacen methodsFor: 'as yet unclassified' stamp: 'PRD 4/19/2015 13:12'!
onAboutToDelete
	self cajas yourself do: [ :caj | self removeCaja: caj ].
	^ true! !

!Almacen methodsFor: 'as yet unclassified' stamp: 'PRD 11/22/2014 00:38'!
onDeleted
	self existencias values do: [ :e | e remove ].
	self existencias keys do: [ :e | self existencias removeKey: e ifAbsent: [ ^ false ] ].
	^ true! !

!Almacen methodsFor: 'accessing' stamp: 'PRD 10/9/2014 19:17'!
puntosVenta
	| col |
	col := OrderedCollection new.
	cajas collect: [:caj | col addAll: caj puntosVenta].
	^ col! !

!Almacen methodsFor: 'accessing' stamp: 'PRD 10/1/2014 12:06'!
puntosVenta: anObject
	puntosVenta := anObject! !

!Almacen methodsFor: 'as yet unclassified' stamp: 'PRD 4/29/2015 00:17'!
removeCaja: aCaja
	aCaja ifNil: [ ^ self ].
	self cajas remove: aCaja.
	aCaja remove.! !

!Almacen methodsFor: 'as yet unclassified' stamp: 'PRD 11/17/2014 19:20'!
removeExistencia: aExistencia
	self existencias remove: aExistencia .
	aExistencia remove.! !

!Almacen methodsFor: 'as yet unclassified' stamp: 'PRD 11/19/2014 21:39'!
stockItem: anItem cantidad: aCantidad
	self
		addExistencia:
			(ExistenciaItem new
				item: anItem;
				cantidad: aCantidad)! !

!Almacen methodsFor: 'calculo' stamp: 'PabloDigonzelli 5/20/2014 01:59'!
tieneAlmacenes
	^ self almacenes isNotEmpty ! !

!Almacen methodsFor: 'accessing' stamp: 'PRD 10/1/2014 12:06'!
virtual
	^ virtual! !

!Almacen methodsFor: 'accessing' stamp: 'PRD 10/1/2014 12:06'!
virtual: anObject
	virtual := anObject! !

POSPersistentObject subclass: #AplicacionComprobante
	instanceVariableNames: 'aplicante aplicado importeAplicante saldoAplicadoAnterior saldoAplicanteAnterior'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!AplicacionComprobante class methodsFor: 'creation' stamp: 'PabloDigonzelli 6/8/2014 12:07'!
aplicante: aComprobanteVenta aplicado: aComprobanteVenta2 
	^ super new initialize ; aplicante: aComprobanteVenta ; 
							aplicado: aComprobanteVenta2 ;
							importeAplicante: aComprobanteVenta saldo;
							saldoAplicadoAnterior: aComprobanteVenta2 saldo;
							saldoAplicanteAnterior: aComprobanteVenta saldo;
							yourself! !

!AplicacionComprobante class methodsFor: 'creation' stamp: 'PabloDigonzelli 6/8/2014 12:14'!
aplicante: aComprobanteVenta aplicado: aComprobanteVenta2 importeAplicante: anImporte
	^ super new initialize ; aplicante: aComprobanteVenta ; 
							aplicado: aComprobanteVenta2 ;
							importeAplicante: anImporte;
							saldoAplicadoAnterior: aComprobanteVenta2 saldo;
							saldoAplicanteAnterior: aComprobanteVenta saldo;
							yourself! !

!AplicacionComprobante methodsFor: 'accessing' stamp: 'PabloDigonzelli 6/7/2014 19:45'!
aplicado
	^ aplicado! !

!AplicacionComprobante methodsFor: 'accessing' stamp: 'PabloDigonzelli 6/7/2014 18:55'!
aplicado: aComprobanteVenta 
	aplicado := aComprobanteVenta! !

!AplicacionComprobante methodsFor: 'accessing' stamp: 'PabloDigonzelli 6/7/2014 19:45'!
aplicante
	^ aplicante! !

!AplicacionComprobante methodsFor: 'accessing' stamp: 'PabloDigonzelli 6/7/2014 18:55'!
aplicante: aComprobanteVenta 
	aplicante := aComprobanteVenta! !

!AplicacionComprobante methodsFor: 'accessing' stamp: 'PabloDigonzelli 6/7/2014 19:36'!
importeAplicante
	^ importeAplicante! !

!AplicacionComprobante methodsFor: 'accessing' stamp: 'PabloDigonzelli 6/7/2014 19:37'!
importeAplicante: anInteger 
	importeAplicante := anInteger! !

!AplicacionComprobante methodsFor: 'accessing' stamp: 'PRD 10/4/2014 11:38'!
initialize
	super initialize! !

!AplicacionComprobante methodsFor: 'accessing' stamp: 'PabloDigonzelli 6/8/2014 12:11'!
saldoAplicadoAnterior: anImporte 
	saldoAplicadoAnterior := anImporte! !

!AplicacionComprobante methodsFor: 'accessing' stamp: 'PabloDigonzelli 6/8/2014 12:12'!
saldoAplicanteAnterior: anImporte
	saldoAplicanteAnterior := anImporte! !

!AplicacionComprobante methodsFor: 'calculos' stamp: 'PabloDigonzelli 6/7/2014 19:51'!
signoPartidaAplicante
	^ self aplicante signoPartida * self aplicado signoPartida ! !

POSPersistentObject subclass: #Caja
	instanceVariableNames: 'puntosVenta numero'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!Caja class methodsFor: 'as yet unclassified' stamp: 'PRD 11/13/2014 10:51'!
uno
	^ super new initialize numero: 1;  yourself .! !

!Caja methodsFor: 'as yet unclassified' stamp: 'PRD 11/28/2014 09:13'!
descriptionNumero
	<magritteDescription>
	^ MANumberDescription new
		label: 'Numero';
		accessor: #numero;
		comment: 'Numero';
		beRequired;
		yourself
	! !

!Caja methodsFor: 'as yet unclassified' stamp: 'PRD 10/9/2014 19:31'!
descriptionPuntosVenta
	<magritteDescription>
	^ MAToManyRelationDescription new
		priority: 600;
		label: 'PuntosVenta';
		accessor: #puntosVenta;
		classes: {PuntoVenta};
		ordered: true;
		comment: 'PuntoVenta';
		yourself	! !

!Caja methodsFor: 'as yet unclassified' stamp: 'PRD 11/13/2014 10:51'!
initialize
	super initialize.
	numero := 0.
	puntosVenta := OrderedCollection new.! !

!Caja methodsFor: 'as yet unclassified' stamp: 'PRD 1/13/2015 00:24'!
nombre
	^ 'Caja ' , self numero asString! !

!Caja methodsFor: 'accessing' stamp: 'PRD 10/9/2014 19:32'!
numero
	^ numero! !

!Caja methodsFor: 'accessing' stamp: 'PRD 10/9/2014 19:32'!
numero: anObject
	numero := anObject! !

!Caja methodsFor: 'accessing' stamp: 'PRD 10/9/2014 19:19'!
puntosVenta
	^ puntosVenta! !

!Caja methodsFor: 'accessing' stamp: 'PRD 10/9/2014 19:19'!
puntosVenta: anObject
	puntosVenta := anObject! !

POSPersistentObject subclass: #CategoriaImpositiva
	instanceVariableNames: 'descripcion abreviatura discrimina'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!CategoriaImpositiva class methodsFor: 'creation' stamp: 'PRD 12/11/2014 00:16'!
basicInitializeCollection
	self creaConsumidorFinal .
	self creaExento.
	self creaMonotributo.
	self creaResponsableInscripto .
	self creaResponsableNoInscripto .! !

!CategoriaImpositiva class methodsFor: 'creation' stamp: 'PRD 12/17/2014 01:26'!
basicInitializeCollectionInSession: aSession
	aSession beginUnitOfWork.
	aSession save:	self creaConsumidorFinal .
	aSession save: self creaExento.
	aSession save: self creaMonotributo.
	aSession save: self creaResponsableInscripto .
	aSession save: self creaResponsableNoInscripto .
	aSession commitUnitOfWork.! !

!CategoriaImpositiva class methodsFor: 'as yet unclassified' stamp: 'PRD 12/17/2014 01:24'!
creaConsumidorFinal
	^ super new initialize descripcion: 'Consumidor Final' ; abreviatura: 'CF'; discrimina: false! !

!CategoriaImpositiva class methodsFor: 'as yet unclassified' stamp: 'PRD 12/17/2014 01:24'!
creaExento
   ^ super new initialize descripcion: 'Exento' ; abreviatura: 'EXE'; discrimina: false! !

!CategoriaImpositiva class methodsFor: 'as yet unclassified' stamp: 'PRD 12/17/2014 01:24'!
creaMonotributo
	^ super new initialize descripcion: 'Monotributista' ; abreviatura: 'MONO'; discrimina: false	! !

!CategoriaImpositiva class methodsFor: 'as yet unclassified' stamp: 'PRD 12/17/2014 01:24'!
creaResponsableInscripto
	^ super new initialize descripcion: 'Responsable Inscripto' ; abreviatura: 'RI'; discrimina: true! !

!CategoriaImpositiva class methodsFor: 'as yet unclassified' stamp: 'PRD 12/17/2014 01:24'!
creaResponsableNoInscripto
   ^ super new initialize descripcion: 'Responsable No Inscripto' ; abreviatura: 'RNI'; discrimina: true	! !

!CategoriaImpositiva class methodsFor: 'accessing - properties' stamp: 'PRD 7/22/2014 21:19'!
hasUserRights
	^ false! !

!CategoriaImpositiva methodsFor: 'accessing' stamp: 'PRD 9/9/2014 17:56'!
abreviatura
	^ abreviatura! !

!CategoriaImpositiva methodsFor: 'accessing' stamp: 'PabloDigonzelli 6/15/2014 17:51'!
abreviatura: aString 
	abreviatura := aString ! !

!CategoriaImpositiva methodsFor: 'accessing' stamp: 'PRD 9/9/2014 17:56'!
descripcion
	^ descripcion! !

!CategoriaImpositiva methodsFor: 'accessing' stamp: 'PRD 9/9/2014 17:56'!
descripcion: aString 
	descripcion := aString! !

!CategoriaImpositiva methodsFor: 'accessing' stamp: 'PRD 9/9/2014 17:56'!
discrimina
	^ discrimina! !

!CategoriaImpositiva methodsFor: 'accessing' stamp: 'PabloDigonzelli 6/15/2014 17:52'!
discrimina: aBoolean
	discrimina := aBoolean! !

!CategoriaImpositiva methodsFor: 'as yet unclassified' stamp: 'PRD 10/14/2014 14:03'!
idUnico
	idUnico := self descripcion .
	^ idUnico! !

!CategoriaImpositiva methodsFor: 'as yet unclassified' stamp: 'PRD 9/17/2014 13:20'!
nombre
	^ self descripcion! !

POSPersistentObject subclass: #ClasificacionItem
	instanceVariableNames: 'abreviatura descripcion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!ClasificacionItem class methodsFor: 'as yet unclassified' stamp: 'PRD 2/24/2015 03:46'!
basicInitializeCollectionInSession: aSession

	aSession beginUnitOfWork.
	aSession rollbackUnitOfWork.
	aSession beginUnitOfWork.
	1 to: 5 do: [:c |  aSession save: ( self creaClasificacion: c) ].
	aSession commitUnitOfWork.
! !

!ClasificacionItem class methodsFor: 'as yet unclassified' stamp: 'PRD 2/19/2015 20:49'!
creaClasificacion: c
	^ super new initialize descripcion: ('Rubro ', c asString ); abreviatura: ( 'RUB ' , c asString ); yourself .! !

!ClasificacionItem methodsFor: 'accessing' stamp: 'PRD 2/19/2015 20:16'!
abreviatura
	^ abreviatura! !

!ClasificacionItem methodsFor: 'accessing' stamp: 'PRD 2/19/2015 20:16'!
abreviatura: anObject
	abreviatura := anObject! !

!ClasificacionItem methodsFor: 'accessing' stamp: 'PRD 2/19/2015 20:16'!
descripcion
	^ descripcion! !

!ClasificacionItem methodsFor: 'accessing' stamp: 'PRD 2/19/2015 20:16'!
descripcion: anObject
	descripcion := anObject! !

!ClasificacionItem methodsFor: 'as yet unclassified' stamp: 'PRD 2/19/2015 20:17'!
descriptionAbreviatura
	<magritteDescription>
	^ MAStringDescription  new 
		accessor: #abreviatura;
		label: 'Abreviatura';
		priority: 100;
		beRequired ;
		yourself! !

!ClasificacionItem methodsFor: 'as yet unclassified' stamp: 'PRD 2/19/2015 20:17'!
descriptionDescripcion
	<magritteDescription>
	^ MAStringDescription  new 
		accessor: #descripcion;
		label: 'Descripcion';
		priority: 100;
		beRequired ;
		yourself! !

!ClasificacionItem methodsFor: 'as yet unclassified' stamp: 'PRD 2/24/2015 14:09'!
nombre
	^ self descripcion! !

POSPersistentObject subclass: #CodigoBarra
	instanceVariableNames: 'item codigoBarra descripcion cantidad'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!CodigoBarra methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/14/2015 19:02'!
cantidad
	^ cantidad! !

!CodigoBarra methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/14/2015 19:02'!
cantidad: anObject
	cantidad := anObject! !

!CodigoBarra methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/14/2015 19:02'!
codigoBarra
	^ codigoBarra! !

!CodigoBarra methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/14/2015 19:02'!
codigoBarra: anObject
	codigoBarra := anObject! !

!CodigoBarra methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/14/2015 19:02'!
descripcion
	^ descripcion! !

!CodigoBarra methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/14/2015 19:02'!
descripcion: anObject
	descripcion := anObject! !

POSPersistentObject subclass: #CodigoPostal
	instanceVariableNames: 'cp'
	classVariableNames: 'Local'
	poolDictionaries: ''
	category: 'TPV-Model'!

!CodigoPostal class methodsFor: 'as yet unclassified' stamp: 'PRD 12/11/2014 10:35'!
creaLocal
	^super new initialize cp: '4000' ; yourself; save! !

!CodigoPostal methodsFor: 'accessing' stamp: 'PabloDigonzelli 6/15/2014 17:04'!
cp
	^ cp! !

!CodigoPostal methodsFor: 'accessing' stamp: 'PabloDigonzelli 6/15/2014 17:04'!
cp: aString 
	cp := aString! !

POSPersistentObject subclass: #CondicionPago
	instanceVariableNames: 'descripcion condicion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!CondicionPago class methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/14/2015 18:30'!
contado
	^ self session contado! !

!CondicionPago methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/14/2015 12:17'!
condicion
	^ condicion! !

!CondicionPago methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/14/2015 12:17'!
condicion: anObject
	condicion := anObject! !

!CondicionPago methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/14/2015 12:17'!
descripcion
	^ descripcion! !

!CondicionPago methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/14/2015 12:17'!
descripcion: anObject
	descripcion := anObject! !

POSPersistentObject subclass: #EntidadComercial
	instanceVariableNames: 'razonSocial categoriaImpositiva direccion cuit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

EntidadComercial subclass: #Cliente
	instanceVariableNames: 'factor listaPrecio generico ctacte'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!Cliente class methodsFor: 'accessing' stamp: 'PRD 2/19/2015 23:15'!
basicInitializeCollectionInSession: aPOSSession

	aPOSSession beginUnitOfWork.
	aPOSSession save: self creaConsumidorFinal.
	aPOSSession save: self creaClienteGenerico.
	aPOSSession save: self creaClienteGenericoExento.
	aPOSSession save: self creaClienteGenericoMonotributo.
	aPOSSession save: self creaClienteGenericoRI.
	aPOSSession commitUnitOfWork.
! !

!Cliente class methodsFor: 'as yet unclassified' stamp: 'PRD 4/17/2015 20:26'!
clienteConsumidorFinal
	^ self session clienteConsumidorFinal! !

!Cliente class methodsFor: 'as yet unclassified' stamp: 'PRD 2/19/2015 23:14'!
creaClienteGenerico
	| c |
	c := self creaClienteRazonSocial: 'Cliente generico' cuit: 20143532978 generico: true.
	c categoriaImpositiva: c session categoriaResponsableInscripto.
	^c 	! !

!Cliente class methodsFor: 'as yet unclassified' stamp: 'PRD 2/19/2015 23:14'!
creaClienteGenericoExento
	| c |
	c := self creaClienteRazonSocial: 'Cliente generico exento' cuit: 20143532979 generico: true.
	c categoriaImpositiva: c session categoriaExento.
	^c 	! !

!Cliente class methodsFor: 'as yet unclassified' stamp: 'PRD 2/19/2015 23:14'!
creaClienteGenericoMonotributo
	| c |
	c := self creaClienteRazonSocial: 'Cliente generico monotributo' cuit: 20143532980 generico: true.
	c categoriaImpositiva: c session categoriaMonotributo.
	^c ! !

!Cliente class methodsFor: 'as yet unclassified' stamp: 'PRD 2/19/2015 23:14'!
creaClienteGenericoRI
	| c |
	c := self creaClienteRazonSocial: 'Cliente generico RI' cuit: 20143532981 generico: true.
	c categoriaImpositiva: c session categoriaResponsableInscripto.
	^c 		! !

!Cliente class methodsFor: 'as yet unclassified' stamp: 'PRD 12/11/2014 11:26'!
creaClienteRazonSocial: aRazonSocial cuit: aCuit generico: aBoolean	
	| c |
	c :=   super new initialize
				razonSocial: aRazonSocial ;
				direccion: (DireccionCliente from: Direccion anonima); 
				cuit: aCuit;
				generico: aBoolean.
	c listaPrecio: c session listaPrecioBase.						
	^c 	! !

!Cliente class methodsFor: 'as yet unclassified' stamp: 'PRD 2/19/2015 23:15'!
creaConsumidorFinal
	| c |
	c := self creaClienteRazonSocial: 'Consumidor Final' cuit: 1111111111 generico: false.
	c categoriaImpositiva: c session categoriaConsumidorFinal.
	^c 		
! !

!Cliente methodsFor: 'accessing' stamp: 'PRD 2/19/2015 16:45'!
ctacte
	^ ctacte! !

!Cliente methodsFor: 'accessing' stamp: 'PRD 2/19/2015 16:45'!
ctacte: anObject
	ctacte := anObject! !

!Cliente methodsFor: 'accessing' stamp: 'PRD 2/19/2015 17:25'!
descriptionCtaCte
	<magritteDescription>
	^ MABooleanDescription new
		priority: 400;
		accessor: #ctacte;
		default: false;
		checkboxLabel: 'CtaCte?';
		trueString: 'Si';
		falseString: 'No';
		visibleInReport: false;
		visibleInLabel: false;
		beRequired;
		yourself
		! !

!Cliente methodsFor: 'accessing' stamp: 'PRD 11/28/2014 09:11'!
descriptionFactor
	<magritteDescription>
	^ MANumberDescription new
		label: 'Factor';
		accessor: #factor;
		comment: 'Factor';
		min: 0 max: 2;
		beRequired;
		priority: 350;
		yourself
	! !

!Cliente methodsFor: 'accessing' stamp: 'PRD 11/28/2014 09:11'!
descriptionListaPrecios
	<magritteDescription>
	^ MASingleOptionDescription   new
		label: 'Lista de Precios';
		accessor: #listaPrecio;
		comment: 'Lista de Precios';
		options: ( ListaPrecio collection);
		beRequired;
		priority: 600;
		yourself
	! !

!Cliente methodsFor: 'accessing' stamp: 'PabloRobertoDigonzelli 6/16/2014 22:48'!
factor
	^ factor! !

!Cliente methodsFor: 'accessing' stamp: 'PRD 9/18/2014 17:40'!
factor: anObject
	factor := anObject! !

!Cliente methodsFor: 'accessing' stamp: 'PRD 12/3/2014 07:09'!
generico
	^ generico! !

!Cliente methodsFor: 'accessing' stamp: 'PRD 12/3/2014 07:09'!
generico: anObject
	generico := anObject! !

!Cliente methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/5/2015 19:10'!
idUnico
	^ idUnico! !

!Cliente methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/5/2015 17:29'!
initialize
	super initialize.
	generico := false.
	ctacte := false.
	
	listaPrecio := self session readOneOf: ListaPrecio where:  [:li | li nombre = ListaPrecio nombreListaBase ].
	factor := 1.00.
! !

!Cliente methodsFor: 'accessing' stamp: 'PRD 11/5/2014 11:22'!
listaPrecio
	^ listaPrecio! !

!Cliente methodsFor: 'accessing' stamp: 'PRD 11/5/2014 11:47'!
listaPrecio: aListaPrecio 
	listaPrecio := aListaPrecio! !

!Cliente methodsFor: 'accessing' stamp: 'PRD 4/18/2015 13:25'!
sincroWith: aCliente inSession: aPOSGlorpSession
	self listaPrecio sincroWith: aCliente listaPrecio inSession: 	aPOSGlorpSession .
	self categoriaImpositiva  sincroWith: aCliente categoriaImpositiva  inSession: 	aPOSGlorpSession .
! !

EntidadComercial subclass: #Empresa
	instanceVariableNames: 'almacenes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!Empresa class methodsFor: 'as yet unclassified' stamp: 'PRD 4/28/2015 12:35'!
aboutClearCollectionInSession: aSession
	aSession clearCollection: Almacen.
! !

!Empresa class methodsFor: 'as yet unclassified' stamp: 'PRD 4/28/2015 09:29'!
basicInitializeCollectionInSession: aSession
	aSession requireUnitOfWork.
	aSession save: self creaEmpresaDemo.
	aSession save: self creaEmpresaDemo1.
	aSession commitUnitOfWork.
	! !

!Empresa class methodsFor: 'as yet unclassified' stamp: 'PRD 4/28/2015 09:17'!
creaEmpresaDemo
	| e a |
	e := self new initialize
		razonSocial: 'Demo';
		categoriaImpositiva: self session categoriaResponsableInscripto;
		cuit: 0;
		direccion: DireccionEmpresa anonima; 
		yourself.	
	a := Almacen prueba1.
	e addAlmacen: a.
	 ^ e ! !

!Empresa class methodsFor: 'as yet unclassified' stamp: 'PRD 4/28/2015 09:17'!
creaEmpresaDemo1
	^ (self new initialize
		razonSocial: 'Demo1';
		categoriaImpositiva: self session categoriaResponsableInscripto;
		cuit: 1;
		direccion: DireccionEmpresa anonima; 
		yourself) ! !

!Empresa methodsFor: 'accessing' stamp: 'PRD 4/29/2015 00:41'!
addAlmacen: anAlmacen
	((self existeAlmacen: anAlmacen) or: [ self existeAlmacenName: anAlmacen nombre ])
		ifFalse: [ 
			almacenes add: anAlmacen.
			anAlmacen empresa: self ].
	^ anAlmacen! !

!Empresa methodsFor: 'searching' stamp: 'PRD 11/24/2014 02:01'!
almacen: anAlmacen 
	^self almacenes detect: [:each | ( each = anAlmacen or: [each nombre = anAlmacen nombre] ) ]  ifNone: [ ^ nil ]! !

!Empresa methodsFor: 'searching' stamp: 'PRD 11/25/2014 14:30'!
almacenName: anAlmacenName 
	^self almacenes detect: [:each | each nombre = anAlmacenName ]  ifNone: [ ^ nil ]! !

!Empresa methodsFor: 'accessing' stamp: 'PRD 10/16/2014 14:33'!
almacenes
	^ almacenes! !

!Empresa methodsFor: 'accessing' stamp: 'PRD 1/13/2015 00:09'!
cajas 
	| o |
	o := OrderedCollection new.
	self almacenes do: [:al | al cajas do: [:caj | o add: caj ]  ].
	^ o! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'PRD 11/24/2014 01:48'!
createAlmacen: anAlmacenName
	| a |
	
	( self existeAlmacenName: anAlmacenName ) 
		ifTrue: [ Error signal: 'Ya existe un almacen con ese nombre para esta empresa'. ^ nil].
		
	a := Almacen new name: anAlmacenName .

	self addAlmacen: a.		! !

!Empresa methodsFor: 'verifing' stamp: 'PRD 11/18/2014 11:44'!
existeAlmacen: anAlmacen 
	^ self almacenes  includes: anAlmacen ! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'PRD 4/29/2015 00:41'!
existeAlmacenName: anAlmacenName
	self almacenes detect: [ :each | each nombre = anAlmacenName ] ifFound: [ ^ true ].
	^ false ! !

!Empresa methodsFor: 'accessing' stamp: 'PRD 11/24/2014 19:08'!
firstAlmacen
	self almacenes isEmpty  ifTrue: [ ^nil ].
	^ self almacenes first! !

!Empresa methodsFor: 'accessing' stamp: 'PRD 11/24/2014 19:10'!
firstCaja
	self firstAlmacen ifNil: [ ^ nil ].
	^ self firstAlmacen firstCaja.! !

!Empresa methodsFor: 'accessing' stamp: 'PRD 12/11/2014 00:08'!
initialize
	super initialize.
	almacenes := OrderedCollection new.
	categoriaImpositiva := self session categoriaResponsableInscripto  .! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'PRD 4/28/2015 12:39'!
onAboutToDelete
	self almacenes yourself do: [ :alm | self removeAlmacen: alm ].
	^ true! !

!Empresa methodsFor: 'accesing' stamp: 'PRD 10/1/2014 15:33'!
primerPuntoVenta
	^ self puntosVenta at: 1 ifAbsent: [ nil ] ! !

!Empresa methodsFor: 'accessing' stamp: 'PRD 10/1/2014 15:28'!
puntosVenta
	| o |
	o := OrderedCollection new.
	self almacenes do: [:a | o copyWithAll: a puntosVenta   ].
	^ o! !

!Empresa methodsFor: 'accessing' stamp: 'PRD 11/18/2014 02:53'!
removeAlmacen: anAlmacen
	self almacenes remove: anAlmacen .
	anAlmacen remove.! !

!Empresa methodsFor: 'creation' stamp: 'PRD 11/18/2014 12:28'!
removeAlmacenes
	self almacenes copy do: [:a | self removeAlmacen: a].! !

!EntidadComercial methodsFor: 'as yet unclassified' stamp: 'PRD 10/16/2014 00:42'!
= anEntidad
	 ( self species = anEntidad  species)  ifFalse: [ ^false ].
	^  ( self cuit = anEntidad cuit )! !

!EntidadComercial methodsFor: 'accessing' stamp: 'PRD 9/16/2014 11:22'!
categoriaImpositiva
	^ categoriaImpositiva! !

!EntidadComercial methodsFor: 'accessing' stamp: 'PRD 9/16/2014 11:22'!
categoriaImpositiva: anObject
	categoriaImpositiva := anObject! !

!EntidadComercial methodsFor: 'accessing' stamp: 'PRD 10/27/2014 23:10'!
cuit
	cuit isNil ifTrue: [ cuit := 0].
	^ cuit! !

!EntidadComercial methodsFor: 'accessing' stamp: 'PRD 9/16/2014 11:28'!
cuit: anObject
	cuit := anObject ! !

!EntidadComercial methodsFor: 'accessing' stamp: 'PRD 12/11/2014 00:07'!
descriptionCategoriaImpositiva
	<magritteDescription>
	^ (MASingleOptionDescription new )
		accessor: #categoriaImpositiva ;
		label: 'Categoria Impositiva';
		priority: 300;
		options: ( self session collection: CategoriaImpositiva);
		optionsAndLabels: (( self session collection: CategoriaImpositiva ) collect: [:each | Association key: each value: each descripcion ] );
		default: (self session categoriaResponsableInscripto);
		yourself .
! !

!EntidadComercial methodsFor: 'as yet unclassified' stamp: 'PRD 11/28/2014 09:11'!
descriptionCuit
	<magritteDescription>
	^ MANumberDescription new 
		label: 'CUIT';
		accessor: #cuit;
		comment: 'Cuit';
		addCondition: [:c | c asString size = 11  ] labelled: 'Tiene que ingresar los 11 números sin otros caracteres' ;
		beRequired ;
		priority: 200;
		yourself! !

!EntidadComercial methodsFor: 'accessing' stamp: 'PRD 9/18/2014 23:57'!
descriptionDireccion
	<magritteDescription>
	^ MAToOneRelationDescription new 
		accessor: #direccion;
		label: 'Direccion';
		priority: 400;
		classes: { Direccion};
		beRequired ;
		yourself! !

!EntidadComercial methodsFor: 'accessing' stamp: 'PRD 9/19/2014 00:21'!
descriptionNombre
	<magritteDescription>
	^ MAStringDescription  new 
		accessor: #nombre;
		label: 'Nombre';
		priority: 100;
		beRequired ;
		yourself! !

!EntidadComercial methodsFor: 'accessing' stamp: 'PRD 9/16/2014 11:30'!
direccion
	^ direccion! !

!EntidadComercial methodsFor: 'accessing' stamp: 'PRD 9/16/2014 11:30'!
direccion: anObject
	direccion := anObject! !

!EntidadComercial methodsFor: 'as yet unclassified' stamp: 'PRD 9/18/2014 17:37'!
discrimina
	^ self categoriaImpositiva discrimina! !

!EntidadComercial methodsFor: 'as yet unclassified' stamp: 'PRD 10/16/2014 00:41'!
hash
	^ self cuit hash! !

!EntidadComercial methodsFor: 'as yet unclassified' stamp: 'PRD 10/27/2014 23:18'!
idUnico
	idUnico := cuit asString .
	^ idUnico! !

!EntidadComercial methodsFor: 'as yet unclassified' stamp: 'PRD 10/16/2014 20:34'!
initialize
	super initialize.
	direccion  := Direccion initializeAnonima .
"	categoriaImpositiva := CategoriaImpositiva consumidorFinal ."! !

!EntidadComercial methodsFor: 'accessing' stamp: 'PRD 9/16/2014 12:00'!
nombre
	^ self razonSocial.! !

!EntidadComercial methodsFor: 'accessing' stamp: 'PRD 9/16/2014 12:00'!
nombre: anObject
	self razonSocial: anObject! !

!EntidadComercial methodsFor: 'accessing' stamp: 'PRD 9/16/2014 11:23'!
razonSocial
	^ razonSocial! !

!EntidadComercial methodsFor: 'accessing' stamp: 'PRD 9/16/2014 11:23'!
razonSocial: aString 
	razonSocial := aString! !

POSPersistentObject subclass: #ExistenciaItem
	instanceVariableNames: 'item cantidad'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!ExistenciaItem class methodsFor: 'creation' stamp: 'PabloDigonzelli 5/20/2014 02:21'!
item: anItem cantidad: aCantidad 
	^ self new initialize item: anItem ; cantidad: aCantidad ; yourself! !

!ExistenciaItem methodsFor: 'accessor' stamp: 'PabloDigonzelli 5/20/2014 03:54'!
Item
	^ item! !

!ExistenciaItem methodsFor: 'calculo' stamp: 'PabloDigonzelli 5/20/2014 02:35'!
addCantidad: aCantidad
	self cantidad: self cantidad + aCantidad! !

!ExistenciaItem methodsFor: 'calculo' stamp: 'PRD 10/15/2014 18:33'!
addExistencia: aExistencia
	self cantidad: self cantidad + aExistencia cantidad! !

!ExistenciaItem methodsFor: 'calcula' stamp: 'PRD 11/2/2014 17:29'!
afecta: anAlmacen 
	anAlmacen addExistencia: self.
	anAlmacen save.! !

!ExistenciaItem methodsFor: 'accessors' stamp: 'PabloDigonzelli 5/20/2014 02:35'!
cantidad
	^ cantidad! !

!ExistenciaItem methodsFor: 'accessors' stamp: 'PabloDigonzelli 5/20/2014 02:23'!
cantidad: aCantidad
	cantidad := aCantidad! !

!ExistenciaItem methodsFor: 'calculating' stamp: 'PRD 9/24/2014 14:30'!
contraExistencia
	^ self deepCopy cantidad: (-1 * self cantidad)! !

!ExistenciaItem methodsFor: 'accesors' stamp: 'PabloDigonzelli 5/20/2014 03:55'!
identificadorUnico
	^ self item identificadorUnico ! !

!ExistenciaItem methodsFor: 'accessors' stamp: 'PabloDigonzelli 5/20/2014 03:09'!
item
	^ item! !

!ExistenciaItem methodsFor: 'accessors' stamp: 'PabloDigonzelli 5/20/2014 02:22'!
item: anItem 
	item := anItem! !

!ExistenciaItem methodsFor: 'calculo' stamp: 'PabloDigonzelli 5/20/2014 02:49'!
substractCantidad: aCantidad
	self cantidad: self cantidad - aCantidad! !

POSPersistentObject subclass: #ImpuestoComprobante
	instanceVariableNames: 'impuesto valor comprobante'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!ImpuestoComprobante class methodsFor: 'creation' stamp: 'PRD 10/4/2014 03:02'!
impuesto: anImpuesto valor: aNumber 
	^ super new impuesto: anImpuesto ; valor: aNumber asImporte ; yourself.! !

!ImpuestoComprobante methodsFor: 'accessing' stamp: 'PRD 10/3/2014 21:15'!
comprobante: aComprobanteVenta 
	comprobante := aComprobanteVenta! !

!ImpuestoComprobante methodsFor: 'accessing' stamp: 'PRD 10/3/2014 21:14'!
impuesto
	^ impuesto! !

!ImpuestoComprobante methodsFor: 'accessing' stamp: 'PRD 10/3/2014 21:13'!
impuesto: anImpuesto 
	impuesto := anImpuesto! !

!ImpuestoComprobante methodsFor: 'accessing' stamp: 'PRD 10/3/2014 21:14'!
valor
	^ valor! !

!ImpuestoComprobante methodsFor: 'accessing' stamp: 'PRD 10/3/2014 21:13'!
valor: aNumber 
	valor := aNumber! !

POSPersistentObject subclass: #Item
	instanceVariableNames: 'codigo descripcion descripcionTicket venta precioMinorista clasificacion impuestos codigoBarra marca'
	classVariableNames: 'Database'
	poolDictionaries: ''
	category: 'TPV-Model'!

!Item class methodsFor: 'as yet unclassified' stamp: 'PRD 4/21/2015 21:10'!
codigo: aCodigo 
	| cont i  gen |
	cont := aCodigo.
	gen := Random seed: 112629.

	i := super new initialize
		codigo: cont;
		descripcion: 'Articulo Nro ' , cont asString;
		descripcionTicket: 'art nro ' , cont asString;
		codigoBarra: cont asString;
		precio: gen next * 100; yourself.
		
	^ i! !

!Item class methodsFor: 'as yet unclassified' stamp: 'PRD 2/19/2015 21:18'!
codigo: aCodigo clasificacion: aClasificacion
	^ (self codigo: aCodigo) clasificacion: aClasificacion ;yourself.
! !

!Item class methodsFor: 'as yet unclassified' stamp: 'PRD 2/28/2015 11:55'!
codigo: aCodigo clasificacion: aClasificacion marca: aMarca
	^ (self codigo: aCodigo) clasificacion: aClasificacion ; marca: aMarca ;yourself.
! !

!Item class methodsFor: 'creation' stamp: 'PabloDigonzelli 5/12/2015 00:21'!
codigo: aCodigo precio: aDecimal
	^ (self codigo: aCodigo) precio: aDecimal  ; yourself! !

!Item class methodsFor: 'calculo' stamp: 'PabloDigonzelli 5/10/2014 12:12'!
dummy
	 ^ self new descripcion: 'DUMMY' ; precio: 0 ; yourself! !

!Item class methodsFor: 'calculo' stamp: 'PRD 12/20/2014 06:44'!
ejemplo1
	|i|
	
	
	i := ( self session readManyOf: self limit:1  ) first.
	^ i! !

!Item class methodsFor: 'calculo' stamp: 'PabloDigonzelli 5/12/2015 00:22'!
ejemplo2
	|i|
	i := self new codigo: '200000' ; descripcion: 'EJEMPLO #2' ; precio: 20 ; yourself.
	i addImpuesto: ( Impuesto iva porcentaje: 21 ).
	^ i! !

!Item class methodsFor: 'calculo' stamp: 'PabloDigonzelli 5/12/2015 00:22'!
ejemplo3
	|i|
	i := self new codigo: '3' ; descripcion: 'EJEMPLO #3' ; precio: 20 ; yourself.
	i addImpuesto: ( Impuesto iva porcentaje: 10.5 ).
	^ i! !

!Item class methodsFor: 'accesors' stamp: 'PRD 12/19/2014 13:45'!
fromIdentificadorUnico: anIdentificadorUnico
	
	^ self fromIdentificadorUnico: anIdentificadorUnico inSession: self session.! !

!Item class methodsFor: 'accesors' stamp: 'PRD 12/20/2014 06:09'!
fromIdentificadorUnico: anIdentificadorUnico inSession: aSession
	
	^ self session findOneOf:self where: [:each | each idUnico =  anIdentificadorUnico ] ifNone: [nil].
! !

!Item class methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/12/2015 00:19'!
generaItemParaDemo: aCantidadItems

	| col clasificaciones c  kmax k marcas m |
	
	col := OrderedCollection new.
	clasificaciones := self session collection: ClasificacionItem .
	marcas := self session collection: MarcaItem .
	
	kmax := clasificaciones size.
	k := 1.
	1 to: aCantidadItems  do: [ :cont | 
		| i |
		
		k := k + 1.
		k > kmax ifTrue: [ k := 1 ].										
		c := clasificaciones at: k .
		m := marcas at: k.
		
		i := self codigo: cont asString clasificacion: c marca: m.
		col add: i .													 
																
	].

	^ col 
	
! !

!Item class methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/12/2015 00:19'!
generaItemParaDemo: aCantidadItems session: aSession

	| col clasificaciones c  kmax k marcas m iva21 |
	
	col := OrderedCollection new.
	clasificaciones := aSession collection: ClasificacionItem .
	marcas := aSession collection: MarcaItem .
	iva21 := aSession findOneOf: Impuesto where: [:i | i idUnico =   'IVA 21|21.00' ] ifNone: [ aSession save: Impuesto creaIva21]. 

	kmax := clasificaciones size.
	k := 1.
	1 to: aCantidadItems  do: [ :cont | 
		| i |
		
		k := k + 1.
		k > kmax ifTrue: [ k := 1 ].										
		c := clasificaciones at: k .
		m := marcas at: k.
		
		i := self codigo: cont asString clasificacion: c marca: m.
		i impuestos: OrderedCollection new.
		i addImpuesto: iva21.
		
		col add: i .													 
																
	].

	^ col 
	
! !

!Item class methodsFor: 'numeracion' stamp: 'PabloDigonzelli 5/12/2015 00:22'!
generaItemParaDemo: aCantidadItems ultimoNro: aNro

	| col  |
	col := OrderedCollection new.	
	
	( aNro + 1 ) to: ( aNro + 1 + aCantidadItems)  do: [ :cont | 
		| i n|
		n := aNro + cont.		
		i := self codigo: cont asString.
		col add: i.												
	 ].
	^ col! !

!Item methodsFor: 'accessors' stamp: 'PRD 10/15/2014 13:43'!
addImpuesto: anImpuesto 

	anImpuesto valido ifTrue: [ self impuestos add: anImpuesto].
	! !

!Item methodsFor: 'accessors' stamp: 'PabloDigonzelli 5/9/2014 14:59'!
clasificacion
	^ clasificacion! !

!Item methodsFor: 'accessors' stamp: 'PRD 2/19/2015 21:17'!
clasificacion: anObject
	clasificacion := anObject! !

!Item methodsFor: 'accessors' stamp: 'PabloDigonzelli 5/9/2014 13:03'!
codigo
	^ codigo! !

!Item methodsFor: 'accessors' stamp: 'PabloDigonzelli 5/12/2015 00:25'!
codigo: aCodigo
	codigo := aCodigo isNumber
		ifTrue: [ aCodigo greaseString ]
		ifFalse: [ aCodigo ]! !

!Item methodsFor: 'accessing' stamp: 'PRD 8/7/2014 13:01'!
codigoBarra
	^ codigoBarra! !

!Item methodsFor: 'accessing' stamp: 'PRD 12/9/2014 19:29'!
codigoBarra: anObject
	codigoBarra := anObject 
	! !

!Item methodsFor: 'accessors' stamp: 'PRD 8/7/2014 12:53'!
descripcion
	^ descripcion isNil ifTrue: ['Articulo ' ,  self codigo asString  ]  ifFalse: [ descripcion ] 
! !

!Item methodsFor: 'accessors' stamp: 'PRD 2/11/2015 15:18'!
descripcion: aString 
	descripcion := aString! !

!Item methodsFor: 'accessing' stamp: 'PRD 7/24/2014 20:14'!
descripcionTicket
	^ descripcionTicket! !

!Item methodsFor: 'accessing' stamp: 'PRD 7/24/2014 20:14'!
descripcionTicket: anObject
	descripcionTicket := anObject! !

!Item methodsFor: 'accessors' stamp: 'PRD 2/24/2015 14:09'!
descriptionClasificacion
	<magritteDescription>
	^ MASingleOptionDescription  new
		priority: 60;
		label: 'Clasificación';
		accessor: #clasificacion;
		optionsAndLabels: ( self session clasificacionesItem collect: [:each | Association key: each value: each descripcion]);
		comment: 'Clasificacion del Item';
		beRequired;
		visibleInReport: true;
		yourself
		
! !

!Item methodsFor: 'accessors' stamp: 'PRD 11/28/2014 09:13'!
descriptionCodigo
	<magritteDescription>
	^ MANumberDescription new
		priority: 40;
		label: 'Código';
		accessor: #codigo;
		beRequired;
		beInteger;
		addCondition: [ :value | value > 0 ] labelled: 'Codigo debe ser positivo';
		yourself! !

!Item methodsFor: 'accessors' stamp: 'PRD 2/4/2015 10:40'!
descriptionCodigoBarra
	<magritteDescription>
	^ MAStringDescription new
		priority: 40;
		label: 'Código Barra';
		accessor: #codigoBarra;
		beRequired;
		addCondition: [ :value | value size > 0 ] labelled: 'Debe ingresar un código';
		yourself! !

!Item methodsFor: 'accessing' stamp: 'PRD 9/19/2014 02:06'!
descriptionDescripcion
	<magritteDescription>
	^ MAMemoDescription new
		accessor: #descripcion;
		label: 'Descripcion';
		priority: 200;
		beRequired ;
		yourself! !

!Item methodsFor: 'accessing' stamp: 'PRD 7/25/2014 23:21'!
descriptionDescripcionTicket
	<magritteDescription>
	^ MAStringDescription new
		accessor: #descripcionTicket;
		label: 'Descripcion Ticket';
		priority: 400;
		beRequired;
		yourself! !

!Item methodsFor: 'accessors' stamp: 'PRD 2/24/2015 14:08'!
descriptionImpuestos
	<magritteDescription>
	^ MAMultipleOptionDescription new
		priority: 60;
		label: 'Impuestos';
		accessor: #impuestos;
		ordered: true;
		comment: 'Impuestos';
		optionsAndLabels: (( self session collection: Impuesto ) collect: [:each | Association key: each  value: each nombre  ])  ;
		visibleInLabel: false;
		visibleInReport: false;
		beRequired;
		yourself
		
! !

!Item methodsFor: 'accessors' stamp: 'PRD 2/27/2015 13:24'!
descriptionMarcaItem
	<magritteDescription>
	^ MASingleOptionDescription  new
		priority: 40;
		label: 'Marca';
		accessor: #marca;
		comment: 'Marca del ítem';
		beRequired;
		optionsAndLabels: ( (self session collection: MarcaItem) collect: [:each | Association key: each value: each nombre ] );
		yourself
		

! !

!Item methodsFor: 'accessors' stamp: 'PRD 4/15/2015 10:25'!
descriptionPrecio
	<magritteDescription>	
	^ MANumberDescription new
		priority: 140;
		label: 'Precio';
		accessor: #precioMinorista;
		comment: 'Precio';
		visibleInLabel: false;
		visibleInReport: false;
		yourself! !

!Item methodsFor: 'as yet unclassified' stamp: 'PRD 11/3/2014 00:30'!
idUnico
	idUnico := self codigo asString.
	^ idUnico! !

!Item methodsFor: 'accessors' stamp: 'PRD 11/3/2014 00:42'!
identificadorUnico
	^ self idUnico! !

!Item methodsFor: 'calculos' stamp: 'PabloDigonzelli 5/14/2014 01:36'!
igualA: anItem
	
	^ anItem class == self class and: [  self identificadorUnico = anItem identificadorUnico  ]! !

!Item methodsFor: 'calculos' stamp: 'PabloDigonzelli 6/9/2014 15:25'!
importeTotalImpuestos
	 ^ self importesImpuestos inject: 0 into: [ :sum :each | sum + each ] ! !

!Item methodsFor: 'calculo' stamp: 'PabloDigonzelli 6/9/2014 15:24'!
importesImpuestos
	^ self impuestos collect: [:eachImpuesto | eachImpuesto valorImpuestoSobre: self precio  ]! !

!Item methodsFor: 'accessing' stamp: 'PRD 10/3/2014 22:15'!
impuestos
	^ impuestos! !

!Item methodsFor: 'accessing' stamp: 'PRD 10/6/2014 01:47'!
impuestos: aCollection 
	impuestos := aCollection! !

!Item methodsFor: 'calculo' stamp: 'PRD 10/3/2014 17:58'!
impuestosVenta
	^ self impuestos select: [:impu | impu esVenta  ]! !

!Item methodsFor: 'initialization' stamp: 'PabloDigonzelli 5/12/2015 18:57'!
initialize
	super initialize.
	self codigo: '0'.
	self venta: true.
	impuestos := OrderedCollection new.
"	self addImpuesto: self session impuestoIva21."
	precioMinorista := 0.00.! !

!Item methodsFor: 'accessing' stamp: 'PRD 2/27/2015 12:37'!
marca
	^ marca! !

!Item methodsFor: 'accessing' stamp: 'PRD 2/27/2015 12:37'!
marca: anObject
	marca := anObject! !

!Item methodsFor: 'as yet unclassified' stamp: 'PRD 9/19/2014 02:07'!
nombre
	^ self descripcionTicket! !

!Item methodsFor: 'accessors' stamp: 'PRD 4/17/2015 19:08'!
precio
	^ self precioMinorista! !

!Item methodsFor: 'calculos' stamp: 'PRD 4/15/2015 10:23'!
precio: aPrecio
	self precioMinorista: aPrecio asImporte! !

!Item methodsFor: 'calculo' stamp: 'PabloDigonzelli 5/13/2014 01:19'!
precioConImpuestos
	^ self precio + (self impuestosVenta inject: 0 into: [:sum :each |  sum + ( each valorImpuestoSobre: self precio)  ]) .! !

!Item methodsFor: 'calculos' stamp: 'PRD 4/17/2015 19:06'!
precioLista
	self precioMinorista isEmpty  ifFalse: [ ^ self precioMinorista ] ifTrue: [  ^ self precioPorDefecto  ]! !

!Item methodsFor: 'accessors' stamp: 'PRD 4/15/2015 10:23'!
precioMinorista
	^ precioMinorista! !

!Item methodsFor: 'accessors' stamp: 'PRD 4/21/2015 21:01'!
precioMinorista: aPrecio
	precioMinorista := aPrecio! !

!Item methodsFor: 'calculos' stamp: 'PabloDigonzelli 5/9/2014 14:23'!
precioPorDefecto
	^ 0.00! !

!Item methodsFor: 'accessors' stamp: 'PabloDigonzelli 5/10/2014 11:31'!
preciosMinorista
	^ preciosMinorista! !

!Item methodsFor: 'accessors' stamp: 'PRD 4/15/2015 10:05'!
preciosMinorista: aOrderedCollection
	preciosMinorista := aOrderedCollection! !

!Item methodsFor: 'glorp' stamp: 'PabloDigonzelli 5/14/2015 23:00'!
removeImpuesto: anImpuesto 
	self impuestos remove: anImpuesto.! !

!Item methodsFor: 'as yet unclassified' stamp: 'PRD 4/15/2015 04:36'!
sincroWith: anItem
	self sincroWith: anItem inSession: self session
! !

!Item methodsFor: 'as yet unclassified' stamp: 'PRD 4/18/2015 15:17'!
sincroWith: anItem inSession: aPOSGlorpSession

! !

!Item methodsFor: 'as yet unclassified' stamp: 'PRD 2/10/2015 13:56'!
validateAdd
	^ codigo < 9000  ! !

!Item methodsFor: 'as yet unclassified' stamp: 'PRD 2/10/2015 15:55'!
validateEdit
	^ codigo < 9000  ! !

!Item methodsFor: 'calculos' stamp: 'PRD 11/8/2014 11:47'!
vendible
	^  self venta! !

!Item methodsFor: 'accessors' stamp: 'PabloDigonzelli 5/9/2014 13:43'!
venta
	^ venta! !

!Item methodsFor: 'accessors' stamp: 'PabloDigonzelli 5/9/2014 13:44'!
venta: aBoolean
	venta := aBoolean! !

POSPersistentObject subclass: #ItemListaPrecio
	instanceVariableNames: 'listaPrecio precio item'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!ItemListaPrecio class methodsFor: 'creating' stamp: 'PRD 10/12/2014 15:34'!
listaPrecio: aListaPrecio item: anItem precio: aPrecio
	^ super new initialize listaPrecio: aListaPrecio ; item: anItem ; precio: aPrecio  ; yourself ! !

!ItemListaPrecio class methodsFor: 'creating' stamp: 'PRD 9/14/2014 23:37'!
listaPrecio: aListaPrecio precio: aPrecio
	^ super new initialize listaPrecio: aListaPrecio ; precio: aPrecio  ; yourself ! !

!ItemListaPrecio methodsFor: 'as yet unclassified' stamp: 'PRD 4/23/2015 14:44'!
descripcionItem
	^ 'Item: ' , self item descripcion , ' . Precio: ' , self precio printAsImporte ! !

!ItemListaPrecio methodsFor: 'accessing' stamp: 'PRD 2/23/2015 20:57'!
descriptionItem
	<magritteDescription>
	^MAStringDescription new 
		priority: 50;
		label: 'Item';
		accessor: #descripcionItem;
		beReadonly;
		visibleInLabel: true;
		visibleInReport: true;
		beRequired;
		yourself! !

!ItemListaPrecio methodsFor: 'as yet unclassified' stamp: 'PRD 2/23/2015 01:46'!
descriptionPrecio
	<magritteDescription>
	^MANumberDescription new 
		label: 'Precio';
		accessor: #valor;
		beRequired;
		yourself! !

!ItemListaPrecio methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/6/2015 17:04'!
idUnico 
	^ idUnico! !

!ItemListaPrecio methodsFor: 'accessing' stamp: 'PRD 10/12/2014 15:21'!
item
	^ item ! !

!ItemListaPrecio methodsFor: 'accessing' stamp: 'PRD 10/12/2014 15:21'!
item: anObject
	item := anObject! !

!ItemListaPrecio methodsFor: 'accessing' stamp: 'PRD 9/14/2014 22:20'!
listaPrecio
	^ listaPrecio! !

!ItemListaPrecio methodsFor: 'accessing' stamp: 'PRD 9/14/2014 22:20'!
listaPrecio: anObject
	listaPrecio := anObject! !

!ItemListaPrecio methodsFor: 'as yet unclassified' stamp: 'PRD 10/2/2014 03:40'!
nombre
	^ 'Item: ' , self descripcionItem , ' -  Precio: ' , self valor asString. ! !

!ItemListaPrecio methodsFor: 'as yet unclassified' stamp: 'PRD 10/12/2014 14:51'!
precio
	^ precio! !

!ItemListaPrecio methodsFor: 'as yet unclassified' stamp: 'PRD 4/15/2015 05:07'!
precio: aPrecio 
	precio := aPrecio asImporte.
	ultimaModificacion := DateAndTime now.! !

!ItemListaPrecio methodsFor: 'as yet unclassified' stamp: 'PRD 4/15/2015 07:14'!
sincroWith: anItem inSession: aPOSGlorpSession
	| c l |
	c := aPOSGlorpSession  readOneOf: Item where: [:each | each pid = anItem item pid ].
	l := aPOSGlorpSession  readOneOf: ListaPrecio where: [:each | each pid = anItem listaPrecio pid].
	self item: c.
	self version: anItem version.
	self precio: anItem precio.
! !

!ItemListaPrecio methodsFor: 'accessing' stamp: 'PRD 10/12/2014 15:19'!
valor
	^ self precio! !

!ItemListaPrecio methodsFor: 'accessing' stamp: 'PRD 10/12/2014 15:19'!
valor: aValor
	self precio: aValor asImporte
! !

POSPersistentObject subclass: #ItemMovimientoStock
	instanceVariableNames: 'movimiento item cantidad unidad'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!ItemMovimientoStock methodsFor: 'accessing' stamp: 'PRD 9/23/2014 23:23'!
cantidad
	^ cantidad! !

!ItemMovimientoStock methodsFor: 'accessing' stamp: 'PRD 9/23/2014 23:23'!
cantidad: anObject
	cantidad := anObject! !

!ItemMovimientoStock methodsFor: 'accessing' stamp: 'PRD 9/23/2014 23:23'!
item
	^ item! !

!ItemMovimientoStock methodsFor: 'accessing' stamp: 'PRD 9/23/2014 23:23'!
item: anObject
	item := anObject! !

!ItemMovimientoStock methodsFor: 'accessing' stamp: 'PRD 9/23/2014 23:23'!
movimiento
	^ movimiento! !

!ItemMovimientoStock methodsFor: 'accessing' stamp: 'PRD 9/23/2014 23:23'!
movimiento: anObject
	movimiento := anObject! !

!ItemMovimientoStock methodsFor: 'accessing' stamp: 'PRD 9/23/2014 23:23'!
unidad
	^ unidad! !

!ItemMovimientoStock methodsFor: 'accessing' stamp: 'PRD 9/23/2014 23:23'!
unidad: anObject
	unidad := anObject! !

POSPersistentObject subclass: #ItemVenta
	instanceVariableNames: 'item cantidad precioUnitario descuento comprobante impuestos neto total'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!ItemVenta class methodsFor: 'as yet unclassified' stamp: 'PRD 10/16/2014 21:47'!
ejemploBrowser
	"comment stating purpose of message"

	| m result toolbar l  items lista c   |


	
	Item initializeCollection .
	MedioPago initializeCollection .
	
	Item generaItemParaDemo: 100.

	c := ComprobanteVenta ejemplo2.	

	items := OrderedCollection new.
	lista := ListaPrecio new.
	
	lista items
		associationsDo: [ :itemLista | c addItem: (ItemVenta new item: (Item fromIdentificadorUnico: itemLista key) cantidad: 10) ].
	
	c cliente: Cliente anonimo.	

	m := DynamicComposableModel new.
	m instantiateModels: #(listModel MultiColumnListModel ).
	m listModel displayBlock: [ :it | { it item descripcion. it item codigo asString. it cantidad asString. it precioUnitarioTotal asString. it importeTotal asString}  ].
	toolbar :=  OkToolbar new
				okAction: [ result := m listModel selectedItem. ];
				yourself.				

	l := ( SpecLayout composed
				newRow: #listModel top: ( StandardFonts defaultFont height + 12 ) ;
				yourself	).				
							

	m listModel items: c items.

	(m openDialogWithSpecLayout: l)
	toolbar: toolbar;
	centered;
	modalRelativeTo: World.
						! !

!ItemVenta class methodsFor: 'calculos' stamp: 'PRD 6/25/2014 21:01'!
importeNetoItems: anInteger 
	self shouldBeImplemented.! !

!ItemVenta methodsFor: 'as yet unclassified' stamp: 'PRD 3/10/2015 02:26'!
calculaImportesItem
	neto := self importeNeto.
	impuestos := ( self calculaImpuestos inject: 0 into: [:sum :each | sum + each valor]).
	total := neto + impuestos.! !

!ItemVenta methodsFor: 'calculating' stamp: 'PRD 3/10/2015 02:38'!
calculaImpuestos
	^self item impuestosVenta collect:  [:i | ImpuestoComprobante impuesto: i valor: ( self neto  * i porcentaje / 100  + i fijo) asImporte ].
! !

!ItemVenta methodsFor: 'accessors' stamp: 'PabloDigonzelli 5/10/2014 12:05'!
cantidad
	^ cantidad! !

!ItemVenta methodsFor: 'accessors' stamp: 'PRD 3/10/2015 01:48'!
cantidad: aCantidad
	cantidad := aCantidad.
	self calculaImportesItem.! !

!ItemVenta methodsFor: 'as yet unclassified' stamp: 'PRD 2/25/2015 14:06'!
clasificacionItem
	self item notNil ifTrue: [ ^ self item clasificacion abreviatura ]! !

!ItemVenta methodsFor: 'accessing' stamp: 'PabloRobertoDigonzelli 6/17/2014 22:29'!
comprobante
	^ comprobante! !

!ItemVenta methodsFor: 'accessing' stamp: 'PRD 3/9/2015 21:59'!
comprobante: aComprobanteVenta
	comprobante := aComprobanteVenta .! !

!ItemVenta methodsFor: 'as yet unclassified' stamp: 'PRD 9/28/2014 12:46'!
descripcionItem
	self item notNil ifTrue: [ ^ self item descripcion ]! !

!ItemVenta methodsFor: 'as yet unclassified' stamp: 'PRD 9/28/2014 12:47'!
descripcionTicketItem
	self item notNil ifTrue: [ ^ self item descripcionTicket ]! !

!ItemVenta methodsFor: 'as yet unclassified' stamp: 'PRD 8/7/2014 17:38'!
descriptionItem
	<magritteDescription>
	
	^ MAStringDescription new 
		label: 'Prod';
		accessor: #descripcionItem;
		beReadonly ;
		yourself ! !

!ItemVenta methodsFor: 'accessing' stamp: 'PabloRobertoDigonzelli 6/17/2014 00:49'!
descuento
	^ descuento! !

!ItemVenta methodsFor: 'accessing' stamp: 'PRD 3/10/2015 01:48'!
descuento: anObject
	descuento := anObject.
	self calculaImportesItem.	! !

!ItemVenta methodsFor: 'calculo' stamp: 'PRD 6/23/2014 20:08'!
displayForBrowser
	^ self item descripcion ! !

!ItemVenta methodsFor: 'calculo' stamp: 'PabloDigonzelli 5/10/2014 12:01'!
esValido
	 ^ self item isNil ifTrue: [ false]  ifFalse:[ self item vendible] ! !

!ItemVenta methodsFor: 'as yet unclassified' stamp: 'PRD 9/28/2014 12:45'!
identificadorUnicoItem
	self item notNil ifTrue: [ ^ self item identificadorUnico ]! !

!ItemVenta methodsFor: 'as yet unclassified' stamp: 'PRD 2/28/2015 17:05'!
importeDescuento
	 ^ (( self cantidad * self precioUnitario )  - self importeNeto ) asImporte .
! !

!ItemVenta methodsFor: 'calculo' stamp: 'PRD 3/5/2015 03:22'!
importeNeto
	 ^ ( self cantidad * self precioUnitario  * ( 1 - (self descuento / 100) )  ) asImporte.! !

!ItemVenta methodsFor: 'calculo' stamp: 'PRD 3/10/2015 02:05'!
importeTotal
	^ self neto + self impuestos
"	 ^ ( self cantidad * self precioUnitarioTotal * (1 - ( self descuento / 100  ) )  ) asImporte ."
! !

!ItemVenta methodsFor: 'accessing' stamp: 'PRD 3/10/2015 03:19'!
impuestos
	impuestos ifNil: [ impuestos :=    self calculaImpuestos inject: 0 into: [:sum :each | sum + each valor] ].
	^ impuestos! !

!ItemVenta methodsFor: 'accessing' stamp: 'PRD 3/10/2015 01:57'!
impuestos: anObject
	impuestos := anObject! !

!ItemVenta methodsFor: 'initialization' stamp: 'PRD 3/9/2015 22:01'!
initialize
	 super initialize.
	cantidad := 0.
	descuento := 0.00.
	precioUnitario := 0.00.! !

!ItemVenta methodsFor: 'accessors' stamp: 'PabloDigonzelli 5/10/2014 12:16'!
item
	^ item! !

!ItemVenta methodsFor: 'accessors' stamp: 'PabloDigonzelli 5/23/2014 01:33'!
item: anItem 
	( anItem yourself )  vendible ifTrue: [ item := anItem ]! !

!ItemVenta methodsFor: 'calculo' stamp: 'PabloDigonzelli 5/13/2014 00:22'!
item: anItem cantidad: aCantidad
	self item: anItem ; cantidad: aCantidad! !

!ItemVenta methodsFor: 'calculo' stamp: 'PabloDigonzelli 5/10/2014 11:38'!
itemValido: anItem 
	^ anItem vendible ! !

!ItemVenta methodsFor: 'calculo' stamp: 'PRD 11/28/2014 08:29'!
listaPrecio
		
	^ self comprobante ifNil: [nil ] ifNotNil:  [self comprobante  listaPrecio] ! !

!ItemVenta methodsFor: 'as yet unclassified' stamp: 'PRD 2/27/2015 13:28'!
marcaItem
	self item notNil ifTrue: [ ^ self item marca abreviatura ]! !

!ItemVenta methodsFor: 'accessing' stamp: 'PRD 3/10/2015 03:12'!
neto
	neto ifNil: [ neto := self importeNeto ].
	^ neto! !

!ItemVenta methodsFor: 'accessing' stamp: 'PRD 3/10/2015 03:35'!
neto: anObject
	neto := anObject asImporte! !

!ItemVenta methodsFor: 'calculo' stamp: 'PabloDigonzelli 5/14/2014 00:33'!
precioItem
	^ item notNil ifTrue: [ self item precio]  ifFalse: [ 0]! !

!ItemVenta methodsFor: 'calculo' stamp: 'PRD 3/9/2015 22:01'!
precioUnitario
"	self listaPrecio notNil
		ifTrue: [ 
			precioUnitario := self listaPrecio precioParaItem: item.
			precioUnitario = 0
				ifTrue: [ precioUnitario := self precioItem ] ]
		ifFalse: [ precioUnitario := self precioItem ]."
	^ precioUnitario! !

!ItemVenta methodsFor: 'accesors' stamp: 'PRD 3/10/2015 03:35'!
precioUnitario: aPrecio
	precioUnitario := aPrecio asImporte. 
	self calculaImportesItem.! !

!ItemVenta methodsFor: 'calculo' stamp: 'PabloDigonzelli 5/14/2014 22:19'!
precioUnitarioConImpuestos

	^ self precioUnitario
		+ (self item impuestosVenta inject: 0 into: [ :sum :each | sum + (each valorImpuestoSobre: self precioUnitario) ])! !

!ItemVenta methodsFor: 'calculo' stamp: 'PRD 6/25/2014 19:23'!
precioUnitarioTotal

	^ self precioUnitario
		+ (self item impuestosVenta inject: 0 into: [ :sum :each | sum + (each valorImpuestoSobre: self precioUnitario) ])! !

!ItemVenta methodsFor: 'accessors' stamp: 'PabloDigonzelli 5/15/2014 22:25'!
setItem: anItem
	anItem vendible
		ifFalse: [ ^ self ].
	item := anItem.
! !

!ItemVenta methodsFor: 'calculo' stamp: 'PabloRobertoDigonzelli 6/17/2014 22:02'!
signoPartida
	^ self comprobante notNil ifTrue: [ self comprobante signoPartida ] ifFalse: [ 1]! !

!ItemVenta methodsFor: 'as yet unclassified' stamp: 'PRD 9/28/2014 12:24'!
subtotalItem
	^ self importeTotal! !

!ItemVenta methodsFor: 'as yet unclassified' stamp: 'PRD 9/28/2014 12:50'!
subtotalNetoItem
	^ self importeNeto! !

!ItemVenta methodsFor: 'accessing' stamp: 'PRD 3/10/2015 03:21'!
total
	total ifNil: [ total := self neto + self impuestos ].
	^ total! !

!ItemVenta methodsFor: 'accessing' stamp: 'PRD 3/10/2015 03:35'!
total: anObject
	total := anObject asImporte! !

!ItemVenta methodsFor: 'calculo' stamp: 'PabloDigonzelli 6/7/2014 18:37'!
vendible
	^  self item notNil and:  [ self importeNeto  > 0 ] ! !

POSPersistentObject subclass: #LibroDiarioVenta
	instanceVariableNames: 'periodo abierto comprobantes anio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!LibroDiarioVenta methodsFor: 'accessors' stamp: 'PabloDigonzelli 5/15/2014 22:50'!
abierto
	^ abierto.! !

!LibroDiarioVenta methodsFor: 'accessing' stamp: 'PRD 12/21/2014 23:04'!
abierto: anObject
	abierto := anObject! !

!LibroDiarioVenta methodsFor: 'calculo' stamp: 'PRD 12/21/2014 22:43'!
addComprobante: aComprobanteVenta 
	self abierto ifFalse: [ ^Error new signal: 'Diario cerrado. No puede ingresar comprobante'].
	self comprobantes detect: [ :c | c nro = aComprobanteVenta nro] ifNone: [self comprobantes add: aComprobanteVenta].
! !

!LibroDiarioVenta methodsFor: 'accessing' stamp: 'PRD 12/21/2014 23:04'!
anio
	^ anio! !

!LibroDiarioVenta methodsFor: 'accessing' stamp: 'PRD 12/21/2014 23:04'!
anio: anObject
	anio := anObject! !

!LibroDiarioVenta methodsFor: 'as yet unclassified' stamp: 'PRD 12/22/2014 00:12'!
cierraComprobantes
	self shouldBeImplemented.! !

!LibroDiarioVenta methodsFor: 'calculating' stamp: 'PRD 12/22/2014 00:13'!
cierraLibro
	self abierto: false.! !

!LibroDiarioVenta methodsFor: 'calculo' stamp: 'PabloDigonzelli 5/15/2014 23:16'!
cierre
	abierto := false.! !

!LibroDiarioVenta methodsFor: 'accessors' stamp: 'PabloDigonzelli 5/15/2014 23:19'!
comprobantes
	^ comprobantes.! !

!LibroDiarioVenta methodsFor: 'accessing' stamp: 'PRD 12/21/2014 23:04'!
comprobantes: anObject
	comprobantes := anObject! !

!LibroDiarioVenta methodsFor: 'accessors' stamp: 'PRD 10/4/2014 11:25'!
comprobantesDesdeFecha: aFechaDesde hastaFecha: aFechaHasta
	^ self comprobantes select: [ :each | each fecha between: aFechaDesde and: aFechaHasta ]! !

!LibroDiarioVenta methodsFor: 'as yet unclassified' stamp: 'PRD 12/21/2014 23:21'!
comprobantesPeriodo
	^ self comprobantesPeriodoInSession: self session.! !

!LibroDiarioVenta methodsFor: 'glorp' stamp: 'PRD 12/21/2014 23:38'!
comprobantesPeriodoInSession: aPOSSession 
	|fechInicio fechFin |
	
	fechInicio 	:= Date year: self anio month: self periodo  day: 01.
	fechFin 		:= Date year: fechInicio onNextMonth year month: fechInicio onNextMonth monthIndex day: 01.
	
	^ aPOSSession readManyOf: ComprobanteVenta where: [:c | c estado = #vigente AND: [ c fecha >= fechInicio ] AND:  [ c fecha < fechFin ] ].! !

!LibroDiarioVenta methodsFor: 'calculo' stamp: 'PabloDigonzelli 5/16/2014 01:03'!
cuentaComprobantes
	
	^ self comprobantes size! !

!LibroDiarioVenta methodsFor: 'as yet unclassified' stamp: 'PRD 12/21/2014 23:23'!
generaComprobantes 
	self comprobantesPeriodo do: [:c | self addComprobante: c  ].
	! !

!LibroDiarioVenta methodsFor: 'accessors' stamp: 'PRD 12/21/2014 23:48'!
initialize
	super initialize.
	
	anio :=  Date today year.
	periodo := Date today monthIndex.
	abierto := true.
	comprobantes := OrderedCollection new.
"	comprobantes := SortedCollection sortBlock: [:a :b | ( a fecha <= b fecha ) or: [a fecha = b fecha and: [a nro < b nro] ]] ."! !

!LibroDiarioVenta methodsFor: 'accessing' stamp: 'PRD 12/21/2014 22:54'!
periodo
	^ periodo! !

!LibroDiarioVenta methodsFor: 'accessing' stamp: 'PRD 12/22/2014 00:10'!
periodo: aMonth 
	periodo := aMonth! !

!LibroDiarioVenta methodsFor: 'accessing' stamp: 'PRD 12/22/2014 00:11'!
remueveComprobantes
	self abierto ifTrue: [ 	self comprobantes removeAll. ]! !

POSPersistentObject subclass: #ListaPrecio
	instanceVariableNames: 'nombre vencimiento tipo habilitada itemsLista'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!ListaPrecio class methodsFor: 'as yet unclassified' stamp: 'PRD 12/11/2014 19:44'!
aboutClearCollectionInSession: aSession
	aSession clearCollections: ({  ItemListaPrecio.} asOrderedCollection ).
! !

!ListaPrecio class methodsFor: 'as yet unclassified' stamp: 'PRD 12/17/2014 01:19'!
basicInitializeCollectionInSession:aSession
	self creaListaBaseInSession: aSession.! !

!ListaPrecio class methodsFor: 'calculos' stamp: 'PRD 10/12/2014 15:19'!
clonar: aListaPrecio 

	| l  |

	l := super new initialize.
	l nombre: ( aListaPrecio nombre , ' clonada' ).
	 aListaPrecio itemsLista do: [:i | l addItem:  i item precio: i precio]  .
	^ l	
! !

!ListaPrecio class methodsFor: 'as yet unclassified' stamp: 'PRD 12/11/2014 11:11'!
creaListaBase
	| l i  |
	l := super new initialize.
	i := 0.
	l nombre: self nombreListaBase.
	Item collection
		do: [ :item | 
			i := i + 1.
			l addItem: item precio: 1 ].
	^ l! !

!ListaPrecio class methodsFor: 'as yet unclassified' stamp: 'PRD 2/19/2015 23:12'!
creaListaBaseInSession: aSession
	| l i  gen |
	
	gen := Random seed: 112629.
	l := super new initialize.
	i := 0.
	l nombre: self nombreListaBase.
	Item collection
		do: [ :item | 
			i := i + 1.
			l addItem: item precio: gen next * 100 ].
	aSession saveAndCommit: l.
	^ l
													 ! !

!ListaPrecio class methodsFor: 'calculos' stamp: 'PRD 9/10/2014 14:24'!
defaultName
	^ 'Lista '! !

!ListaPrecio class methodsFor: 'as yet unclassified' stamp: 'PRD 4/17/2015 20:20'!
listaFromBaseNombre: aNombre factor: aFactor
	^ self session listaFromBaseNombre: aNombre factor: aFactor.
	! !

!ListaPrecio class methodsFor: 'as yet unclassified' stamp: 'PRD 4/17/2015 20:32'!
listaPrecioBase
	^ self session listaPrecioBase
! !

!ListaPrecio class methodsFor: 'as yet unclassified' stamp: 'PRD 4/17/2015 20:20'!
listaPrecioDoble
	^ self session listaPrecioDoble.
	! !

!ListaPrecio class methodsFor: 'as yet unclassified' stamp: 'PRD 9/10/2014 13:22'!
nombreListaBase
	^ 'Lista Base'! !

!ListaPrecio class methodsFor: 'calculo' stamp: 'PabloDigonzelli 5/13/2014 20:59'!
plazoPorDefecto
	^ 30! !

!ListaPrecio class methodsFor: 'calculo' stamp: 'PabloDigonzelli 5/13/2014 21:00'!
tipos
	 ^#(#minorista #mayorista)! !

!ListaPrecio methodsFor: 'accessors' stamp: 'PRD 2/23/2015 19:00'!
addItem: anItem precio: aImporte
	| i |
	
	i :=  self findItembyItem: anItem.
	i isNil ifTrue: [ i := ( ItemListaPrecio listaPrecio: self item: anItem precio: aImporte ) . itemsLista add: i . i ].
	^ i
! !

!ListaPrecio methodsFor: 'as yet unclassified' stamp: 'PRD 4/23/2015 16:16'!
containerActions: aContainer
	<magritteContainer>
	aContainer tbsInlineValidationMessages: true.
"	aContainer customButtons: ( Array with: #prueba -> 'Prueba' )."
	^ aContainer
		
	! !

!ListaPrecio methodsFor: 'as yet unclassified' stamp: 'PRD 9/11/2014 01:08'!
ddmmyyyy
	^ self vencimiento ddmmyyyy! !

!ListaPrecio methodsFor: 'accessing' stamp: 'PRD 11/28/2014 09:12'!
descriptionHabilitada
	<magritteDescription>
	^ MABooleanDescription new
		priority: 200; 	
		accessor: #habilitada;
		default: true;
		checkboxLabel: 'Habilitada';
		trueString: 'Si';
		falseString: 'No';
		label: 'Habiltada';
		yourself! !

!ListaPrecio methodsFor: 'as yet unclassified' stamp: 'PRD 4/27/2015 18:55'!
descriptionItemsLista
	<magritteDescription>
	^ MAToManyRelationDescription new 
		priority: 300;
		label: 'Items';
		sorted: true;
		accessor: #itemsLista;
		classes: { ItemListaPrecio };
		display: [:each| each descripcionItem   ];
		beDetail;
		removeMethod: #removeItem:;
		yourself
		
! !

!ListaPrecio methodsFor: 'accessing' stamp: 'PRD 11/28/2014 09:11'!
descriptionNombre
	<magritteDescription>
	^ MAMemoDescription new 
		comment: 'Denominación de la lista de precios';
		beRequired ;
		priority: 100;
		accessor: #nombre;
		label: 'Denominacion';
		default: self class defaultName ;
		lineCount: 5;
		yourself
		
! !

!ListaPrecio methodsFor: 'accessors' stamp: 'PRD 9/12/2014 11:13'!
descriptionVencimiento
	<magritteDescription>
	^ MADateDescription new
		priority: 200;
		beRequired ;
		label: 'Vencimiento';
		accessor: #vencimiento;
		default: ( Date today + 30 ) ;
		display: [:d | d ddmmyyyy ];
"		componentClass: POSMAJQDateInputComponent ; "
		comment: 'Fecha de vencimiento de la lista de precios';
		yourself! !

!ListaPrecio methodsFor: 'as yet unclassified' stamp: 'PRD 4/9/2015 10:37'!
findItembyItem: anItem
	^ self session findOneOf: ItemListaPrecio where: [:each | each item = anItem AND: [ each listaPrecio = self ]  ] ifNone: [ nil ] 
! !

!ListaPrecio methodsFor: 'accessing' stamp: 'PRD 9/12/2014 09:36'!
habilitada
	^ habilitada! !

!ListaPrecio methodsFor: 'accessing' stamp: 'PRD 9/12/2014 09:36'!
habilitada: anObject
	habilitada := anObject! !

!ListaPrecio methodsFor: 'initialization' stamp: 'PRD 10/12/2014 11:08'!
initialize
	super initialize .
	self vencimiento: ( Date today + self class  plazoPorDefecto ).
	self tipo: self class tipos first.
	self habilitada: true.
	self itemsLista: OrderedCollection new.
! !

!ListaPrecio methodsFor: 'accessing' stamp: 'PRD 9/15/2014 18:06'!
itemsLista
	^ itemsLista! !

!ListaPrecio methodsFor: 'accessing' stamp: 'PRD 9/15/2014 21:38'!
itemsLista: anObject
	itemsLista := anObject! !

!ListaPrecio methodsFor: 'calculos' stamp: 'PRD 10/12/2014 14:43'!
multiplicarPor: aFactor
	self itemsLista do: [:each | each precio: (each valor * aFactor) ].! !

!ListaPrecio methodsFor: 'accessing' stamp: 'PRD 9/10/2014 12:42'!
nombre
	^ nombre! !

!ListaPrecio methodsFor: 'accessing' stamp: 'PRD 9/10/2014 12:42'!
nombre: anObject
	nombre := anObject! !

!ListaPrecio methodsFor: 'as yet unclassified' stamp: 'PRD 2/23/2015 18:39'!
onAboutToDelete
	
	| col  it|
	[ col := self itemsLista copy. col do: [:each | it := each .self removeItem: each ]] on: Error do: [:err |  ^ false].
	^ super onAboutToDelete! !

!ListaPrecio methodsFor: 'calculo' stamp: 'PRD 12/17/2014 04:06'!
precioParaItem: anItem 
	| it |
	it :=  self findItembyItem: anItem .
	it isNil ifFalse: [ ^ it precio ] ifTrue: [ ^0 ]! !

!ListaPrecio methodsFor: 'as yet unclassified' stamp: 'PRD 9/14/2014 21:38'!
prueba
! !

!ListaPrecio methodsFor: 'as yet unclassified' stamp: 'PRD 4/27/2015 19:15'!
removeItem: anItem
	^ [ 
	self itemsLista remove: anItem.
	self session remove: anItem.
	true ]
		ifCurtailed: [ ^ false ]! !

!ListaPrecio methodsFor: 'as yet unclassified' stamp: 'PRD 4/15/2015 07:03'!
sincroWith: anItem inSession: aPOSGlorpSession
	| c  j |

	self itemsLista: OrderedCollection new.
	anItem itemsLista do: [:i | 
		c := aPOSGlorpSession  readOneOf: Item where: [:each | each pid = i item pid ].
		j := (self addItem: c precio: i precio ).
		j pid: i pid.
		aPOSGlorpSession refresh: j].	! !

!ListaPrecio methodsFor: 'calculos' stamp: 'PRD 10/12/2014 15:01'!
sumaPrecios
	^ self itemsLista inject: 0 into: [:sum :each | sum + each valor] ! !

!ListaPrecio methodsFor: 'accessors' stamp: 'PabloDigonzelli 5/13/2014 21:23'!
tipo
	^ tipo ! !

!ListaPrecio methodsFor: 'accessors' stamp: 'PabloDigonzelli 5/13/2014 21:23'!
tipo: aTipo
	tipo := aTipo! !

!ListaPrecio methodsFor: 'calculos' stamp: 'PRD 6/26/2014 00:05'!
triplicada
	| l |
	l := self class clonar: self.
	^ ( l multiplicarPor: 3 )! !

!ListaPrecio methodsFor: 'accessors' stamp: 'PRD 9/11/2014 20:00'!
vencimiento
	^ vencimiento isNil ifTrue: [ vencimiento := ( Date today +self class plazoPorDefecto) ] ifFalse: [vencimiento].! !

!ListaPrecio methodsFor: 'accessors' stamp: 'PabloDigonzelli 5/13/2014 21:19'!
vencimiento: aDate 
	vencimiento := aDate! !

POSPersistentObject subclass: #MarcaItem
	instanceVariableNames: 'abreviatura descripcion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!MarcaItem class methodsFor: 'as yet unclassified' stamp: 'PRD 4/28/2015 12:29'!
basicInitializeCollectionInSession: aSession

	aSession requireUnitOfWork.
	aSession rollbackUnitOfWork.
	aSession beginUnitOfWork.
	1 to: 5 do: [:c | aSession save: ( self creaMarca: c) ].
	aSession commitUnitOfWork.
! !

!MarcaItem class methodsFor: 'as yet unclassified' stamp: 'PRD 2/28/2015 11:45'!
creaMarca: c
	^ super new initialize descripcion: ('Marca ', c asString ); abreviatura: ( 'MARC ' , c asString ); yourself .! !

!MarcaItem methodsFor: 'accessing' stamp: 'PRD 2/27/2015 12:39'!
abreviatura
	^ abreviatura! !

!MarcaItem methodsFor: 'accessing' stamp: 'PRD 2/27/2015 12:39'!
abreviatura: anObject
	abreviatura := anObject! !

!MarcaItem methodsFor: 'accessing' stamp: 'PRD 2/27/2015 12:39'!
descripcion
	^ descripcion! !

!MarcaItem methodsFor: 'accessing' stamp: 'PRD 2/27/2015 12:39'!
descripcion: anObject
	descripcion := anObject! !

!MarcaItem methodsFor: 'as yet unclassified' stamp: 'PRD 2/27/2015 12:40'!
descriptionAbreviatura
	<magritteDescription>
	^ MAStringDescription new 
		label: 'Abreviatura';
		comment: 'Abreviatura';
		priority: 200;
		accessor: #abreviatura;
		yourself! !

!MarcaItem methodsFor: 'as yet unclassified' stamp: 'PRD 2/27/2015 12:40'!
descriptionDescripcion
	<magritteDescription>
	^ MAStringDescription new 
		label: 'Descripcion';
		accessor: #descripcion;
		comment: 'Descripcion';
		priority: 100;
		yourself! !

!MarcaItem methodsFor: 'as yet unclassified' stamp: 'PRD 2/27/2015 12:41'!
nombre
	^ self abreviatura ! !

POSPersistentObject subclass: #MedioPago
	instanceVariableNames: 'submedios medio descripcion abreviatura vuelto otrosDatos codigo seRinde'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!MedioPago class methodsFor: 'as yet unclassified' stamp: 'PRD 12/17/2014 01:32'!
basicInitializeCollectionInSession: aSession
	aSession beginUnitOfWork.
	aSession save: self creaEfectivo.
	aSession save: self creaCtaCte.
	aSession save: self creaTarjetaCredito .
	aSession commitUnitOfWork.
	! !

!MedioPago class methodsFor: 'as yet unclassified' stamp: 'PRD 3/3/2015 19:00'!
creaCtaCte
	^ super new
		initialize;
		descripcion: 'CTACTE';
		abreviatura: 'CTACTE';
		seRinde: false;
		yourself! !

!MedioPago class methodsFor: 'as yet unclassified' stamp: 'PRD 2/20/2015 02:13'!
creaEfectivo
	^ super new initialize ; 
			  descripcion: 'EFECTIVO' ; 
			  abreviatura: 'EFECTIVO'; 
			  vuelto: true; yourself! !

!MedioPago class methodsFor: 'as yet unclassified' stamp: 'PRD 2/20/2015 02:14'!
creaTarjetaCredito
	^ super new
		initialize;
		descripcion: 'TARJETA CREDITO';
		abreviatura: 'T.CREDITO';
		otrosDatos: true;
		yourself! !

!MedioPago class methodsFor: 'as yet unclassified' stamp: 'PRD 4/17/2015 23:04'!
ctaCte
	^ self session medioPagoCtaCte 
	! !

!MedioPago class methodsFor: 'as yet unclassified' stamp: 'PRD 4/17/2015 22:40'!
efectivo
	^ self session medioPagoEfectivo 
	! !

!MedioPago class methodsFor: 'as yet unclassified' stamp: 'PRD 4/17/2015 23:04'!
tarjetaCredito
	^ self session medioPagoTarjetaCredito 
	! !

!MedioPago methodsFor: 'accessing' stamp: 'PRD 9/19/2014 00:57'!
abreviatura
	^ abreviatura! !

!MedioPago methodsFor: 'accessing' stamp: 'PabloDigonzelli 6/6/2014 15:00'!
abreviatura: aString 
	abreviatura := aString.! !

!MedioPago methodsFor: 'adding elements' stamp: 'PRD 10/15/2014 16:01'!
addSubmedio: aMedioPago
	(self submedios includes: aMedioPago)
		ifTrue: [ ^ self ].
	self submedios add: aMedioPago.
! !

!MedioPago methodsFor: 'accessing' stamp: 'PRD 10/9/2014 12:21'!
codigo
	^ codigo! !

!MedioPago methodsFor: 'accessing' stamp: 'PRD 10/9/2014 12:24'!
codigo: anInteger 
	codigo := anInteger! !

!MedioPago methodsFor: 'accessing' stamp: 'PabloDigonzelli 6/15/2014 14:30'!
descripcion
	^ descripcion! !

!MedioPago methodsFor: 'accessing' stamp: 'PabloDigonzelli 6/6/2014 14:43'!
descripcion: aString 
	descripcion := aString! !

!MedioPago methodsFor: 'accessing' stamp: 'PRD 11/28/2014 09:12'!
descriptionAbreviatura
	<magritteDescription>
	^ MAStringDescription new 
		label: 'Abreviatura';
		comment: 'Abreviatura';
		priority: 200;
		accessor: #abreviatura;
		yourself! !

!MedioPago methodsFor: 'accessing' stamp: 'PRD 11/28/2014 09:12'!
descriptionDescripcion
	<magritteDescription>
	^ MAStringDescription new 
		label: 'Descripcion';
		accessor: #descripcion;
		comment: 'Descripcion';
		priority: 100;
		yourself! !

!MedioPago methodsFor: 'as yet unclassified' stamp: 'PRD 11/28/2014 09:12'!
descriptionOtrosDatos
	<magritteDescription>
	^ MABooleanDescription new 
		label: 'Otros datos';
		comment: 'Exige otros datos';
		priority: 300;
		accessor: #otrosDatos;
		trueString: 'Exige otros datos';
		falseString: 'No exige otros datos';
		yourself! !

!MedioPago methodsFor: 'as yet unclassified' stamp: 'PRD 3/3/2015 19:00'!
descriptionSeRinde
	<magritteDescription>
	^ MABooleanDescription new 
		label: 'Se rinde?';
		comment: 'Define si se rinde o no';
		priority: 300;
		accessor: #seRinde;
		trueString: 'Se rinde';
		falseString: 'No se rinde';
		yourself! !

!MedioPago methodsFor: 'accessing' stamp: 'PRD 11/28/2014 09:12'!
descriptionSubmedios
	<magritteDescription>
	^ MAToManyRelationDescription  new 
		label: 'submedios';
		accessor: #submedios;
		comment: 'Sub medios';
		priority: 300;
		classes: { MedioPago };
		yourself! !

!MedioPago methodsFor: 'as yet unclassified' stamp: 'PRD 11/28/2014 09:12'!
descriptionVuelto
	<magritteDescription>
	^ MABooleanDescription new 
		label: 'Vuelto';
		comment: 'Entrega vuelto';
		priority: 300;
		accessor: #vuelto;
		trueString: 'Entrega vuelto';
		falseString: 'No entrega vuelto';
		yourself! !

!MedioPago methodsFor: 'as yet unclassified' stamp: 'PRD 10/9/2014 12:53'!
getCodigo
	| c |
	^ ( c := self collection sorted: [:a :b | a codigo <= b codigo  ] )  size = 0 ifTrue: [1] ifFalse: [c last codigo + 1]! !

!MedioPago methodsFor: 'as yet unclassified' stamp: 'PRD 10/15/2014 16:24'!
idUnico
	idUnico := self descripcion.
	^ idUnico! !

!MedioPago methodsFor: 'as yet unclassified' stamp: 'PRD 3/3/2015 18:59'!
initialize
	super initialize.
	vuelto := false.
	otrosDatos := false.
	seRinde := true.
	codigo := '0'.! !

!MedioPago methodsFor: 'accessing' stamp: 'PRD 3/3/2015 18:57'!
medio
	^ medio! !

!MedioPago methodsFor: 'accessing' stamp: 'PRD 3/3/2015 18:57'!
medio: anObject
	medio := anObject! !

!MedioPago methodsFor: 'as yet unclassified' stamp: 'PRD 10/4/2014 13:23'!
nombre
	^ medio notNil ifTrue:  [  medio nombre , self descripcion ] ifFalse: [ self descripcion  ]! !

!MedioPago methodsFor: 'accessing' stamp: 'PRD 10/4/2014 19:12'!
otrosDatos
	^ otrosDatos! !

!MedioPago methodsFor: 'accessing' stamp: 'PRD 10/4/2014 21:42'!
otrosDatos: anObject
	otrosDatos := anObject! !

!MedioPago methodsFor: 'accessing' stamp: 'PabloDigonzelli 6/6/2014 18:51'!
removeSubmedio: aMedioPago 
	self submedios remove: aMedioPago .! !

!MedioPago methodsFor: 'accessing' stamp: 'PRD 3/3/2015 18:57'!
seRinde
	^ seRinde! !

!MedioPago methodsFor: 'accessing' stamp: 'PRD 3/3/2015 18:57'!
seRinde: anObject
	seRinde := anObject! !

!MedioPago methodsFor: 'accessing' stamp: 'PabloDigonzelli 6/6/2014 17:15'!
submedios
	submedios isNil ifTrue: [submedios := OrderedCollection new ].
	^ submedios! !

!MedioPago methodsFor: 'accessing' stamp: 'PRD 9/19/2014 00:57'!
submedios: anObject
	submedios := anObject! !

!MedioPago methodsFor: 'accessing' stamp: 'PRD 10/4/2014 16:57'!
vuelto
	^ vuelto! !

!MedioPago methodsFor: 'accessing' stamp: 'PRD 10/4/2014 16:58'!
vuelto: aTrue 
	vuelto := aTrue! !

POSPersistentObject subclass: #MovimientoCaja
	instanceVariableNames: 'fecha importe tipo medioPago caja rendicion manual'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!MovimientoCaja class methodsFor: 'creation' stamp: 'PRD 12/21/2014 12:25'!
egresoVentaMedioPago: aMedioPago fecha: aFecha caja: aCaja importe: aImporte 
	^ self egresoVentaMedioPago: aMedioPago fecha: aFecha caja: aCaja importe: aImporte inSession: self session
! !

!MovimientoCaja class methodsFor: 'as yet unclassified' stamp: 'PRD 12/21/2014 12:24'!
egresoVentaMedioPago: aMedioPago fecha: aFecha caja: aCaja importe: aImporte inSession: aSession
	| mov egr |

	egr := aSession egresoPorVenta.

	mov := (self sinRendirInSession: aSession )
		detect: [ :each | 
			( each tipo = egr )
				and: [ each medioPago = aMedioPago and: [ each fecha  = aFecha and: [ each caja = aCaja ] ] ] ]
		ifNone: [ nil ].
		
	mov isNil
		ifTrue: [ 
			mov := super new initialize
				medioPago: aMedioPago;
				tipo: egr;
				fecha: aFecha;
				caja: aCaja;
				importe: 0;
				yourself ].
	mov addImporte: aImporte.
	^ aSession save: mov! !

!MovimientoCaja class methodsFor: 'as yet unclassified' stamp: 'PRD 1/22/2015 00:10'!
egresosCajaSinRendirInSession: aSession
	^ ( self sinRendirInSession: aSession  ) select: [ :each | each tipo esEgreso = true ]! !

!MovimientoCaja class methodsFor: 'as yet unclassified' stamp: 'PRD 4/17/2015 22:33'!
fromComprobanteVenta: aComprobanteVenta
		| m |
	aComprobanteVenta partida = aComprobanteVenta session partidaDebe 	
		ifTrue:   [ aComprobanteVenta pagos do: [:p | m:= MovimientoCaja egresoVentaMedioPago: p medioPago 
																		fecha: aComprobanteVenta fecha 
																		caja: aComprobanteVenta caja 
																		importe: p importe]] 
		ifFalse:  [ aComprobanteVenta pagos do: [:p | m:= MovimientoCaja ingresoVentaMedioPago: p medioPago 
																		fecha: aComprobanteVenta fecha 
																		caja: aComprobanteVenta caja 
																		importe: p importe ]].
		^ m save! !

!MovimientoCaja class methodsFor: 'as yet unclassified' stamp: 'PRD 12/21/2014 12:28'!
fromComprobanteVenta: aComprobanteVenta inSession: aSession
		| m |
	aComprobanteVenta partida = aSession partidaDebe 	
		ifTrue:   [ aComprobanteVenta pagos do: [:p | m:= MovimientoCaja egresoVentaMedioPago: p medioPago 
																		fecha: aComprobanteVenta fecha 
																		caja: aComprobanteVenta caja 
																		importe: p importe 
																		inSession: aSession ]] 
		ifFalse:  [ aComprobanteVenta pagos do: [:p | m:= MovimientoCaja ingresoVentaMedioPago: p medioPago 
																		fecha: aComprobanteVenta fecha 
																		caja: aComprobanteVenta caja 
																		importe: p importe 
																		inSession: aSession ]].
		^ aSession save: m! !

!MovimientoCaja class methodsFor: 'as yet unclassified' stamp: 'PRD 4/17/2015 22:37'!
ingresoVentaMedioPago: aMedioPago fecha: aFecha caja: aCaja
	^ self ingresoVentaMedioPago: aMedioPago fecha: aFecha caja: aCaja inSession: self session! !

!MovimientoCaja class methodsFor: 'creation' stamp: 'PRD 4/17/2015 22:51'!
ingresoVentaMedioPago: aMedioPago fecha: aFecha caja: aCaja importe: aImporte 
	^ self ingresoVentaMedioPago: aMedioPago fecha: aFecha caja: aCaja importe: aImporte inSession: self session! !

!MovimientoCaja class methodsFor: 'creation' stamp: 'PRD 12/19/2014 14:04'!
ingresoVentaMedioPago: aMedioPago fecha: aFecha caja: aCaja importe: aImporte inSession: aSession
	| mov ing |

	ing := aSession ingresoPorVenta.

	mov := (self sinRendirInSession: aSession )
		detect: [ :each | 
			( each tipo = ing )
				and: [ each medioPago = aMedioPago and: [ each fecha  = aFecha and: [ each caja = aCaja ] ] ] ]
		ifNone: [ nil ].
		
	mov isNil
		ifTrue: [ 
			mov := super new initialize
				medioPago: aMedioPago;
				tipo: ing;
				fecha: aFecha;
				caja: aCaja;
				importe: 0;
				yourself ].

	mov addImporte: aImporte.
	^ aSession save: mov! !

!MovimientoCaja class methodsFor: 'as yet unclassified' stamp: 'PRD 12/19/2014 14:01'!
ingresoVentaMedioPago: aMedioPago fecha: aFecha caja: aCaja inSession: aSession
	| mov ing |

	ing := aSession ingresoPorVenta.
	
	mov := ( self sinRendirInSession: aSession )
		detect: [ :each | 
			( each tipo = ing )
				and: [ each medioPago = aMedioPago and: [ each fecha asDateAndTime  = aFecha asDateAndTime  and: [ each caja = aCaja ] ] ] ]
		ifNone: [ nil ].
		
	mov isNil
		ifTrue: [ 
			mov := super new initialize
				medioPago: aMedioPago;
				tipo: ing;
				fecha: aFecha;
				caja: aCaja;
				importe: 0;
				yourself ].

	^ aSession save: mov! !

!MovimientoCaja class methodsFor: 'as yet unclassified' stamp: 'PRD 1/22/2015 00:10'!
ingresosCajaSinRendirInSession: aSession
	^ ( self sinRendirInSession: aSession  ) select: [ :each | each tipo esIngreso = true ]! !

!MovimientoCaja class methodsFor: 'creation' stamp: 'PRD 12/19/2014 14:09'!
medioPago: aMedioPago 
	| m |
	m := (self sinRendirInSession: aMedioPago session ) detect: [:each | each medioPago = aMedioPago ] ifNone: [nil]. 
	m isNil ifTrue: [  m :=  ( super new initialize medioPago: aMedioPago  ; yourself ) ].
	^ m ! !

!MovimientoCaja class methodsFor: 'collection' stamp: 'PRD 12/19/2014 13:55'!
sinRendir
	^ self sinRendirInSession: self session! !

!MovimientoCaja class methodsFor: 'collection' stamp: 'PRD 12/19/2014 13:55'!
sinRendirInSession: aSession
	^ aSession readManyOf: self where: [:each | each rendicion = false   ]! !

!MovimientoCaja class methodsFor: 'as yet unclassified' stamp: 'PRD 12/16/2014 03:39'!
tipo: aTipo fecha: aFecha medioPago: aMedioPago caja: aCaja
	^ super 	new initialize
			  	medioPago: aMedioPago;
			  	tipo: aTipo;
			   fecha: aFecha;
				caja: aCaja;
				importe: 0;
				yourself .
! !

!MovimientoCaja methodsFor: 'calculating' stamp: 'PRD 11/24/2014 22:51'!
addImporte: aImporte 
	importe := importe + aImporte! !

!MovimientoCaja methodsFor: 'accessing' stamp: 'PRD 10/9/2014 16:23'!
caja
	^ caja! !

!MovimientoCaja methodsFor: 'accessing' stamp: 'PRD 10/10/2014 00:37'!
caja: anInteger 
	caja := anInteger! !

!MovimientoCaja methodsFor: 'as yet unclassified' stamp: 'PRD 1/7/2015 13:55'!
ddmmyyyy
	^ self fecha ddmmyyyy! !

!MovimientoCaja methodsFor: 'as yet unclassified' stamp: 'PRD 3/18/2015 02:21'!
ddmmyyyy:aDate
	fecha := ( Date readFrom: aDate readStream pattern: POSPattern datePattern) ! !

!MovimientoCaja methodsFor: 'as yet unclassified' stamp: 'prd 12/30/2014 16:17'!
descripcionMedioPago
	^ self medioPago descripcion! !

!MovimientoCaja methodsFor: 'as yet unclassified' stamp: 'prd 12/30/2014 16:17'!
descripcionTipo
	^ self tipo descripcion! !

!MovimientoCaja methodsFor: 'as yet unclassified' stamp: 'PRD 1/7/2015 14:14'!
descriptionFecha
	<magritteDescription>
	^ MADateDescription new
		priority: 10;
		beRequired ;
		label: 'Fecha';
		accessor: #fecha;
		default: ( Date today ) ;
		display: [:d | d ddmmyyyy ];
		componentClass: POSMAJQDateInputComponent ; 
		comment: 'Fecha de movimiento';
		yourself		! !

!MovimientoCaja methodsFor: 'as yet unclassified' stamp: 'PRD 1/21/2015 13:16'!
descriptionImporte
	<magritteDescription>
	^ MANumberDescription new
		accessor: #importe;
		priority: 20;
		label: 'importe';
		yourself! !

!MovimientoCaja methodsFor: 'as yet unclassified' stamp: 'PRD 3/17/2015 21:20'!
descriptionMedioPago
	<magritteDescription>
	^ MASingleOptionDescription new 
		priority: 30;
		label: 'Medio de Pago';
		accessor: #medioPago;
		comment: 'Medio de pago';
		optionsAndLabels: ( ( (self session collection: MedioPago) select: [ :each | each seRinde ] ) 
										collect: [:each | Association key: each value: each nombre  ] );
		yourself! !

!MovimientoCaja methodsFor: 'as yet unclassified' stamp: 'PRD 1/21/2015 12:16'!
descriptionTipoMovimientoCaja
	<magritteDescription>
	^ MASingleOptionDescription new 
		priority: 40;
		label: 'Tipo Movimiento Caja';
		accessor: #tipo;
		comment: 'Tipo Movimiento Caja';
		optionsAndLabels: ( (self session collection: TipoMovimientoCaja) collect: [:each | Association key: each value: each nombre  ] );
		yourself
		
	
! !

!MovimientoCaja methodsFor: 'accessing' stamp: 'PRD 10/7/2014 07:38'!
fecha
	^ fecha! !

!MovimientoCaja methodsFor: 'accessing' stamp: 'PRD 10/7/2014 07:38'!
fecha: anObject
	fecha := anObject! !

!MovimientoCaja methodsFor: 'accessing' stamp: 'PRD 10/7/2014 07:38'!
importe
	^ importe! !

!MovimientoCaja methodsFor: 'accessing' stamp: 'PRD 3/18/2015 09:51'!
importe: anObject
	importe := anObject! !

!MovimientoCaja methodsFor: 'accessing' stamp: 'PRD 3/13/2015 21:42'!
importeConSigno
	^ self importe * self signoPartida ! !

!MovimientoCaja methodsFor: 'as yet unclassified' stamp: 'PRD 3/9/2015 14:24'!
initialize
	super initialize .
	fecha := Date today.
	importe := 0.00 asImporte .
	rendicion := false.
	manual := true.! !

!MovimientoCaja methodsFor: 'accessing' stamp: 'PRD 3/9/2015 14:24'!
manual
	^ manual! !

!MovimientoCaja methodsFor: 'accessing' stamp: 'PRD 3/9/2015 14:24'!
manual: anObject
	manual := anObject! !

!MovimientoCaja methodsFor: 'accessing' stamp: 'PRD 10/9/2014 13:10'!
medioPago
	^ medioPago! !

!MovimientoCaja methodsFor: 'accessing' stamp: 'PRD 10/8/2014 21:57'!
medioPago: aMedioPago 
	medioPago := aMedioPago ! !

!MovimientoCaja methodsFor: 'accessing' stamp: 'PRD 2/24/2015 15:17'!
partida
	^ self tipo partida! !

!MovimientoCaja methodsFor: 'accessing' stamp: 'PRD 10/7/2014 07:38'!
rendicion
	^ rendicion! !

!MovimientoCaja methodsFor: 'accessing' stamp: 'PRD 12/31/2014 06:19'!
rendicion: aBoolean
	rendicion := aBoolean! !

!MovimientoCaja methodsFor: 'accessing' stamp: 'PRD 10/9/2014 05:37'!
signoPartida
	| s |
	s := self tipo signoPartida.
	s  isNil ifTrue: [ ^ self referencia signoPartida ] ifFalse: [ ^s ]
! !

!MovimientoCaja methodsFor: 'calculating' stamp: 'PRD 11/13/2014 13:44'!
sinRendir
	^ rendicion = false! !

!MovimientoCaja methodsFor: 'accessing' stamp: 'PRD 10/7/2014 07:58'!
tipo
	^ tipo! !

!MovimientoCaja methodsFor: 'accessing' stamp: 'PRD 10/7/2014 08:24'!
tipo: aTipoMovimientoCaja 
	tipo := aTipoMovimientoCaja! !

POSPersistentObject subclass: #MovimientoStock
	instanceVariableNames: 'tipo origen destino fecha referencia items nro nroLegal procesado proceso'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!MovimientoStock class methodsFor: 'as yet unclassified' stamp: 'PRD 12/11/2014 19:45'!
aboutClearCollectionInSession: aSession
	aSession clearCollections: ({  ItemMovimientoStock.} asOrderedCollection ).! !

!MovimientoStock class methodsFor: 'as yet unclassified' stamp: 'PRD 11/19/2014 15:45'!
origen: almacenOrigen destino: almacenDestino tipo: tipoMovimientoStock
	^ super new initialize
		origen: almacenOrigen;
		destino: almacenDestino;
		tipo: tipoMovimientoStock;
		yourself! !

!MovimientoStock class methodsFor: 'as yet unclassified' stamp: 'PRD 12/12/2014 12:26'!
pruebaCantidad: aCantidad origen: aOrigen destino: aDestino
	| c m |
	c := OrderedCollection new.
	
	
	m := self origen: aOrigen destino: aDestino tipo: POSSession noSeaside tipoMovimientoStockTransferencia.
	((self getSession readManyOf: Item where: [ :each | each codigo > 0 ] limit: 5)
		asSortedCollection: [ :a :b | a codigo < b codigo ])
		do: [ :i | 
			m
				addItem:
					(ItemMovimientoStock new
						item: i;
						cantidad: aCantidad;
						yourself) ].
	^ m ! !

!MovimientoStock methodsFor: 'creating' stamp: 'PRD 11/19/2014 15:42'!
addItem: anItemMovimientoStock 
	self items add: anItemMovimientoStock .
	anItemMovimientoStock movimiento: self.! !

!MovimientoStock methodsFor: 'as yet unclassified' stamp: 'PRD 11/20/2014 02:12'!
desprocesa
	self procesado ifFalse: [  
		self desprocesaItems ifFalse: [ ^nil ].
		self desprocesoMovimiento.
	"	self saveAndCommit ."
	].
	
	
	! !

!MovimientoStock methodsFor: 'processing' stamp: 'PRD 11/20/2014 02:13'!
desprocesaItems
	self flag: 'Revisar el método stockItem:cantidad: no me gusta'.
	self items 	do: [:each |  self origen   addExistenciaItem: each item cantidad: (each cantidad * -1 ). 
						 	 self destino addExistenciaItem: each item cantidad: each cantidad     ].
	^ true
! !

!MovimientoStock methodsFor: 'processing' stamp: 'PRD 11/20/2014 02:13'!
desprocesoMovimiento
	procesado := false.
	proceso := nil.! !

!MovimientoStock methodsFor: 'accessing' stamp: 'PRD 9/22/2014 23:55'!
destino
	^ destino! !

!MovimientoStock methodsFor: 'accessing' stamp: 'PRD 9/22/2014 23:55'!
destino: anObject
	destino := anObject! !

!MovimientoStock methodsFor: 'accessing' stamp: 'PRD 9/22/2014 23:55'!
fecha
	^ fecha! !

!MovimientoStock methodsFor: 'accessing' stamp: 'PRD 9/22/2014 23:55'!
fecha: anObject
	fecha := anObject! !

!MovimientoStock methodsFor: 'as yet unclassified' stamp: 'PRD 9/24/2014 14:32'!
initialize
	super initialize.
	fecha := DateAndTime now.
	items := OrderedCollection new.
	procesado := false.! !

!MovimientoStock methodsFor: 'accessing' stamp: 'PRD 9/24/2014 12:47'!
items
	^ items! !

!MovimientoStock methodsFor: 'accessing' stamp: 'PRD 9/24/2014 12:47'!
items: anObject
	items := anObject! !

!MovimientoStock methodsFor: 'accessing' stamp: 'PRD 9/24/2014 12:47'!
nro
	^ nro! !

!MovimientoStock methodsFor: 'accessing' stamp: 'PRD 9/24/2014 12:47'!
nro: anObject
	nro := anObject! !

!MovimientoStock methodsFor: 'accessing' stamp: 'PRD 9/24/2014 12:47'!
nroLegal
	^ nroLegal! !

!MovimientoStock methodsFor: 'accessing' stamp: 'PRD 9/24/2014 12:47'!
nroLegal: anObject
	nroLegal := anObject! !

!MovimientoStock methodsFor: 'as yet unclassified' stamp: 'PRD 11/20/2014 02:14'!
onAboutToDelete
	[self procesado ifTrue: [ self desprocesa ].
	self items do: [:each | each remove  ] ] ifCurtailed: [ ^false ].
	^ true
	! !

!MovimientoStock methodsFor: 'accessing' stamp: 'PRD 9/22/2014 23:55'!
origen
	^ origen! !

!MovimientoStock methodsFor: 'accessing' stamp: 'PRD 9/22/2014 23:55'!
origen: anObject
	origen := anObject! !

!MovimientoStock methodsFor: 'as yet unclassified' stamp: 'PRD 11/24/2014 01:18'!
procesa
	self procesado ifFalse: [  
		self procesaItems ifFalse: [ ^nil ].
		self procesoMovimiento.
	].
	
	
	! !

!MovimientoStock methodsFor: 'processing' stamp: 'PRD 11/20/2014 01:47'!
procesaItems
	self flag: 'Revisar el método stockItem:cantidad: no me gusta'.
	self items 	do: [:each |  self origen   addExistenciaItem: each item cantidad: each cantidad . 
						 	 self destino addExistenciaItem: each item cantidad: (each cantidad * -1)    ].
	^ true
! !

!MovimientoStock methodsFor: 'accessing' stamp: 'PRD 9/24/2014 14:53'!
procesado
	^ procesado! !

!MovimientoStock methodsFor: 'accessing' stamp: 'PRD 9/24/2014 14:53'!
proceso
	^ proceso! !

!MovimientoStock methodsFor: 'accessing' stamp: 'PRD 9/24/2014 14:53'!
proceso: anObject
	proceso := anObject! !

!MovimientoStock methodsFor: 'processing' stamp: 'PRD 9/24/2014 14:53'!
procesoMovimiento
	procesado := true.
	proceso := DateAndTime now.! !

!MovimientoStock methodsFor: 'accessing' stamp: 'PRD 9/22/2014 23:55'!
referencia
	^ referencia! !

!MovimientoStock methodsFor: 'accessing' stamp: 'PRD 9/22/2014 23:55'!
referencia: anObject
	referencia := anObject! !

!MovimientoStock methodsFor: 'accessing' stamp: 'PRD 9/22/2014 23:55'!
tipo
	^ tipo! !

!MovimientoStock methodsFor: 'accessing' stamp: 'PRD 9/22/2014 23:55'!
tipo: anObject
	tipo := anObject! !

POSPersistentObject subclass: #Novedad
	instanceVariableNames: 'tabla pidTabla novedad'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!Novedad class methodsFor: 'as yet unclassified' stamp: 'PRD 4/28/2015 09:21'!
from: anObject
	( anObject
		respondsTo: #pid )
		ifTrue: [ 
			^ self new initialize
				tabla: anObject class greaseString translateToLowercase;
				pidTabla: anObject pid;
				yourself ]! !

!Novedad methodsFor: 'as yet unclassified' stamp: 'PRD 4/27/2015 03:00'!
initialize
	super initialize.
	ultimaModificacion := DateAndTime now.
	self session user isNil
		ifTrue: [ ^ self ].
	usuariodbpid := self session user pid.
	usuariodbname := self session user userid! !

!Novedad methodsFor: 'accessing' stamp: 'PRD 4/26/2015 22:20'!
novedad
	^ novedad! !

!Novedad methodsFor: 'accessing' stamp: 'PRD 4/26/2015 22:20'!
novedad: anObject
	novedad := anObject! !

!Novedad methodsFor: 'accessing' stamp: 'PRD 4/26/2015 22:20'!
pidTabla
	^ pidTabla! !

!Novedad methodsFor: 'accessing' stamp: 'PRD 4/26/2015 22:20'!
pidTabla: anObject
	pidTabla := anObject! !

!Novedad methodsFor: 'accessing' stamp: 'PRD 4/26/2015 22:20'!
tabla
	^ tabla! !

!Novedad methodsFor: 'accessing' stamp: 'PRD 4/26/2015 22:20'!
tabla: anObject
	tabla := anObject! !

!POSPersistentObject class methodsFor: 'initializing' stamp: 'PRD 12/11/2014 11:57'!
aboutClearCollectionInSession: aSession
! !

!POSPersistentObject class methodsFor: 'initializing' stamp: 'PRD 12/19/2014 13:40'!
basicInitializeCollection
	self basicInitializeCollectionInSession: self session! !

!POSPersistentObject class methodsFor: 'initializing' stamp: 'PRD 4/12/2015 16:08'!
basicInitializeCollectionInSession: aPOSGlorpSession
"do nothing"! !

!POSPersistentObject class methodsFor: 'initializing' stamp: 'PRD 12/19/2014 13:42'!
clearCollection
	self clearCollectionInSession: self session.
	! !

!POSPersistentObject class methodsFor: 'initializing' stamp: 'PRD 12/19/2014 13:21'!
clearCollectionInSession: aPOSSession
	aPOSSession clearCollection: self.
	! !

!POSPersistentObject class methodsFor: 'accessors' stamp: 'PRD 12/19/2014 13:22'!
collection
	^self collectionInSession: self session
! !

!POSPersistentObject class methodsFor: 'accessors' stamp: 'PRD 12/19/2014 13:23'!
collectionInSession: aPOSSession
	^aPOSSession collection: self
! !

!POSPersistentObject class methodsFor: 'finding objects' stamp: 'PRD 11/9/2014 23:54'!
count
	"Count the number of objects in the database"
	"Person count"

	^ self getSession count: self! !

!POSPersistentObject class methodsFor: 'collection' stamp: 'PRD 11/11/2014 01:35'!
first
	self collection size > 0 ifTrue: [ ^ ( self collection sorted: [:a :b | a idUnico <= b idUnico  ] ) first ] ifFalse:[^ nil]! !

!POSPersistentObject class methodsFor: 'as yet unclassified' stamp: 'PRD 4/18/2015 13:17'!
fromObject: anObject 
	^ self fromObject: anObject inSession: self session.! !

!POSPersistentObject class methodsFor: 'as yet unclassified' stamp: 'PRD 4/18/2015 13:18'!
fromObject: anObject inSession: aPOSGlorpSession
	| o |
	o := anObject veryDeepCopy .
	o initializeValues.
	^o! !

!POSPersistentObject class methodsFor: 'accessing - properties' stamp: 'PRD 10/13/2014 21:19'!
hasUserRights
	^ true! !

!POSPersistentObject class methodsFor: 'initializing' stamp: 'PRD 10/16/2014 23:02'!
initializeCollection
	self basicInitializeCollection .! !

!POSPersistentObject class methodsFor: 'glorp' stamp: 'PRD 4/12/2015 16:02'!
initializeCollectionInSession: aSession
	self basicInitializeCollectionInSession: aSession .! !

!POSPersistentObject class methodsFor: 'collection' stamp: 'PRD 11/11/2014 01:35'!
last
	self collection size > 0 ifTrue: [ ^ ( self collection sorted: [:a :b | a idUnico <= b idUnico  ] ) last ] ifFalse:[^ nil]! !

!POSPersistentObject class methodsFor: 'instance creation' stamp: 'PRD 11/9/2014 23:54'!
new
	^super new initialize.! !

!POSPersistentObject methodsFor: 'comparing' stamp: 'PRD 11/9/2014 23:55'!
= anObject
	"Implement equality to compare primary keys if they are set. Make sure that if we have proxies, we check through them."

	| descriptor myKey |
	self class = anObject yourSelf class ifFalse: [^false].
	descriptor := self descriptor.	

	"If the primary keys aren't equal, then we know for sure we are unequal. Otherwise we have to check further."
	myKey := descriptor primaryKeyCollectionFor: self.
	myKey = (descriptor primaryKeyCollectionFor: anObject)
		ifFalse: [^false].

	"If the primary key contains nils, then fall back to the default equality comparison. If they don't, and are equal, then the objects are equal."
	^(myKey includes: nil) 
		ifTrue: [super = anObject yourSelf]
		ifFalse: [true].! !

!POSPersistentObject methodsFor: 'as yet unclassified' stamp: 'PRD 11/9/2014 23:55'!
=~ aPOSPersistenObject
	self class = aPOSPersistenObject class ifFalse: [ ^ false ]. 
	
	( self pid notNil and: [ aPOSPersistenObject pid notNil ] ) ifTrue: [ ^ pid = aPOSPersistenObject pid ].
	( self idUnico notNil and: [aPOSPersistenObject idUnico notNil ] ) ifTrue: [ ^ idUnico = aPOSPersistenObject idUnico ]. 
	^ self == aPOSPersistenObject .! !

!POSPersistentObject methodsFor: 'accessing' stamp: 'PRD 4/23/2015 19:25'!
accessor
	^ self gsession isNil ifTrue: [ Error signal: 'Session inexistente' ] ifFalse: [  self gsession accessor ]
! !

!POSPersistentObject methodsFor: 'persistence' stamp: 'PRD 12/11/2014 10:50'!
accionAboutPersist
	| accion |
	pid isNil
		ifTrue: [ accion := #insert ]
		ifFalse: [ accion := #update ].
	(pid isNil and: [ self idUnico notNil ])
		ifTrue: [ 
			self findUnico notNil
				ifTrue: [ 
					self onAboutRegistroDuplicado.
					^ self ] ].
	pid isNil
		ifTrue: [ accion := #insert ]
		ifFalse: [ accion := #update ].
	^ accion! !

!POSPersistentObject methodsFor: 'as yet unclassified' stamp: 'PRD 12/10/2014 13:52'!
add
	^ ( self == self saveAndCommit   )! !

!POSPersistentObject methodsFor: 'as yet unclassified' stamp: 'PRD 4/23/2015 19:24'!
autocommit
	^ self session autocommit! !

!POSPersistentObject methodsFor: 'actions' stamp: 'PRD 11/11/2014 02:08'!
bePersistent
	"Queue our object to be saved to the database upon commit."

	self gsession
		requireUnitOfWork;
		register: self! !

!POSPersistentObject methodsFor: 'glorp' stamp: 'PRD 11/17/2014 20:36'!
beginUnitOfWork
	^ self gsession beginUnitOfWork ! !

!POSPersistentObject methodsFor: 'as yet unclassified' stamp: 'PRD 12/6/2014 21:19'!
cancel
	self gsession rollbackUnitOfWork .! !

!POSPersistentObject methodsFor: 'as yet unclassified' stamp: 'PRD 12/6/2014 21:19'!
cancelAndBegin
	self gsession rollbackUnitOfWork .
	self beginUnitOfWork .! !

!POSPersistentObject methodsFor: 'as yet unclassified' stamp: 'PRD 4/18/2015 18:04'!
checkpid
	self pid ifNil: [ self pid: self session gsession nextValuePid  ].! !

!POSPersistentObject methodsFor: 'accessing' stamp: 'PRD 11/9/2014 23:56'!
classModel
	^self descriptor classModel! !

!POSPersistentObject methodsFor: 'calculos' stamp: 'PRD 10/13/2014 21:22'!
collection
	^ self class collection! !

!POSPersistentObject methodsFor: 'actions' stamp: 'PRD 11/11/2014 02:08'!
commitUnitOfWork
	"Commit the entire unit of work; this may include objects other than myself."

	self gsession hasUnitOfWork ifFalse: [^self].
	self gsession commitUnitOfWork! !

!POSPersistentObject methodsFor: 'accessing' stamp: 'PRD 10/15/2014 02:33'!
creacion
	^ creacion! !

!POSPersistentObject methodsFor: 'accessing' stamp: 'PRD 10/15/2014 02:33'!
creacion: anObject
	creacion := anObject! !

!POSPersistentObject methodsFor: 'as yet unclassified' stamp: 'PRD 12/7/2014 10:39'!
createSession
	| acc |
"	acc := DatabaseAccessor forLogin: self login.
	acc login.

	session := GlorpSession new.
	session system: (GlorpPOSDescriptor forPlatform: login database).
	session accessor: acc.

	^ session
"	

! !

!POSPersistentObject methodsFor: 'actions' stamp: 'PRD 4/10/2015 10:02'!
delete
	"Queue our object to be removed from the database on commit."
	
	[self session delete: self] on: Error do:[:e | Error signal: ('Error de borrado ' , e messageText ) ]! !

!POSPersistentObject methodsFor: 'accessing' stamp: 'PRD 11/11/2014 02:08'!
descriptor
	^self gsession descriptorFor: self class! !

!POSPersistentObject methodsFor: 'editing' stamp: 'PRD 1/14/2015 18:03'!
edit
	^ self add! !

!POSPersistentObject methodsFor: 'as yet unclassified' stamp: 'PRD 10/13/2014 21:22'!
errorOnAddMessage
	^ 'No puede agregar el  ' , self className ! !

!POSPersistentObject methodsFor: 'as yet unclassified' stamp: 'PRD 2/2/2015 18:56'!
errorOnDeleteMessage
	^ 'No puede borrar ' , self className  ! !

!POSPersistentObject methodsFor: 'as yet unclassified' stamp: 'PRD 10/13/2014 21:23'!
errorOnEditMessage
	^ 'No puede editar el  ' , self className ! !

!POSPersistentObject methodsFor: 'as yet unclassified' stamp: 'PRD 10/14/2014 16:23'!
errorUnicoDuplicado
	"^ RegistroDuplicadoError  signal: 'Instancia duplicada (' , self idUnico asString , ')'."! !

!POSPersistentObject methodsFor: 'finding objects' stamp: 'PRD 11/11/2014 02:09'!
find
	"This is a query by example facility. We take whichever fields are filled in the object and read back any objects in the database that match."
	
	| instances |
	instances := GlorpVirtualCollection on: self class in: self gsession.
	self descriptor mappings do: [:eachMapping | 
		instances := self findMapping: eachMapping in: instances].
	^instances.! !

!POSPersistentObject methodsFor: 'accessing' stamp: 'PRD 11/10/2014 00:18'!
find: aClass with: aSymbol value: aValue
	^ self selectOne: aClass where: [:each | ( each perform: aSymbol ) = aValue ]! !

!POSPersistentObject methodsFor: 'accessing' stamp: 'PRD 11/11/2014 02:09'!
findLast: aClass using: aString 
	| query value |
	query := Query readManyOf: aClass.
	query retrieveMax: aString asSymbol .
	value  := self gsession execute: query.
	^ value isEmpty ifTrue:[nil] ! !

!POSPersistentObject methodsFor: 'private' stamp: 'PRD 11/9/2014 23:56'!
findMapping: aMapping in: aVirtualCollection
	
	aMapping hasAttribute not ifTrue: [^aVirtualCollection].
	aMapping attribute name = #session ifTrue: [^aVirtualCollection].
	^(aMapping attribute getValueFrom: self)
		ifNil: [aVirtualCollection]
		ifNotNil: [:value | aVirtualCollection select: [:each | self matchAttribute: (each get: aMapping attribute name) to: value]].! !

!POSPersistentObject methodsFor: 'persistence' stamp: 'PRD 12/10/2014 09:59'!
findUnico
	|unico|
	unico := self idUnico.
	^ self gsession readOneOf: self class where: [ :each | each idUnico = unico ].
! !

!POSPersistentObject methodsFor: 'accessing' stamp: 'PRD 12/7/2014 10:57'!
gsession
	"^ self class getSession."
	^ self session gsession "prd cambiado a session"! !

!POSPersistentObject methodsFor: 'glorp' stamp: 'PRD 11/17/2014 20:35'!
hasUnitOfWork
	^ self gsession hasUnitOfWork ! !

!POSPersistentObject methodsFor: 'comparing' stamp: 'PRD 11/9/2014 23:56'!
hash
	"Implement hash to compare primary keys if they are set. Make sure that if we have proxies, we check through them."

	| myKey |

	"If the primary key contains nils, then fall back to the default hash. If they don't, hash the collection."
	myKey := self descriptor primaryKeyCollectionFor: self.
	^(myKey includes: nil) 
		ifTrue: [super hash]
		ifFalse: [myKey hash]! !

!POSPersistentObject methodsFor: 'accessing' stamp: 'PRD 11/10/2014 15:45'!
idOf: anObject
	^ anObject id.! !

!POSPersistentObject methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/14/2015 10:37'!
idUnico
	idUnico ifNil: [ 	pid isNil ifFalse: [idUnico := pid asString]].
	^ idUnico! !

!POSPersistentObject methodsFor: 'accessing' stamp: 'PRD 10/14/2014 00:33'!
idUnico: anObject
	idUnico := anObject! !

!POSPersistentObject methodsFor: 'as yet unclassified' stamp: 'PRD 4/26/2015 23:44'!
initialize 
	super initialize. 
	creacion := DateAndTime now.
	version := 0.! !

!POSPersistentObject methodsFor: 'as yet unclassified' stamp: 'PRD 4/15/2015 05:31'!
initializeValues
	creacion := DateAndTime now.
	ultimaModificacion := nil.
	version := 0.
	idUnico := nil.
	
	! !

!POSPersistentObject methodsFor: 'as yet unclassified' stamp: 'PRD 10/14/2014 00:49'!
inserted

! !

!POSPersistentObject methodsFor: 'as yet unclassified' stamp: 'PRD 11/13/2014 17:29'!
isNew
	^self gsession isNew: self.! !

!POSPersistentObject methodsFor: 'as yet unclassified' stamp: 'PRD 2/3/2015 11:52'!
isPersistent
	^ true! !

!POSPersistentObject methodsFor: 'accessing' stamp: 'PRD 11/10/2014 15:45'!
keyOf: anObject
	^ anObject pid! !

!POSPersistentObject methodsFor: 'private' stamp: 'PRD 11/9/2014 23:56'!
matchAttribute: anExpression to: value
	"We match expressions differently depending on what type they are."
	
	^(value isString and: [value includes: $%]) 
		ifTrue: [anExpression like: value] 
		ifFalse: [anExpression = value].! !

!POSPersistentObject methodsFor: 'as yet unclassified' stamp: 'PRD 10/14/2014 16:25'!
onAboutRegistroDuplicado
! !

!POSPersistentObject methodsFor: 'as yet unclassified' stamp: 'PRD 11/17/2014 19:28'!
onAboutToDelete
	^ true! !

!POSPersistentObject methodsFor: 'as yet unclassified' stamp: 'PRD 1/18/2015 20:50'!
onAboutToInsert
! !

!POSPersistentObject methodsFor: 'as yet unclassified' stamp: 'PRD 1/18/2015 20:50'!
onAboutToUpdate
! !

!POSPersistentObject methodsFor: 'as yet unclassified' stamp: 'PRD 11/18/2014 01:50'!
onDeleted
	^ true! !

!POSPersistentObject methodsFor: 'persistence' stamp: 'PRD 12/11/2014 10:51'!
persistOnRepo
	| accion |
	self idUnico.
	accion := self accionAboutPersist.
	accion = #insert 	ifTrue: 	[ self onAboutToInsert ]
							ifFalse: 	[ self onAboutToUpdate ].
	self gsession
		requireUnitOfWork;
		register: self.	"self bePersistent . "

	self autoCommit  ifTrue: [ self commitUnitOfWork ].

	accion = #insert
		ifTrue: [ self inserted ]
		ifFalse: [ self updated ].
	^ self! !

!POSPersistentObject methodsFor: 'accessing' stamp: 'PRD 11/10/2014 15:45'!
pid
	^ pid
				! !

!POSPersistentObject methodsFor: 'accessing' stamp: 'PRD 10/22/2014 15:23'!
pid: anObject
	pid := anObject! !

!POSPersistentObject methodsFor: 'actions' stamp: 'PRD 11/11/2014 02:09'!
refresh
	"Refresh our object from the database and rollback any changes registered in the unit of work."

	self rollback.
	self gsession refresh: self! !

!POSPersistentObject methodsFor: 'as yet unclassified' stamp: 'PRD 11/17/2014 20:26'!
refreshMe
	self gsession refresh: self.! !

!POSPersistentObject methodsFor: 'glorp/events' stamp: 'PRD 12/7/2014 21:45'!
registerInUnitOfWork
	self gsession 
		requireUnitOfWork;
		register: self	.																						
! !

!POSPersistentObject methodsFor: 'register' stamp: 'PRD 11/11/2014 02:09'!
registerMe

	self gsession register: self.
	! !

!POSPersistentObject methodsFor: 'deleting' stamp: 'PRD 4/10/2015 10:00'!
remove
	self onAboutToDelete ifFalse: [ ^ false]. 
	

	[self delete  ] on: Error do: [:e | ^ false]. 
			
	
	self onDeleted   ifFalse: [ ^ false ].		
	
	^ true			
"	(self keyOf: self) ifNil: [ self deleted. ^true ] ifNotNil: [ self notDeleted. ^false ] " "Tuve que sacarlo por GLORP"
	
"	^ self removeFromRepo ."! !

!POSPersistentObject methodsFor: 'remove' stamp: 'PRD 12/11/2014 11:39'!
remove: anObject
	^ [ 	self delete.
		anObject pid: nil. true ]
		ifCurtailed: [ false ]! !

!POSPersistentObject methodsFor: 'deleting' stamp: 'PRD 12/13/2014 21:59'!
removeInSession: aPOSSession

	^ aPOSSession remove: self

! !

!POSPersistentObject methodsFor: 'as yet unclassified' stamp: 'PRD 12/8/2014 01:13'!
reset
	self session reset
! !

!POSPersistentObject methodsFor: 'actions' stamp: 'PRD 11/11/2014 02:09'!
rollback
	"Rollback our entries in the queue so that we are not involved in the commit."

	self gsession hasUnitOfWork ifFalse: [^self].
	self gsession rollbackUnitOfWorkFor: self! !

!POSPersistentObject methodsFor: 'as yet unclassified' stamp: 'PRD 1/14/2015 20:03'!
save
	^ self session save: self ! !

!POSPersistentObject methodsFor: 'glorp' stamp: 'PRD 1/14/2015 17:10'!
saveAndCommit
	^ self session saveAndCommit: self
! !

!POSPersistentObject methodsFor: 'collection' stamp: 'PRD 11/10/2014 01:09'!
selectAll: aClass 
	^self class selectAll! !

!POSPersistentObject methodsFor: 'as yet unclassified' stamp: 'PRD 11/10/2014 01:10'!
selectMany: aClass where: aBlock 	
	^ self class selectMany: aBlock! !

!POSPersistentObject methodsFor: 'sql' stamp: 'PRD 11/10/2014 01:10'!
selectOne: aClass where: aBlockClosure 
	^ self class selectOne: aBlockClosure .! !

!POSPersistentObject methodsFor: 'accessing' stamp: 'PRD 11/11/2014 02:10'!
setDescriptor: aDescriptor 
	self gsession system: (aDescriptor forPlatform: self login database).
	! !

!POSPersistentObject methodsFor: 'as yet unclassified' stamp: 'PRD 4/15/2015 03:29'!
sincroWith: anObject
! !

!POSPersistentObject methodsFor: 'as yet unclassified' stamp: 'PRD 4/18/2015 13:54'!
sincroWith: anItem inSession: aPOSGlorpSession! !

!POSPersistentObject methodsFor: 'accessing' stamp: 'PRD 11/10/2014 00:39'!
table
	^self descriptor ifNotNil: [:descriptor | descriptor table]! !

!POSPersistentObject methodsFor: 'accessing' stamp: 'PRD 3/8/2015 13:35'!
ultimaModificacion
	^ ultimaModificacion! !

!POSPersistentObject methodsFor: 'accessing' stamp: 'PRD 3/8/2015 13:35'!
ultimaModificacion: anObject
	ultimaModificacion := anObject! !

!POSPersistentObject methodsFor: 'as yet unclassified' stamp: 'PRD 10/14/2014 00:49'!
updated

! !

!POSPersistentObject methodsFor: 'accessing' stamp: 'PRD 3/8/2015 13:33'!
usuariodbname
	^ usuariodbname! !

!POSPersistentObject methodsFor: 'accessing' stamp: 'PRD 3/8/2015 13:33'!
usuariodbname: anObject
	usuariodbname := anObject! !

!POSPersistentObject methodsFor: 'accessing' stamp: 'PRD 3/8/2015 13:33'!
usuariodbpid
	^ usuariodbpid! !

!POSPersistentObject methodsFor: 'accessing' stamp: 'PRD 3/8/2015 13:33'!
usuariodbpid: anObject
	usuariodbpid := anObject! !

!POSPersistentObject methodsFor: 'accessing' stamp: 'PRD 4/13/2015 01:53'!
version
	version ifNil: [ version := 0 ].
	^ version! !

!POSPersistentObject methodsFor: 'accessing' stamp: 'PRD 4/12/2015 23:43'!
version: anObject
	version := anObject! !

POSPersistentObject subclass: #PagoComprobante
	instanceVariableNames: 'medioPago importe comprobante referencia1 referencia2 referenciaCaja referencia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!PagoComprobante class methodsFor: 'creation' stamp: 'PabloDigonzelli 6/15/2014 16:31'!
fromComprobante: aComprobanteVenta medio: aMedioPago 
	|m|
	m :=  self medioPago: aMedioPago importe: aComprobanteVenta saldoImportePago  .
	m aplicaA: aComprobanteVenta .
	^ m! !

!PagoComprobante class methodsFor: 'initialization' stamp: 'PabloDigonzelli 6/11/2014 19:41'!
medioPago: aMedioPago importe: aNumber 
	^ super new initialize; medioPago: aMedioPago ; importe: aNumber ; yourself! !

!PagoComprobante methodsFor: 'calculos' stamp: 'PabloDigonzelli 6/11/2014 20:40'!
aplicaA: aComprobanteVenta 
	( aComprobanteVenta saldoImportePago >= self importe ) 
			ifTrue: [ aComprobanteVenta addPago: self]
			ifFalse:[Error signal: 'El importe supera el monto aplicable para Pago en el comprobante '  ]
									! !

!PagoComprobante methodsFor: 'accessing' stamp: 'PRD 9/25/2014 11:02'!
comprobante
	^ comprobante! !

!PagoComprobante methodsFor: 'accessor' stamp: 'PabloDigonzelli 6/11/2014 19:49'!
comprobante: aComprobanteVenta 
	comprobante := aComprobanteVenta! !

!PagoComprobante methodsFor: 'accessors' stamp: 'prd 12/30/2014 14:03'!
importe
	importe ifNil: [ importe := 0.00 ].
	^ importe! !

!PagoComprobante methodsFor: 'accessor' stamp: 'PabloDigonzelli 6/11/2014 19:42'!
importe: aNumber 
	importe := aNumber! !

!PagoComprobante methodsFor: 'accessing' stamp: 'PabloDigonzelli 6/15/2014 15:41'!
medioPago
	^ medioPago! !

!PagoComprobante methodsFor: 'accesors' stamp: 'PabloDigonzelli 6/11/2014 19:42'!
medioPago: aMedioPago 
	medioPago := aMedioPago! !

!PagoComprobante methodsFor: 'accessors' stamp: 'PabloDigonzelli 6/11/2014 19:39'!
medioPago: aMedioPago importe: aNumber 
	self shouldBeImplemented.! !

!PagoComprobante methodsFor: 'accessing' stamp: 'PRD 10/4/2014 18:53'!
referencia1
	^ referencia1! !

!PagoComprobante methodsFor: 'accessing' stamp: 'PRD 10/4/2014 18:53'!
referencia1: anObject
	referencia1 := anObject! !

!PagoComprobante methodsFor: 'accessing' stamp: 'PRD 10/4/2014 18:53'!
referencia2
	^ referencia2! !

!PagoComprobante methodsFor: 'accessing' stamp: 'PRD 10/4/2014 18:53'!
referencia2: anObject
	referencia2 := anObject! !

!PagoComprobante methodsFor: 'accsessing' stamp: 'PRD 10/9/2014 03:59'!
referencia: aMovimientoCaja 
	referencia := aMovimientoCaja ! !

!PagoComprobante methodsFor: 'accessing' stamp: 'PRD 10/8/2014 22:18'!
referenciaCaja: aMovimientoCaja 
	referenciaCaja := aMovimientoCaja ! !

!PagoComprobante methodsFor: 'calculating' stamp: 'PRD 10/7/2014 08:27'!
signoPartida
	^ self comprobante signoPartida ! !

POSPersistentObject subclass: #PuntoVenta
	instanceVariableNames: 'numero empresa'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!PuntoVenta class methodsFor: 'as yet unclassified' stamp: 'PRD 10/1/2014 12:05'!
uno
	^ super new initialize numero: 1.! !

!PuntoVenta methodsFor: 'accessing' stamp: 'PRD 10/1/2014 11:50'!
descriptionNumero
	<magritteDescription>
	^ MANumberDescription new
		label: 'Numero';
		accessor: #numero;
		tooltip: 'Número';
		comment: 'Numero';
		beRequired;
		yourself
	! !

!PuntoVenta methodsFor: 'as yet unclassified' stamp: 'PRD 10/1/2014 02:27'!
initialize
	super initialize.
	numero := 0.! !

!PuntoVenta methodsFor: 'as yet unclassified' stamp: 'PRD 10/1/2014 11:47'!
nombre
	^ self numero asString! !

!PuntoVenta methodsFor: 'accessing' stamp: 'PRD 10/1/2014 02:27'!
numero
	^ numero! !

!PuntoVenta methodsFor: 'accessing' stamp: 'PRD 10/1/2014 02:27'!
numero: anObject
	numero := anObject! !

POSPersistentObject subclass: #RendicionCaja
	instanceVariableNames: 'caja fecha cerrada movimientos comprobantes rendicionesCajero cajero'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!RendicionCaja class methodsFor: 'calculating' stamp: 'PRD 12/20/2014 07:10'!
anula: aRendicionCaja 
	^ self anula: aRendicionCaja inSession: self session! !

!RendicionCaja class methodsFor: 'creation' stamp: 'PRD 3/9/2015 13:47'!
caja: aCaja fecha: aDate 
	^ self caja: aCaja fecha: aDate inSession: self session	
	! !

!RendicionCaja class methodsFor: 'creation' stamp: 'PRD 3/10/2015 04:00'!
caja: aCaja fecha: aDate inSession: aSession
	| r rant |
	rant := self rendicionAnteriorAbiertaCaja: aCaja fecha: aDate inSession: aSession.
	rant isEmpty ifFalse: [ ^ nil ].
	r := super new initialize
		caja: aCaja;
		fecha: aDate;
		yourself.
	r generaMovimientosRendicionInSession: aSession.
	^ r! !

!RendicionCaja class methodsFor: 'creation' stamp: 'PRD 4/18/2015 02:03'!
rendicionAnteriorAbiertaCaja: aCaja fecha: aDate 
	^ self rendicionAnteriorAbiertaCaja: aCaja  fecha: aDate inSession: self session! !

!RendicionCaja class methodsFor: 'creation' stamp: 'PRD 3/9/2015 14:58'!
rendicionAnteriorAbiertaCaja: aCaja fecha: aDate inSession: aSession
	^ aSession
		readManyOf: self
		where: [ :each | each caja = aCaja AND: [ each cerrada = false ] AND: [ each fecha <= aDate ] ]! !

!RendicionCaja methodsFor: 'creation' stamp: 'PRD 2/24/2015 13:43'!
addComprobante: aComprobante 
	
	cerrada ifTrue: [ ^self ].
	
"	movimientos add: aMovimientoCaja ."
	aComprobante rendicionCaja: self.! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 2/24/2015 14:45'!
addDetail: aMovimientoCaja
	( self movimientos includes: aMovimientoCaja ) ifFalse: [ self addMovimiento: aMovimientoCaja ]! !

!RendicionCaja methodsFor: 'creation' stamp: 'PRD 2/24/2015 15:03'!
addMovimiento: aMovimientoCaja 
	
	cerrada ifTrue: [ ^self ].
	
	movimientos add: aMovimientoCaja .
	aMovimientoCaja rendicion: true.
! !

!RendicionCaja methodsFor: 'creation' stamp: 'PRD 3/4/2015 02:30'!
addRendicionCajero: aRendicion 
	
	cerrada ifTrue: [ ^self ].
	
	rendicionesCajero add: aRendicion.! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 4/17/2015 23:42'!
anula
	^ self anulaInSession: self session.! !

!RendicionCaja methodsFor: 'calculating' stamp: 'PRD 3/10/2015 05:17'!
anulaInSession: aSession
	cerrada ifFalse: [ ^ self ].
	aSession refresh: self.
	aSession requireUnitOfWork.	
	aSession registerObject: self.
	self anulaRendicionComprobantesInSession: aSession.
	self anulaMovimientosInSession: aSession.
	aSession remove: self.
	aSession commitUnitOfWork.	

	^ self! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 4/17/2015 23:43'!
anulaMovimientos
	^ self anulaMovimientosInSession: self session
! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 3/10/2015 06:22'!
anulaMovimientosInSession: aSession
	self movimientos do: [:mov | self removeMovimiento: mov inSession: aSession].
	self movimientos: OrderedCollection new.
! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 4/17/2015 23:43'!
anulaRendicionComprobantes
	self anulaRendicionComprobantesInSession: self session! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 3/10/2015 06:18'!
anulaRendicionComprobantesInSession: aSession
	self comprobantes  do: [ :com | 	aSession registerObject: com.
												com rendicionCaja: nil].
   comprobantes := OrderedCollection new.! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 2/2/2015 11:22'!
basicValidateRemove
	self cerrada ifTrue: [ ^false ].
	^ true! !

!RendicionCaja methodsFor: 'accessing' stamp: 'PRD 12/16/2014 15:39'!
caja
	^ caja! !

!RendicionCaja methodsFor: 'accessing' stamp: 'PRD 10/9/2014 15:04'!
caja: anInteger 
	caja := anInteger ! !

!RendicionCaja methodsFor: 'accessing' stamp: 'PRD 3/14/2015 23:43'!
cajero
	^ cajero! !

!RendicionCaja methodsFor: 'accessing' stamp: 'PRD 3/14/2015 23:43'!
cajero: anObject
	cajero := anObject! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 2/3/2015 01:08'!
canCerrar
	^ self cerrada not! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 2/4/2015 14:33'!
canEdit
	^ self cerrada not! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 2/3/2015 01:08'!
canReabrir
	^ self cerrada ! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 2/4/2015 14:23'!
canRemove
	^ self cerrada not! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 2/4/2015 14:27'!
canShowDetails
	^ self cerrada not! !

!RendicionCaja methodsFor: 'accessing' stamp: 'PRD 1/13/2015 20:49'!
cerrada
	^ cerrada! !

!RendicionCaja methodsFor: 'accessing' stamp: 'PRD 1/13/2015 00:17'!
cerrada: anObject
	cerrada := anObject! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 4/17/2015 23:45'!
cerrar
	cerrada := true.
! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 3/10/2015 05:41'!
cierra
	cerrada := true.
! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 3/10/2015 05:21'!
cierraInSession: aSession
	aSession requireUnitOfWork.
	aSession registerObject: self.
	cerrada := true.
	self session commitUnitOfWork.! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 4/18/2015 00:00'!
cierraRendicion
	cerrada := true.
! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 3/10/2015 06:19'!
comprobantes
	^ comprobantes .! !

!RendicionCaja methodsFor: 'accessing' stamp: 'PRD 3/14/2015 23:43'!
comprobantes: anObject
	comprobantes := anObject! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 3/9/2015 13:03'!
comprobantesVentaEgresoARendirPorFecha: col
	|  dic |
	dic := Dictionary new.
		col
		do: [ :c | 
			dic  at: c fecha ifAbsentPut: [ OrderedCollection new ].
			c partida = self session partidaHaber
				ifTrue: [ (dic at: c fecha) add: c ] ].
	^ dic
	! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 3/9/2015 13:03'!
comprobantesVentaIngresoARendirPorFecha: col
	|  dic |
	dic := Dictionary new.
		col
		do: [ :c | 
			dic  at: c fecha ifAbsentPut: [ OrderedCollection new ].
			c partida = self session partidaDebe
				ifTrue: [ (dic at: c fecha) add: c ] ].
	^ dic
	! !

!RendicionCaja methodsFor: 'accesing' stamp: 'PRD 3/10/2015 05:38'!
containerActions: aContainer
	<magritteContainer1>
	 ^aContainer
		addCommand: 'Cerrar' condition: #canCerrar action: #cerrar ;
		addCommand: 'ReAbrir' condition: #canReabrir action: #reabrir;
		yourself! !

!RendicionCaja methodsFor: 'accesing' stamp: 'PRD 1/13/2015 20:49'!
descriptionCaja
	<magritteDescription>
	^ MASingleOptionDescription new 
		priority: 300;
		label: 'Caja';
		accessor: #caja;
		comment: 'Caja';
		optionsAndLabels: ( self empresa cajas collect: [:each | Association key: each value: each nombre ] );
		yourself! !

!RendicionCaja methodsFor: 'accesing' stamp: 'PRD 1/13/2015 00:28'!
descriptionCerrada
	<magritteDescription>
	^MABooleanDescription new
		accessor: #cerrada;
		label: 'Cerrada';
		priority: 300;
		trueString: 'Si';
		falseString: 'No';
		beReadonly;
		yourself! !

!RendicionCaja methodsFor: 'accesing' stamp: 'PRD 1/13/2015 00:21'!
descriptionFecha
	<magritteDescription>
	^ MADateDescription new 
		priority: 300;
		label: 'Fecha';
		accessor: #fecha;
		comment: 'Fecha';
		default: ( Date today ) ;
		display: [:d | d ddmmyyyy ];
		componentClass: POSMAJQDateInputComponent ; 
		yourself! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 2/24/2015 15:16'!
descriptionImporteARendir
	<magritteDescription>
	^ MANumberDescription new 
		priority: 300;
		label: 'A rendir';
		accessor: #importeARendir;
		beReadonly;
		yourself
		
! !

!RendicionCaja methodsFor: 'accessing' stamp: 'PRD 1/23/2015 09:57'!
descriptionMovimientos
	<magritteDescription>
	^ MAToManyRelationDescription new 
		priority: 300;
		label: 'Movimientos';
		sorted: true;
		accessor: #movimientos;
		classes: { MovimientoCaja };
		beDetail;
		yourself
		
! !

!RendicionCaja methodsFor: 'rendicion' stamp: 'PRD 12/20/2014 20:08'!
egresosPorVentaPorFechaPorMedioPago
	movimientosCajaEgreso := self movimientosPorFechaPorMedioPago: comprobantesVentaEgreso.
	^ movimientosCajaEgreso! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 1/13/2015 00:17'!
empresa
	^ self session empresa! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 2/2/2015 18:58'!
errorOnDeleteMessage

	^ 'La rendición está cerrada. Debe reabrirla primero'.  ! !

!RendicionCaja methodsFor: 'accessing' stamp: 'PRD 1/13/2015 00:17'!
fecha
	^ fecha! !

!RendicionCaja methodsFor: 'accessing' stamp: 'PRD 10/9/2014 15:04'!
fecha: aDate 
	fecha := aDate! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 3/9/2015 13:45'!
generaMovimientosRendicion

	self generaMovimientosRendicionInSession: self session! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 4/17/2015 21:04'!
generaMovimientosRendicionInSession: aSession

	| tipoIngreso tipoEgreso comprobantesVentaIngreso comprobantesVentaEgreso col mov1  movimientosCajaIngreso movimientosCajaEgreso |

	movimientos := OrderedCollection new.
	col := ComprobanteVenta sinRendirCaja: self caja.

	tipoIngreso 	:= self session ingresoPorVenta .
	tipoEgreso 	:= self session egresoPorVenta .

	comprobantesVentaIngreso := self comprobantesVentaIngresoARendirPorFecha: col.
	comprobantesVentaEgreso  := self comprobantesVentaEgresoARendirPorFecha: col.

	mov1 := self movimientosSinRendirCaja: self caja  inSession: aSession.

	movimientosCajaIngreso 	:=  ( self generaMovimientosTipo: tipoIngreso comprobantes: comprobantesVentaIngreso caja: self caja session: aSession manual: false) .
	movimientosCajaEgreso 	:=  ( self generaMovimientosTipo: tipoEgreso comprobantes: comprobantesVentaEgreso  caja: self caja session: aSession manual: false) .
	
	movimientosCajaIngreso do: [:m | self addMovimiento: m].
	movimientosCajaEgreso do: [:m | self addMovimiento: m].
	mov1 do: [:m | self addMovimiento: m].
	col do: [:each | self addComprobante: each  ].
	
! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 3/9/2015 15:21'!
generaMovimientosTipo: aTipoMovimiento comprobantes: dictOfComprobantes caja: aCaja session: aSession manual: aFlag
	| ses dict col ing|
	ses := aSession.
	col := OrderedCollection new.
	
	dict := self movimientosPorFechaPorMedioPago: dictOfComprobantes.
	dict keys
		do: [ :fecha1 | 
			(dict at: fecha1) keys
				do: [ :medio | 
							ing := MovimientoCaja
								tipo: aTipoMovimiento 
								fecha: fecha1
								medioPago: medio
								caja: aCaja.
							ing manual: aFlag.
							ing importe: ing importe + ((dict at: fecha1) at: medio).
							col add: ing ] ].
	^ col! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 2/24/2015 16:50'!
importeARendir
	self cerrada ifTrue: [ ^  0.00 asImporte ].
	^  ( self importeDebe - self importeHaber ) asImporte! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 2/24/2015 15:12'!
importeDebe
	^ self movimientosDebe inject: 0 into: [ :sum :mov | sum + mov importe ].! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 2/24/2015 15:13'!
importeHaber
	^ self movimientosHaber inject: 0 into: [ :sum :mov | sum + mov importe ].! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 3/13/2015 21:42'!
importeMedio: aMedioPago
	^ ( self movimientos select: [:each | each medioPago = aMedioPago  ] ) inject:0 into: [:sum :mov | sum + ( mov importeConSigno)  ]! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 3/14/2015 20:37'!
importeRendidoMedio: aMedioPago
	^ ( self rendicionesCajero select: [:each | each medioPago = aMedioPago  ] ) inject:0 into: [:sum :ren | sum + ( ren importe)  ]! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 3/18/2015 09:17'!
initialize
	super initialize.
	cerrada := false.
	movimientos := OrderedCollection new.
	comprobantes := OrderedCollection new.
	rendicionesCajero := OrderedCollection new.
"	cajero := self session user."
! !

!RendicionCaja methodsFor: 'accesing' stamp: 'PRD 10/9/2014 15:36'!
movimientos
	^ movimientos! !

!RendicionCaja methodsFor: 'accessing' stamp: 'PRD 10/9/2014 15:05'!
movimientos: aCollection 
	movimientos := aCollection! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 2/24/2015 15:11'!
movimientosDebe
	^ self movimientos select: [:m | m partida = self session partidaDebe   ]! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 2/24/2015 15:11'!
movimientosHaber
	^ self movimientos select: [:m | m partida = self session partidaHaber   ]! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'prd 12/30/2014 14:02'!
movimientosPorFechaPorMedioPago: aDictionaryOfComprobantes
	| dict mpago  |
	dict := Dictionary new.
	aDictionaryOfComprobantes keysAndValuesDo: [ :k :v | 
			| impo dict1|
			dict1 := dict at: k ifAbsentPut: [ dict1 := Dictionary new ].
			v do: [:v1 | v1 pagos do: [ :pag | 
					mpago := pag medioPago.
					dict1 at: mpago ifAbsentPut: [ 0.00 asImporte ].
					impo := dict1 at: mpago.
					impo := impo + pag importe.
					dict1 at: mpago put: impo asImporte ] ]
	 ].
	^ dict! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 4/18/2015 01:38'!
movimientosSinRendirCaja:  aCaja 
	^ self movimientosSinRendirCaja: aCaja inSession: self session
	! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 3/9/2015 13:36'!
movimientosSinRendirCaja:  aCaja inSession: aSession

	^ aSession readManyOf: MovimientoCaja  where: [:each | each rendicion = false AND: [each caja = aCaja  ] ]

	! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 3/9/2015 13:26'!
movimientosSinRendirTipo: tipoIngreso caja:  aCaja

	^ self movimientosSinRendirTipo: tipoIngreso caja:  aCaja inSession: self session

	! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 3/9/2015 13:26'!
movimientosSinRendirTipo: tipoIngreso caja:  aCaja inSession: aSession

	^ aSession readManyOf: MovimientoCaja  where: [:each | each rendicion = false AND: [each caja = aCaja  ] AND: [each tipo = tipoIngreso  ] ]

	! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 3/9/2015 13:53'!
movimientosVentaInSession: aSession	
	^ movimientos select: [:each | each tipo = aSession ingresoPorVenta  or: [ each tipo = aSession egresoPorVenta ] ].! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 1/13/2015 12:07'!
noCerrada
	^ self cerrada not! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 3/10/2015 05:43'!
onAboutToDelete
	self movimientos do: [:mov | self removeMovimiento: mov].
	self comprobantes do: [:com | self removeComprobante: com  ].
	self rendicionesCajero  do: [:ren | self removeRendicionCajero: ren  ].

	^ true ! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 2/24/2015 13:05'!
reabrir
	self anulaInSession: self session.! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 2/24/2015 13:44'!
removeComprobante: aComprobante
	self comprobantes remove: aComprobante.
	aComprobante  rendicionCaja: nil.
! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 3/10/2015 05:32'!
removeMovimiento: aMovimientoCaja 
	self removeMovimiento: aMovimientoCaja inSession: self session! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 3/10/2015 06:22'!
removeMovimiento: aMovimientoCaja inSession: aSession
	aMovimientoCaja manual 
						ifTrue: [ 	aSession registerObject: aMovimientoCaja .
										aMovimientoCaja rendicion: false.]
						ifFalse: [aSession remove: aMovimientoCaja].
! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 4/18/2015 01:39'!
removeRendicionCajero: aRendicion
	self removeRendicionCajero: aRendicion  inSession: self session
! !

!RendicionCaja methodsFor: 'as yet unclassified' stamp: 'PRD 3/10/2015 05:44'!
removeRendicionCajero: aRendicion inSession: aSession
	self rendicionesCajero remove: aRendicion.
	aSession remove: aRendicion.
! !

!RendicionCaja methodsFor: 'accessing' stamp: 'PRD 3/3/2015 20:15'!
rendicionesCajero
	^ rendicionesCajero! !

!RendicionCaja methodsFor: 'accessing' stamp: 'PRD 3/3/2015 20:15'!
rendicionesCajero: anObject
	rendicionesCajero := anObject! !

POSPersistentObject subclass: #RendicionCajero
	instanceVariableNames: 'importe medioPago'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!RendicionCajero methodsFor: 'as yet unclassified' stamp: 'PRD 3/3/2015 20:17'!
descripcionMedioPago
	^ self medioPago descripcion! !

!RendicionCajero methodsFor: 'as yet unclassified' stamp: 'PRD 3/3/2015 20:16'!
descriptionImporte
	<magritteDescription>
	^ MANumberDescription new
		accessor: #importe;
		priority: 20;
		label: 'importe';
		yourself! !

!RendicionCajero methodsFor: 'as yet unclassified' stamp: 'PRD 3/3/2015 20:16'!
descriptionMedioPago
	<magritteDescription>
	^ MASingleOptionDescription new 
		priority: 30;
		label: 'Medio de Pago';
		accessor: #medioPago;
		comment: 'Medio de pago';
		optionsAndLabels: ( ( self session collection: MedioPago ) collect: [:each | Association key: each value: each nombre  ] );
		yourself! !

!RendicionCajero methodsFor: 'accessing' stamp: 'PRD 3/3/2015 20:14'!
importe
	^ importe! !

!RendicionCajero methodsFor: 'accessing' stamp: 'PRD 3/3/2015 20:14'!
importe: anObject
	importe := anObject! !

!RendicionCajero methodsFor: 'accessing' stamp: 'PRD 3/3/2015 20:14'!
medioPago
	^ medioPago! !

!RendicionCajero methodsFor: 'accessing' stamp: 'PRD 3/3/2015 20:14'!
medioPago: anObject
	medioPago := anObject! !

POSPersistentObject subclass: #RolUsuario
	instanceVariableNames: 'rolName administrador'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!RolUsuario class methodsFor: 'as yet unclassified' stamp: 'PRD 2/19/2015 18:44'!
basicInitializeCollectionInSession:aSession
	| rol  |
	
	aSession beginUnitOfWork.
	
	rol := super new initialize rolName: 'admin';  
		administrador: true; 
		yourself .
	aSession registerObject: rol.
	
	aSession commitUnitOfWork.
! !

!RolUsuario class methodsFor: 'as yet unclassified' stamp: 'PRD 7/22/2014 21:35'!
hasUserRights
	^ false! !

!RolUsuario methodsFor: 'accessing' stamp: 'PRD 2/14/2015 23:58'!
administrador
	^ administrador! !

!RolUsuario methodsFor: 'accessing' stamp: 'PRD 2/14/2015 23:58'!
administrador: anObject
	administrador := anObject! !

!RolUsuario methodsFor: 'accessing' stamp: 'PRD 2/15/2015 12:45'!
canAdd: aClass toClass: aClass2 
	^ true! !

!RolUsuario methodsFor: 'accessing' stamp: 'PRD 2/15/2015 12:44'!
canAddToClass: aClass 
	^ true! !

!RolUsuario methodsFor: 'accessing' stamp: 'PRD 2/15/2015 14:21'!
canEdit: anUsuario class: aClass 
	^ true! !

!RolUsuario methodsFor: 'accessing' stamp: 'PRD 2/15/2015 12:43'!
canRemove: aRow class: aClass 
	^true! !

!RolUsuario methodsFor: 'as yet unclassified' stamp: 'PRD 2/14/2015 23:58'!
descriptionAdministrador
	<magritteDescription>
	^ MABooleanDescription new
		priority: 200; 	
		accessor: #administrador;
		default: false;
		checkboxLabel: 'Administrador';
		trueString: 'Si';
		falseString: 'No';
		label: 'Administrador';
		yourself! !

!RolUsuario methodsFor: 'as yet unclassified' stamp: 'PRD 2/15/2015 01:56'!
descriptionRolName
	<magritteDescription>
	^ MAStringDescription new
		priority: 100;
		label: 'Nombre';
		comment: 'Nombre de rol';
		accessor: #rolName;
		beRequired ;
		yourself! !

!RolUsuario methodsFor: 'as yet unclassified' stamp: 'PRD 2/14/2015 23:50'!
initialize
	administrador := false.! !

!RolUsuario methodsFor: 'as yet unclassified' stamp: 'PRD 2/14/2015 23:59'!
isAdministrador
	^ self administrador! !

!RolUsuario methodsFor: 'as yet unclassified' stamp: 'PRD 2/14/2015 23:51'!
rolName
	^ rolName! !

!RolUsuario methodsFor: 'as yet unclassified' stamp: 'PRD 2/14/2015 23:51'!
rolName: anObject
	rolName := anObject! !

POSPersistentObject subclass: #TipoMovimientoStock
	instanceVariableNames: 'descripcion abreviatura origen destino'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!TipoMovimientoStock class methodsFor: 'as yet unclassified' stamp: 'PRD 10/16/2014 22:10'!
basicInitializeCollection
	self creaTransferencia.! !

!TipoMovimientoStock class methodsFor: 'transferencia' stamp: 'PRD 12/12/2014 12:21'!
creaTransferencia
	^	super new initialize
				descripcion: 'Transferencia';
				abreviatura: 'TF'; yourself ! !

!TipoMovimientoStock class methodsFor: 'transferencia' stamp: 'PRD 9/23/2014 17:00'!
transferencia
	^ self collection
		detect: [ :each | each descripcion = 'Transferencia' and: [ each abreviatura = 'TF' ] ]
		ifNone: [ self creaTransferencia ]! !

!TipoMovimientoStock methodsFor: 'accessing' stamp: 'PRD 9/23/2014 00:03'!
abreviatura
	^ abreviatura! !

!TipoMovimientoStock methodsFor: 'accessing' stamp: 'PRD 9/23/2014 00:03'!
abreviatura: anObject
	abreviatura := anObject! !

!TipoMovimientoStock methodsFor: 'accessing' stamp: 'PRD 9/23/2014 00:03'!
descripcion
	^ descripcion! !

!TipoMovimientoStock methodsFor: 'accessing' stamp: 'PRD 9/23/2014 00:03'!
descripcion: anObject
	descripcion := anObject! !

!TipoMovimientoStock methodsFor: 'accessing' stamp: 'PRD 9/23/2014 00:19'!
destino
	^ destino! !

!TipoMovimientoStock methodsFor: 'accessing' stamp: 'PRD 9/23/2014 00:19'!
destino: anObject
	destino := anObject! !

!TipoMovimientoStock methodsFor: 'accessing' stamp: 'PRD 9/23/2014 00:19'!
origen
	^ origen! !

!TipoMovimientoStock methodsFor: 'accessing' stamp: 'PRD 9/23/2014 00:19'!
origen: anObject
	origen := anObject! !

POSPersistentObject subclass: #Usuario
	instanceVariableNames: 'userid nombreUsuario passwordHash password roles strPassword'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!Usuario class methodsFor: 'as yet unclassified' stamp: 'PRD 2/19/2015 18:43'!
basicInitializeCollectionInSession:aSession
	| u  |
	
	aSession beginUnitOfWork.
	
	u := super new initialize userid: 'admin';  
		 nombreUsuario: 'admin'; 
		strPassword: 'admin'; 
		yourself .
	aSession registerObject:u.
	
	aSession commitUnitOfWork.
! !

!Usuario class methodsFor: 'as yet unclassified' stamp: 'PRD 7/22/2014 21:18'!
hasUserRights
	^ true! !

!Usuario methodsFor: 'accessing' stamp: 'PRD 2/15/2015 12:44'!
canAdd: aClass toClass: aModelClass 
	self roles do: [ :each |
		(each canAdd: aClass toClass: aModelClass) ifTrue: [ ^true ] ].
	(self model hasClassUserRights: aClass) ifTrue: [ ^false ].
	^true! !

!Usuario methodsFor: 'accessing' stamp: 'PRD 2/15/2015 12:44'!
canAddToClass: aClass 
	self roles do: [ :each | (each canAddToClass: aClass) ifTrue: [ ^true ] ].
	(self model hasClassUserRights: aClass) ifTrue: [ ^false ].
	^true! !

!Usuario methodsFor: 'as yet unclassified' stamp: 'PRD 2/14/2015 23:37'!
canChangePassword
	self ifLoggedIn: [ ^(self user = self) or: [ self user isAdminUser ] ].
	^false! !

!Usuario methodsFor: 'accessing' stamp: 'PRD 2/15/2015 14:21'!
canEdit: aRow class: aModelClass 
	self roles do: [ :each | (each canEdit: aRow class: aModelClass) ifTrue: [ ^true ] ].
	(self model hasClassUserRights: aModelClass) ifTrue: [ ^false ].
	aRow hasParent ifTrue: [ ^self canEdit: aRow parent class: aRow parent class ].
	^true! !

!Usuario methodsFor: 'accessing' stamp: 'PRD 2/15/2015 12:42'!
canRemove: aRow class: aModelClass 
	self roles do: [ :each | (each canRemove: aRow class: aModelClass) ifTrue: [ ^true ] ].
	(self model hasClassUserRights: aModelClass) ifTrue: [ ^false ].
	aRow hasParent ifTrue: [ ^self canEdit: aRow parent class: aRow parent class ].
	^true! !

!Usuario methodsFor: 'as yet unclassified' stamp: 'PRD 2/15/2015 20:24'!
changePasswordOn: aComponent 
	aComponent announce: (POSQCShowDetails on: (QCUserPassword on: self))! !

!Usuario methodsFor: 'as yet unclassified' stamp: 'PRD 2/14/2015 23:36'!
checkPasswordOnMemento: aMemento
	^(aMemento readUsing: self descriptionPassword) = (aMemento readUsing: self descriptionPasswordVerify)! !

!Usuario methodsFor: 'as yet unclassified' stamp: 'PRD 4/27/2015 03:52'!
componentFor: aTarget from: aParent
	"can be overridden to support user (rights/preference) based changes"
	(aParent respondsTo: #componentFor:) ifTrue: [ 
		^aParent componentFor: aTarget ] 
	ifFalse: [ ^aTarget asComponent ] ! !

!Usuario methodsFor: 'as yet unclassified' stamp: 'PRD 2/15/2015 21:56'!
containerActions: aContainer
	<magritteContainer1>
	^aContainer
		addCommand: 'Cambiar Password'
				condition: #canChangePassword
				action: [ :row :component | row changePasswordOn: component ];
		yourself! !

!Usuario methodsFor: 'accessing' stamp: 'PRD 2/15/2015 12:31'!
correctPassword
	" is called when user enters the correct password. See also wrongPassword "! !

!Usuario methodsFor: 'accessing' stamp: 'PRD 2/15/2015 12:42'!
curLanguage
	^QCMultilanguageString curLanguage! !

!Usuario methodsFor: 'as yet unclassified' stamp: 'PRD 2/15/2015 01:20'!
descriptionNombreUsuario
	<magritteDescription>
	^ MAStringDescription new
		priority: 100;
		label: 'Nombre';
		comment: 'Nombre de usuario';
		accessor: #nombreUsuario;
		beRequired ;
		yourself! !

!Usuario methodsFor: 'as yet unclassified' stamp: 'PRD 2/15/2015 21:51'!
descriptionPassword
	<magritteDescription>
	passwordHash ifNotNil: [ ^nil ].
	^MAPasswordDescription new
		accessor: #password;
		readonly: passwordHash notNil;
		beRequired;
		requiredErrorMessage: 'You need to input a password';
		comment: 'Please enter your password';
		label: 'Password';
		priority: 200;
		visibleInReport: false;
		yourself! !

!Usuario methodsFor: 'as yet unclassified' stamp: 'PRD 2/15/2015 21:51'!
descriptionPasswordVerify
	<magritteDescription>
	passwordHash ifNotNil: [ ^nil ].
	^MAPasswordDescription new
		accessor: #passwordVerify;
		readonly: passwordHash notNil;
		beRequired;
		requiredErrorMessage: 'You need to input a password verification';
		comment: 'Please retype your password for verification';
		label: 'Password (Check)';
		priority: 210;
		visibleInReport: false;
		yourself! !

!Usuario methodsFor: 'as yet unclassified' stamp: 'PRD 2/15/2015 02:18'!
descriptionRoles
	<magritteDescription>
	self userid ifNil: [ ^nil ].
	^MAMultipleOptionDescription new
		accessor: #roles;
		label: 'Roles';
		comment: 'Rol de usuario';
		priority: 500;
		optionsAndLabels: (( self session collection: RolUsuario ) collect: [:each | Association key: each  value: each rolName  ])  ;
		visibleInLabel: false;
		visibleInReport: true;
		yourself! !

!Usuario methodsFor: 'as yet unclassified' stamp: 'PRD 2/14/2015 23:45'!
descriptionUserid
	<magritteDescription>
	^MAStringDescription new
		accessor: #userid;
		readonly: userid notNil;
		beRequired;
		comment: 'Identificación de usuario';
		label: 'Userid';
		priority: 50;
		visibleInReport: false;
		yourself! !

!Usuario methodsFor: 'accessing' stamp: 'PRD 2/15/2015 01:28'!
hashPassword: aString
	^GRPlatform current secureHashFor: aString ! !

!Usuario methodsFor: 'as yet unclassified' stamp: 'PRD 2/15/2015 00:00'!
isAdminUser
	^self roles contains: [ :each | each isAdministrador ]! !

!Usuario methodsFor: 'accessing' stamp: 'PRD 2/14/2015 23:32'!
nombreUsuario
	^ nombreUsuario! !

!Usuario methodsFor: 'accessing' stamp: 'PRD 2/14/2015 23:32'!
nombreUsuario: anObject
	nombreUsuario := anObject! !

!Usuario methodsFor: 'as yet unclassified' stamp: 'PRD 2/15/2015 12:23'!
onAboutToDelete
	self roles do: [ :c | self remove: c . self session remove: c].
	^ true! !

!Usuario methodsFor: 'as yet unclassified' stamp: 'PRD 2/16/2015 11:08'!
password
	self passwordHash ifNil: [ ^nil ].
	^'***'! !

!Usuario methodsFor: 'as yet unclassified' stamp: 'PRD 2/14/2015 23:46'!
password: anObject
	strPassword := anObject.
	passwordHash := self hashPassword: anObject! !

!Usuario methodsFor: 'accessing' stamp: 'PRD 2/19/2015 17:46'!
passwordHash
	strPassword ifNil:  [ ^nil ].
	^ self hashPassword: strPassword ! !

!Usuario methodsFor: 'accessing' stamp: 'PRD 2/14/2015 23:47'!
passwordHash: anObject
	passwordHash := anObject.! !

!Usuario methodsFor: 'magritte-description' stamp: 'PRD 2/15/2015 01:27'!
passwordVerify
	passwordHash ifNil: [ ^nil ].
	^'***'! !

!Usuario methodsFor: 'as yet unclassified' stamp: 'PRD 2/15/2015 01:27'!
passwordVerify: anObject
	" dummy "! !

!Usuario methodsFor: 'accessing' stamp: 'PRD 2/15/2015 12:41'!
rightsFor: aMAToManyRelationDescription 
	^ #('C' 'R' 'U' 'D')! !

!Usuario methodsFor: 'accessing' stamp: 'PRD 2/15/2015 01:29'!
roles
	^ roles ifNil: [ roles := OrderedCollection new ]! !

!Usuario methodsFor: 'as yet unclassified' stamp: 'PRD 2/15/2015 01:39'!
roles: aOrderedCollection
	roles := aOrderedCollection! !

!Usuario methodsFor: 'accessing' stamp: 'PRD 2/15/2015 12:31'!
roots
	^self rootsFor: self model! !

!Usuario methodsFor: 'accessing' stamp: 'PRD 2/15/2015 12:32'!
rootsFor: aTarget
	| retVal |
	retVal := OrderedCollection new.
	aTarget magritteDescription do: [ :aDescription |
		aDescription isRoot ifTrue: [ 
			 | rights |
			rights := self rightsFor: aDescription.
			rights ifNotEmpty: [ 
				retVal add: aDescription ] ] ].
	^retVal
! !

!Usuario methodsFor: 'accessing' stamp: 'PRD 2/19/2015 18:35'!
strPassword: aString 
	strPassword := aString! !

!Usuario methodsFor: 'accessing' stamp: 'PRD 2/9/2015 14:30'!
userid
	^ userid! !

!Usuario methodsFor: 'accessing' stamp: 'PRD 2/9/2015 14:30'!
userid: anObject
	userid := anObject! !

!Usuario methodsFor: 'as yet unclassified' stamp: 'PRD 2/16/2015 10:56'!
verifyPassword: aString
	^(self hashPassword: aString) = self passwordHash.! !

!Usuario methodsFor: 'accessing' stamp: 'PRD 2/15/2015 14:07'!
wrongPassword
	" is called when user enters wrong password, can be used to block users if too many password attempts where made. See also correctPassword "! !

POSPersistentObject subclass: #Vendedor
	instanceVariableNames: 'nombre'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!Vendedor class methodsFor: 'as yet unclassified' stamp: 'PRD 4/28/2015 12:29'!
basicInitializeCollectionInSession: aSession

	aSession requireUnitOfWork.
	1 to: 5 do: [:c |  aSession save: ( super new initialize nombre: ( 'Vendedor' , c asString) ) ].
	aSession commitUnitOfWork.
! !

!Vendedor methodsFor: 'as yet unclassified' stamp: 'PRD 2/27/2015 09:37'!
descriptionNombre
	<magritteDescription>
	^ MAStringDescription new
		priority: 100;
		label: 'Nombre';
		comment: 'Nombre';
		accessor: #nombre;
		beRequired ;
		yourself! !

!Vendedor methodsFor: 'accessing' stamp: 'PRD 2/27/2015 09:37'!
nombre
	^ nombre! !

!Vendedor methodsFor: 'accessing' stamp: 'PRD 2/27/2015 09:37'!
nombre: anObject
	nombre := anObject! !

POSObject subclass: #PoliticaLetras
	instanceVariableNames: 'categoriaImpositivaEmisor categoriaImpositivaReceptor letras'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!PoliticaLetras class methodsFor: 'creation' stamp: 'PRD 12/11/2014 00:14'!
ejemplo
	| ejemplo |
	ejemplo := super new initialize categoriaImpositivaEmisor: POSSession noSeaside categoriaResponsableInscripto  ;
				categoriaImpositivaReceptor: #( ( POSSession noSeaside categoriaResponsableInscripto ) (POSSession noSeaside categoriaResponsableNoInscripto))  ; 
				letras: #( 'A' 'B' 'R' ) ; yourself.


	^ ejemplo
! !

!PoliticaLetras class methodsFor: 'creation' stamp: 'PRD 12/10/2014 23:56'!
ejemplo1
	| ejemplo |
	ejemplo := super new initialize categoriaImpositivaEmisor: POSSession noSeaside categoriaResponsableInscripto  ;
				categoriaImpositivaReceptor: #( ( POSSession noSeaside categoriaConsumidorFinal ) (POSSession noSeaside categoriaExento) (POSSession noSeaside categoriaMonotributo))  ; 
				letras: #(  'B' 'R' ) ; yourself.

	^ ejemplo! !

!PoliticaLetras class methodsFor: 'creation' stamp: 'PRD 12/10/2014 23:57'!
ejemplo2
	| ejemplo |
	ejemplo := super new initialize
		categoriaImpositivaEmisor: POSSession noSeaside categoriaExento;
		categoriaImpositivaReceptor:
				#(	(POSSession noSeaside categoriaConsumidorFinal) 
					(POSSession noSeaside categoriaExento) 
					(POSSession noSeaside categoriaMonotributo)
					(POSSession noSeaside categoriaResponsableInscripto)
					(POSSession noSeaside categoriaResponsableNoInscripto));
		letras: #('C' 'R');
		yourself.
	^ ejemplo ! !

!PoliticaLetras class methodsFor: 'accessing - properties' stamp: 'PRD 7/22/2014 21:17'!
hasUserRights
	^ false! !

!PoliticaLetras methodsFor: 'accessing' stamp: 'PRD 9/19/2014 02:15'!
categoriaImpositivaEmisor
	^ categoriaImpositivaEmisor! !

!PoliticaLetras methodsFor: 'accessing' stamp: 'PRD 9/19/2014 02:15'!
categoriaImpositivaEmisor: anObject
	categoriaImpositivaEmisor := anObject! !

!PoliticaLetras methodsFor: 'accessing' stamp: 'PRD 9/19/2014 02:15'!
categoriaImpositivaReceptor
	^ categoriaImpositivaReceptor! !

!PoliticaLetras methodsFor: 'accessing' stamp: 'PRD 9/19/2014 02:15'!
categoriaImpositivaReceptor: anObject
	categoriaImpositivaReceptor := anObject! !

!PoliticaLetras methodsFor: 'accessing' stamp: 'PRD 9/19/2014 02:35'!
letras
	^ letras! !

!PoliticaLetras methodsFor: 'accessing' stamp: 'PRD 9/19/2014 02:35'!
letras: anObject
	letras := anObject! !

POSObject subclass: #Precio
	instanceVariableNames: 'item valor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!Precio class methodsFor: 'as yet unclassified' stamp: 'PRD 9/14/2014 23:23'!
item: anItem valor: aPrecio
	^ super new item: anItem ; valor: aPrecio; yourself! !

!Precio methodsFor: 'accessing' stamp: 'PRD 9/14/2014 23:18'!
item
	^ item! !

!Precio methodsFor: 'accessing' stamp: 'PRD 9/14/2014 23:18'!
item: anObject
	item := anObject! !

!Precio methodsFor: 'accessing' stamp: 'PRD 9/14/2014 23:18'!
valor
	^ valor! !

!Precio methodsFor: 'accessing' stamp: 'PRD 9/14/2014 23:18'!
valor: anObject
	valor := anObject! !

POSPersistentObject subclass: #ComprobanteVenta
	instanceVariableNames: 'fecha nro items estado importeAplicadoHaber importeAplicadoDebe aplicacionesA aplicacionesDe terminado pagos cliente factor nroLegal puntoVenta movimientoStock cuitCliente razonSocialCliente categoriaImpositivaCliente direccionCliente tipoComprobante letra impuestos descuentoGeneral impreso rendicionCaja caja vendedor'
	classVariableNames: ''
	poolDictionaries: 'POSPool1'
	category: 'TPV-Model'!

!ComprobanteVenta class methodsFor: 'as yet unclassified' stamp: 'PRD 12/11/2014 12:06'!
aboutClearCollectionInSession: aSession
	aSession clearCollections: ({  ItemVenta. ImpuestoComprobante. PagoComprobante. AplicacionComprobante.} asOrderedCollection ).
! !

!ComprobanteVenta class methodsFor: 'creation' stamp: 'PRD 4/17/2015 13:15'!
dumb
"	^ self dumbInSession: self session"
	^ super new initialize.! !

!ComprobanteVenta class methodsFor: 'calculo' stamp: 'PRD 2/19/2015 23:16'!
ejemplo1

	|  lista c lista1 cliente  ses |

	ses := POSSession noSeaside.
	ses clearCollection: ComprobanteVenta.


	lista := ses listaPrecioBase.
	c := ComprobanteVenta new.
	c generaItemsFromListaPrecio: lista cantidad: 10 nroItems: 100 inSession: ses.			
	ses saveAndCommit: c.	
		
	lista1 := ses listaPrecioDoble.
	cliente := ses clienteConsumidorFinal listaPrecio: lista1.
	c cliente: cliente.	
	ses saveAndCommit: c.	

	^ c		
! !

!ComprobanteVenta class methodsFor: 'calculo' stamp: 'PRD 2/19/2015 23:17'!
ejemplo2

	|  lista cliente  c2 ses |
	
	ses := POSSession noSeaside.
	ses clearCollection: ComprobanteVenta.

	lista := ses listaPrecioBase.
	c2 := ComprobanteVenta new.
	
	1 to: 5 do: [ :index |  c2 addItem: (ItemVenta new item: (  (lista itemsLista at: index) item ) cantidad: 10 ) ].
	cliente := ses clienteConsumidorFinal  listaPrecio: lista.
	c2 cliente: cliente.
	ses save: c2.
		
	^ c2		
! !

!ComprobanteVenta class methodsFor: 'calculo' stamp: 'PRD 2/19/2015 23:17'!
ejemplo3

	|   c lista1 cliente  |	

	
	c := ComprobanteVenta new.
	
	c generaItemsFromListaPrecio: c session listaPrecioBase cantidad: 10 nroItems: 40.
	
	c saveAndCommit .
		
	lista1 := c session listaPrecioDoble.
	cliente := c session clienteConsumidorFinal  listaPrecio: lista1.
	cliente saveAndCommit .
	
	c cliente: cliente.
	c addPago: (PagoComprobante medioPago: c session medioPagoEfectivo  importe: c importeTotal).
	^ c	 saveAndCommit 	
! !

!ComprobanteVenta class methodsFor: 'calculo' stamp: 'PRD 4/17/2015 23:09'!
ejemplo4

	|  lista c    col   nro |


	col := OrderedCollection new.
	lista := ListaPrecio listaPrecioBase.
	self session beginUnitOfWork .
	nro := self proximoNumero.
		
	nro to: ( nro + 4 ) do: [:i | 
		 c := (ComprobanteVenta "dumbInSession: ses" dumb ) nro: i; yourself.
		 ( lista itemsLista copyFrom:1 to: 10 ) do: [:it | c addItem: (ItemVenta new item: it item cantidad: 10)  ].
		c addPago: (PagoComprobante medioPago: MedioPago efectivo   importe: c importeTotal / 2).
		c addPago: (PagoComprobante medioPago: MedioPago tarjetaCredito   importe: c importeTotal / 2 ).
		c cierre.
		c save.																																											
	   col add: c.		
	].
	self session commitUnitOfWork .
	^ col! !

!ComprobanteVenta class methodsFor: 'calculo' stamp: 'PRD 4/17/2015 23:10'!
ejemplo6

	|  lista c lista1 cliente  col  ses |
	
	ses := 	POSSession noSeaside.

	ses beginUnitOfWork.
	lista := ses listaPrecioBase.
	col := OrderedCollection new.

				
	1 to: 5 do: [:i |
		c := ComprobanteVenta new.
		1 to: 80 do: [ :index |  c addItem: (ItemVenta new item: ( lista itemsLista at: index) item cantidad: 10 ) ].
		ses save:c.
		lista1 := ListaPrecio new.
		lista itemsLista do: [ :itemLista | lista1 addItem: itemLista item precio: (itemLista precio * 2 )].
		cliente := ses clienteConsumidorFinal listaPrecio: lista1.
		c cliente: cliente.
		c addPago: (PagoComprobante medioPago: MedioPago efectivo   importe: c importeTotal / 2).
		c addPago: (PagoComprobante medioPago: MedioPago tarjetaCredito importe: c importeTotal / 2 ).
      col add: c.		
	].
	ses commitUnitOfWork.
	^ col! !

!ComprobanteVenta class methodsFor: 'calculo' stamp: 'PRD 4/22/2015 08:48'!
ejemplo7

	|   c col nro r1 r2 r3 r importe1 importe0 importe2 |

	col := OrderedCollection new.
	
	self session reset.
	
	r := Random new.
	r1 := Random new.
	r2 := Random new.
	r3 := Random new.


	nro := ComprobanteVenta  proximoNumero.
	self session beginUnitOfWork .		
	nro to: ( nro + (r nextInt: 1000 ) ) do: [:i | 

		 c := (ComprobanteVenta  dumb ) nro: i; yourself.
		1 to: ( r1 nextInt: 100 ) do: [:it | |item1|
			item1 := self session readOneOf: Item where: [:each | each codigo = (r2 nextInt: 1000)  ].
			c addItem: (ItemVenta new item: item1 cantidad: (r3 nextInt: 100))  ].
		
		
		importe0 := c importeTotal asImporte.
		importe1 := ( importe0 / 2 ) asImporte. 
		importe2 := (importe0 - importe1 ) asImporte.

		c addPago: (PagoComprobante medioPago: MedioPago efectivo   importe: importe1).
		c addPago: (PagoComprobante medioPago: MedioPago tarjetaCredito   importe: importe2).
		c cierre.
		c save.																																											
		(c importeTotal = c importePago ) ifFalse: [ self halt ].
		col add: c.	
	].
	self session commitUnitOfWork .	

	^ col
! !

!ComprobanteVenta class methodsFor: 'as yet unclassified' stamp: 'PRD 4/22/2015 08:32'!
ejemplo8

	|   c col nro r1 r2 r3 r importe1 importe0 importe2 |

	col := OrderedCollection new.
	self session reset.

	r := Random new.
	r1 := Random new.
	r2 := Random new.
	r3 := Random new.


	nro := ComprobanteVenta  proximoNumero.
		
	nro to: ( nro + (r nextInt: 1000 ) ) do: [:i | 
		self session beginUnitOfWork .
		 c := (ComprobanteVenta dumb ) nro: i; yourself.
		1 to: ( r1 nextInt: 100 ) do: [:it | |item1|
			item1 := self session readOneOf: Item where: [:each | each codigo = (r2 nextInt: 1000)  ].
			c addItem: (ItemVenta new item: item1 cantidad: (r3 nextInt: 100))  ].
		
		
		importe0 := c importeTotal asImporte.
		importe1 := ( importe0 / 2 ) asImporte. 
		importe2 := (importe0 - importe1 ) asImporte.

		c addPago: (PagoComprobante medioPago: MedioPago efectivo  importe: importe1).
		c addPago: (PagoComprobante medioPago: MedioPago tarjetaCredito   importe: importe2).
		c calculaImpuestos .
		c save.																																											
		self session commitUnitOfWork .	
		(c importeTotal = c importePago ) ifFalse: [ self halt ].
		col add: c.	
	].

	^ col
! !

!ComprobanteVenta class methodsFor: 'calculo' stamp: 'PabloDigonzelli 5/15/2014 22:34'!
estadoVigente
	^ #vigente! !

!ComprobanteVenta class methodsFor: 'accessors' stamp: 'PabloDigonzelli 5/15/2014 22:32'!
estados
	^ #(#vigente #anulado)! !

!ComprobanteVenta class methodsFor: 'accessors' stamp: 'PRD 4/17/2015 21:00'!
partidaPorDefecto
	^ self session partidaDebe! !

!ComprobanteVenta class methodsFor: 'calculo' stamp: 'PRD 12/14/2014 01:52'!
proximoNumero
	| n |
	 n := self session findMax: self using: #nro.
	^ n ifNil: [ 1 ] ifNotNil: [ n + 1 ]! !

!ComprobanteVenta class methodsFor: 'collection ops' stamp: 'PRD 12/20/2014 07:09'!
rendicion: aRendicionCaja 
	^ self rendicion: aRendicionCaja inSession: self session! !

!ComprobanteVenta class methodsFor: 'collection ops' stamp: 'PRD 12/20/2014 07:09'!
rendicion: aRendicionCaja inSession: aSession
	^ aSession readManyOf: self where: [:com | com rendicionCaja = aRendicionCaja   ]! !

!ComprobanteVenta class methodsFor: 'collection' stamp: 'PRD 12/20/2014 06:53'!
sinRendir
	^ self sinRendirInSession: self session! !

!ComprobanteVenta class methodsFor: 'collection' stamp: 'PRD 12/20/2014 19:35'!
sinRendirCaja: aCaja
	^ self sinRendirCaja: aCaja inSession: self session! !

!ComprobanteVenta class methodsFor: 'collection' stamp: 'PRD 4/17/2015 21:06'!
sinRendirCaja: aCaja inSession: aSession
	^ aSession sinRendirCaja: aCaja! !

!ComprobanteVenta class methodsFor: 'collection' stamp: 'PRD 12/20/2014 15:55'!
sinRendirInSession: aSession
	^ aSession readManyOf: ComprobanteVenta where: [ :each | each estado = 'vigente' AND: [ each rendicionCaja = nil ] ]! !

!ComprobanteVenta class methodsFor: 'accessors' stamp: 'PRD 12/14/2014 01:53'!
valoresPartida
	^ self session partidas! !

!ComprobanteVenta methodsFor: 'as yet unclassified' stamp: 'PRD 11/13/2014 10:05'!
actualizaPreciosItems
	self items do: [:it | it precioUnitario ].! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PabloDigonzelli 6/7/2014 19:21'!
addAplicacionA: anAplicacionComprobante 
	self aplicacionesA add: anAplicacionComprobante .! !

!ComprobanteVenta methodsFor: 'calculos' stamp: 'PabloDigonzelli 6/7/2014 19:21'!
addAplicacionDe: anAplicacionComprobante 
	self aplicacionesDe add: anAplicacionComprobante .
! !

!ComprobanteVenta methodsFor: 'creating' stamp: 'PRD 10/4/2014 03:06'!
addImpuesto: anImpuestoComprobante 
	| i |
	( i :=  ( self impuestos collect: [:each | each impuesto  ] ) indexOf: anImpuestoComprobante impuesto  ) = 0 	ifTrue: [ impuestos add: anImpuestoComprobante  ]
		 																											ifFalse: [  impuestos at: i put: anImpuestoComprobante ].

	anImpuestoComprobante comprobante: self.! !

!ComprobanteVenta methodsFor: 'calculo' stamp: 'PRD 4/15/2015 10:25'!
addItem: anItemVenta
	| precioUnitario |
	terminado
		ifTrue: [ Error new signal: 'Comprobante cerrado . No se puede modificar' ].		
	precioUnitario := self listaPrecio yourself precioParaItem: anItemVenta item.
	( precioUnitario isNil or: [ precioUnitario <= 0 ]) ifTrue: [ precioUnitario := anItemVenta item precioMinorista ].
	(precioUnitario notNil and: [ precioUnitario > 0 ])
		ifTrue: [ 
			anItemVenta item vendible
				ifFalse: [ ^ Error signal: 'Este item no esta configurado para la venta' ] ]
		ifFalse: [ ^ Error signal: 'Este item no esta configurado para la venta' ].
	anItemVenta precioUnitario: precioUnitario asImporte.
	anItemVenta comprobante: self.
	self items addLast: anItemVenta.
! !

!ComprobanteVenta methodsFor: 'calculos' stamp: 'PRD 10/5/2014 01:07'!
addPago: aPagoComprobante 
	self pagos add: aPagoComprobante .
	aPagoComprobante comprobante: self.! !

!ComprobanteVenta methodsFor: 'calculos' stamp: 'PabloDigonzelli 6/7/2014 19:04'!
aplicaA: aComprobanteVenta 
	
	|aplicacion|	
	
	aplicacion := AplicacionComprobante aplicante: self aplicado: aComprobanteVenta. 


	aComprobanteVenta addAplicacionDe: aplicacion.
	self addAplicacionA:  aplicacion.
		! !

!ComprobanteVenta methodsFor: 'calculos' stamp: 'PabloDigonzelli 6/8/2014 12:15'!
aplicaA: aComprobanteVenta importe: aImporte 
	|aplicacion|	
	
	aplicacion :=  AplicacionComprobante aplicante: self aplicado: aComprobanteVenta importeAplicante: aImporte.

	aComprobanteVenta addAplicacionDe: aplicacion.
	self addAplicacionA:  aplicacion.
		! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PabloDigonzelli 6/7/2014 18:53'!
aplicacionesA
	^ aplicacionesA! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 9/25/2014 10:58'!
aplicacionesA: anObject
	aplicacionesA := anObject! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PabloDigonzelli 6/7/2014 19:03'!
aplicacionesDe
	^ aplicacionesDe! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 9/25/2014 10:58'!
aplicacionesDe: anObject
	aplicacionesDe := anObject! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 10/9/2014 16:31'!
caja
	^ caja! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 10/9/2014 16:31'!
caja: anObject
	caja := anObject! !

!ComprobanteVenta methodsFor: 'calculations' stamp: 'PRD 10/4/2014 00:25'!
calculaImpuesto: anImpuesto
	self impuestos
		detect: [ :imp | imp impuesto = anImpuesto ]
		ifNone: [ 
			self
				addImpuesto:
					(ImpuestoComprobante impuesto: anImpuesto valor: self importeNeto abs * anImpuesto porcentaje + anImpuesto fijo) ]! !

!ComprobanteVenta methodsFor: 'impuestos' stamp: 'PRD 3/10/2015 01:26'!
calculaImpuestos
	impuestos := OrderedCollection new.
	self importeNeto > 0		ifFalse: [ ^ self ].
	self impuestosItems do: [ :each | self addImpuesto: each ].

	! !

!ComprobanteVenta methodsFor: 'as yet unclassified' stamp: 'PRD 3/11/2015 02:54'!
cantItems
	^ self items size! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 9/30/2014 16:13'!
categoriaImpositivaCliente
	^ categoriaImpositivaCliente! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 4/14/2015 10:06'!
categoriaImpositivaCliente: aCategoriaImpositiva 
	categoriaImpositivaCliente := aCategoriaImpositiva ! !

!ComprobanteVenta methodsFor: 'accessors' stamp: 'PRD 10/4/2014 11:34'!
cerrado
	^ terminado ! !

!ComprobanteVenta methodsFor: 'calculo' stamp: 'PRD 2/25/2015 13:14'!
cierre
	self calculaImpuestos .
	terminado := true.
! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PabloRobertoDigonzelli 6/17/2014 00:34'!
cliente
	^ cliente! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 4/14/2015 10:06'!
cliente: aCliente 
	cliente := aCliente. 
	self factor: aCliente factor.
	self cuitCliente: aCliente cuit.
	self razonSocialCliente: aCliente razonSocial.
	self direccionCliente: (DireccionComprobante from: aCliente direccion).
	self categoriaImpositivaCliente: aCliente categoriaImpositiva .
! !

!ComprobanteVenta methodsFor: 'calculos' stamp: 'PRD 9/30/2014 15:44'!
contraPartida
	^ self tipoComprobante contraPartida! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 9/30/2014 16:13'!
cuitCliente
	^ cuitCliente! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 2/16/2015 14:30'!
cuitCliente: anInteger 
	cuitCliente := anInteger.
! !

!ComprobanteVenta methodsFor: 'calculos' stamp: 'PabloDigonzelli 6/8/2014 12:53'!
desaplica: aComprobanteVenta 
	
	self aplicacionesDe select: [:each | each aplicante == aComprobanteVenta  ] 
		thenDo:   [:each | self aplicacionesDe remove: each].
	aComprobanteVenta  aplicacionesA select: [:each | each aplicado == self  ] 
		thenDo:   [:each | aComprobanteVenta  aplicacionesA remove: each].
	 ! !

!ComprobanteVenta methodsFor: 'as yet unclassified' stamp: 'PRD 8/7/2014 18:54'!
descriptionFecha
	<magritteDescription>
	^ MADateDescription new
		accessor: #fecha;
		priority: 10;
		label: 'Fecha';
		beReadonly ;
		yourself! !

!ComprobanteVenta methodsFor: 'as yet unclassified' stamp: 'PRD 8/7/2014 17:00'!
descriptionItems
	<magritteDescription>
	^ MAToManyRelationDescription new
		label: 'Productos';
		accessor: #items;
		priority: 100;
		classes: {ItemVenta};
		yourself! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 10/4/2014 00:06'!
descuentoGeneral
	^ descuentoGeneral! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 10/4/2014 00:10'!
descuentoGeneral: anObject
	descuentoGeneral := anObject asImporte! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 9/30/2014 16:13'!
direccionCliente
	^ direccionCliente! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 2/16/2015 14:30'!
direccionCliente: aDireccion 
	direccionCliente := aDireccion.
! !

!ComprobanteVenta methodsFor: 'accessors' stamp: 'PabloDigonzelli 5/15/2014 22:31'!
estado
	^ estado! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 9/25/2014 10:58'!
estado: anObject
	estado := anObject! !

!ComprobanteVenta methodsFor: 'calculo' stamp: 'PRD 12/7/2014 18:00'!
existeComprobanteNro: anInteger 
	^self findByNro: anInteger.
! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 9/25/2014 10:58'!
factor
	^ factor! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PabloRobertoDigonzelli 6/17/2014 00:37'!
factor: aFloat
	factor := aFloat! !

!ComprobanteVenta methodsFor: 'accessors' stamp: 'PabloDigonzelli 5/9/2014 15:55'!
fecha
	^ fecha! !

!ComprobanteVenta methodsFor: 'accessors' stamp: 'PabloDigonzelli 6/8/2014 14:36'!
fecha: aDate 
	terminado ifTrue: [ ^ Error new signal: 'Comprobante Terminado . No se puede modificar'].
	fecha := aDate! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 12/11/2014 15:07'!
findByNro: anInteger 
	^ ( self session find: self class with:#nro value: anInteger ) notNil ! !

!ComprobanteVenta methodsFor: 'creation' stamp: 'PRD 12/20/2014 04:37'!
generaItemsFromListaPrecio: aListaPrecio cantidad: anInteger 
	self generaItemsFromListaPrecio: aListaPrecio cantidad: anInteger inSession: self session! !

!ComprobanteVenta methodsFor: 'creation' stamp: 'PRD 12/20/2014 04:34'!
generaItemsFromListaPrecio: aListaPrecio cantidad: anInteger inSession: aSession
		( aSession gsession readManyOf: ItemListaPrecio  where: [:each | each listaPrecio = aListaPrecio   ]  limit: 40 )  
			do: [ :i | self addItem:  ( ItemVenta new item:  i item ; cantidad: anInteger ; yourself)  ].	
! !

!ComprobanteVenta methodsFor: 'creation' stamp: 'PRD 12/20/2014 04:37'!
generaItemsFromListaPrecio: aListaPrecio cantidad: anInteger nroItems: nroItems
	self generaItemsFromListaPrecio: aListaPrecio cantidad: anInteger nroItems: nroItems inSession: self session.
! !

!ComprobanteVenta methodsFor: 'creation' stamp: 'PRD 12/20/2014 04:37'!
generaItemsFromListaPrecio: aListaPrecio cantidad: anInteger nroItems: nroItems inSession: aSession
		( aSession gsession readManyOf: ItemListaPrecio  where: [:each | each listaPrecio = aListaPrecio   ]  limit: nroItems )  
			do: [ :i | self addItem:  ( ItemVenta new item:  i item ; cantidad: anInteger ; yourself)  ].	
! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 9/25/2014 10:58'!
importeAplicadoDebe
	^ importeAplicadoDebe! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 9/25/2014 10:58'!
importeAplicadoDebe: anObject
	importeAplicadoDebe := anObject! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 9/25/2014 10:58'!
importeAplicadoHaber
	^ importeAplicadoHaber! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 9/25/2014 10:58'!
importeAplicadoHaber: anObject
	importeAplicadoHaber := anObject! !

!ComprobanteVenta methodsFor: 'impuestos' stamp: 'PRD 10/6/2014 13:13'!
importeImpuestos
	   self calculaImpuestos .
	^ ( self impuestos inject: 0 into: [:sum :item | sum + item valor ] ) asImporte! !

!ComprobanteVenta methodsFor: 'calculo' stamp: 'PRD 3/10/2015 01:54'!
importeNeto
	"^ (( self items inject: 0  into: [ :sum :each |  sum + each importeNeto  ])  - descuentoGeneral )  asImporte ."
	^ (( self items inject: 0  into: [ :sum :each |  sum + each neto  ])  - descuentoGeneral )  asImporte .
! !

!ComprobanteVenta methodsFor: 'calculo' stamp: 'PRD 3/5/2015 02:15'!
importePago
	^ ( self pagos inject: 0 into: [:sum :each | sum + each importe ] ) asImporte! !

!ComprobanteVenta methodsFor: 'calculo' stamp: 'PRD 3/10/2015 03:00'!
importeTotal
	^ ( self importeNeto + self importeImpuestos ) asImporte.
	
! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 10/6/2014 17:50'!
impreso
	^ impreso! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 10/6/2014 17:50'!
impreso: anObject
	impreso := anObject! !

!ComprobanteVenta methodsFor: 'as yet unclassified' stamp: 'PRD 12/2/2014 11:03'!
imprime
	| mensaje |
	mensaje := self validaImportesYPagos .
	mensaje = 'ok' ifTrue: [self impreso: true].
	^ mensaje

! !

!ComprobanteVenta methodsFor: 'impuestos' stamp: 'PRD 10/3/2014 20:48'!
impuestos
	^ impuestos! !

!ComprobanteVenta methodsFor: 'impuestos' stamp: 'PRD 3/10/2015 02:59'!
impuestosItems
	| dict col dict1 |
	dict := Dictionary new.
	dict1 := Dictionary new.
	self items
		do: [ :it | 
			it calculaImpuestos
				do: [ :im | 
					| val |
					val := dict at: im impuesto idUnico ifAbsent: [ 0.00 asImporte ].
					dict at: im impuesto idUnico put: val + im valor ] ].
	col := OrderedCollection new.
	dict
		associationsDo: [ :a | 
			col
				add:
					(ImpuestoComprobante impuesto: (self session selectOne: Impuesto where: [ :i | i idUnico = a key ]) valor: a value) ].
	^ col! !

!ComprobanteVenta methodsFor: 'initialization' stamp: 'PRD 4/17/2015 23:19'!
initialize
	super initialize.
	estado  := #vigente.
	terminado := false.
	self fecha: Date today.
	importeAplicadoHaber := 0.00.
	importeAplicadoDebe := 0.00.
	descuentoGeneral := 0.00.
	aplicacionesA := OrderedCollection new.
	aplicacionesDe := OrderedCollection new.
	pagos := OrderedCollection new.
	factor := 0.0.
	items := OrderedCollection new.
	
	self cliente: Cliente clienteConsumidorFinal .
	
	self session  empresa isNil 
		ifFalse: [ letra := ( LetraPermitida empresa: self session empresa  cliente: self cliente ) first .
				  puntoVenta := self session empresa primerPuntoVenta]
		ifTrue: [ letra := LetraPermitida default ].
	caja := self session caja.  
	self tipoComprobante:  ( TipoComprobante tipoComprobantePorDefecto:letra).	
	self vendedor: (self session collection: Vendedor)	first.
	impuestos := OrderedCollection new.	
	impreso := false.
	self nro: self proximoNumero.
	
! !

!ComprobanteVenta methodsFor: 'initialization' stamp: 'PRD 4/17/2015 23:23'!
initialize: aSession
	super initialize.
	estado  := #vigente.
	terminado := false.
	self fecha: Date today.
	importeAplicadoHaber := 0.00.
	importeAplicadoDebe := 0.00.
	descuentoGeneral := 0.00.
	aplicacionesA := OrderedCollection new.
	aplicacionesDe := OrderedCollection new.
	pagos := OrderedCollection new.
	factor := 0.0.
	items := OrderedCollection new.
	self cliente: aSession clienteConsumidorFinal .
	
	aSession  empresa isNil 
		ifFalse: [ letra := ( LetraPermitida empresa: aSession empresa  cliente: self cliente ) first .
				  puntoVenta := aSession empresa primerPuntoVenta]
		ifTrue: [ letra := LetraPermitida default ].
	caja := aSession caja.  
	self tipoComprobante:  ( TipoComprobante tipoComprobantePorDefecto:letra).	
	impuestos := OrderedCollection new.	
	impreso := false.
	self nro: ( self proximoNumero: aSession).
	
! !

!ComprobanteVenta methodsFor: 'calculos' stamp: 'PRD 3/11/2015 15:05'!
isAnulable

	^ self tipoComprobante isRecibo ifFalse: [  ( self aplicacionesA  isEmpty & self aplicacionesDe isEmpty)  ]! !

!ComprobanteVenta methodsFor: 'as yet unclassified' stamp: 'PRD 3/11/2015 15:01'!
isCerrado
	^ terminado ! !

!ComprobanteVenta methodsFor: 'accessors' stamp: 'PabloDigonzelli 5/12/2014 02:01'!
items
	items isNil ifTrue: [ items := OrderedCollection new ] .
	^ items
! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 8/7/2014 18:23'!
items: aCollection 
"	items := aCollection"! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 9/30/2014 16:10'!
letra
	^ letra! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 9/30/2014 16:13'!
letra: anObject
	letra := anObject! !

!ComprobanteVenta methodsFor: 'calculating' stamp: 'PRD 11/13/2014 19:19'!
listaPrecio
	^ self cliente listaPrecio! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 11/22/2014 13:02'!
listaPrecio: aListaPrecio 
	^ Error signal:'Las listas de precios se asignan a través del cliente'! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 9/25/2014 11:00'!
movimientoStock
	^ movimientoStock! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 9/25/2014 11:00'!
movimientoStock: anObject
	movimientoStock := anObject! !

!ComprobanteVenta methodsFor: 'accessors' stamp: 'PabloDigonzelli 5/10/2014 12:39'!
nro
	^ nro! !

!ComprobanteVenta methodsFor: 'accessors' stamp: 'PRD 10/12/2014 15:58'!
nro: aNumero
	aNumero > 0 ifTrue: [ 
	(self existeComprobanteNro: aNumero) ifTrue: [ ^ Error new signal: 'Numero de comprobante existente'].  ].
	nro := aNumero! !

!ComprobanteVenta methodsFor: 'as yet unclassified' stamp: 'PRD 12/16/2014 19:29'!
nroItems
	^ self items size! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 9/25/2014 10:58'!
nroLegal
	^ nroLegal! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 9/25/2014 10:58'!
nroLegal: anObject
	nroLegal := anObject! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PabloDigonzelli 6/11/2014 19:35'!
pagos
	 ^ pagos! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 9/25/2014 10:58'!
pagos: anObject
	pagos := anObject! !

!ComprobanteVenta methodsFor: 'accessors' stamp: 'PRD 9/30/2014 15:42'!
partida
	^ tipoComprobante partida! !

!ComprobanteVenta methodsFor: 'calculo' stamp: 'PRD 4/10/2015 10:17'!
proximoNumero
	| n  |
	
	n := self session findMax: self class using: #nro.
	^ n ifNil: [ 1 ] ifNotNil: [ n + 1 ]! !

!ComprobanteVenta methodsFor: 'calculo' stamp: 'PRD 12/19/2014 04:06'!
proximoNumero: aSession
	| n |
	 n := aSession findMax: self class using: #nro.
	^ n ifNil: [ 1 ] ifNotNil: [ n + 1 ]! !

!ComprobanteVenta methodsFor: 'as yet unclassified' stamp: 'PRD 12/6/2014 21:27'!
puedeCancelarse
	self impreso ifTrue:  [^ false].
	^ true! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 9/25/2014 11:00'!
puntoVenta
	^ puntoVenta! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 9/25/2014 11:00'!
puntoVenta: anObject
	puntoVenta := anObject! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 9/30/2014 16:13'!
razonSocialCliente
	^ razonSocialCliente! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 2/16/2015 14:30'!
razonSocialCliente: aString 
	razonSocialCliente := aString.
! !

!ComprobanteVenta methodsFor: 'calculos' stamp: 'PabloDigonzelli 6/15/2014 15:41'!
removePago: aPagoComprobante 
	|p|
	p := self pagos select:
		 [:each | each medioPago = aPagoComprobante medioPago and: [each importe = aPagoComprobante importe] ].
	p notNil ifTrue: [self pagos remove: aPagoComprobante  ifAbsent: [ ]]
	! !

!ComprobanteVenta methodsFor: 'as yet unclassified' stamp: 'PRD 12/17/2014 06:34'!
removePagos
	self pagos removeAll.! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 10/9/2014 16:31'!
rendicionCaja
	^ rendicionCaja! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 3/10/2015 15:14'!
rendicionCaja: anObject
	rendicionCaja := anObject! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PabloDigonzelli 6/8/2014 12:09'!
saldo
	^ self importeTotal   + 
	( self aplicacionesDe inject: 0 into: [:sum :each | sum + each importeAplicante ] ) -
	( self aplicacionesA inject: 0 into: [:sum :each | sum + each importeAplicante abs]). ! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 2/21/2015 01:33'!
saldoImportePago
	^ (self importeTotal abs - self importePago) asImporte ! !

!ComprobanteVenta methodsFor: 'calculos' stamp: 'PRD 9/26/2014 13:46'!
seAnula
	self isAnulable ifTrue: [  self estado: #anulado ] ifFalse: [ Error signal: 'Comprobante no anulable' ]
		! !

!ComprobanteVenta methodsFor: 'calculos' stamp: 'PRD 10/4/2014 11:34'!
signoPartida
	^ ( self partida == HABER ) ifTrue: [ -1] ifFalse: [ 1] ! !

!ComprobanteVenta methodsFor: 'calculation' stamp: 'PRD 10/9/2014 15:37'!
sinRendir
	^ rendicionCaja isNil! !

!ComprobanteVenta methodsFor: 'calculos' stamp: 'PRD 10/4/2014 00:38'!
subtotal
	^  ( self importeNeto abs  + descuentoGeneral  ) ! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PabloDigonzelli 6/8/2014 14:25'!
terminado
	^ terminado! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PabloDigonzelli 6/8/2014 14:26'!
terminado: aTrue 
	terminado := aTrue! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 9/30/2014 15:44'!
tipoComprobante
	^ tipoComprobante! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 9/30/2014 15:44'!
tipoComprobante: aTipoComprobante 
	tipoComprobante := aTipoComprobante! !

!ComprobanteVenta methodsFor: 'calculo' stamp: 'PRD 10/6/2014 18:16'!
validaCierre
	| mensaje |
	mensaje := self validaImportesYPagos.
	mensaje = 'ok' ifTrue: [ self impreso ifFalse: [ mensaje := 'Comprobante no impreso' ] ].
	^ mensaje! !

!ComprobanteVenta methodsFor: 'calculo' stamp: 'PRD 10/6/2014 18:09'!
validaImportesYPagos
	| mensaje |
	mensaje := 'ok'.
	(self importePago = self importeTotal and: [ self importeTotal ~= 0 ])
		ifFalse: [ mensaje := 'Comprobante no abonado' ].
	^ mensaje! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 2/27/2015 12:31'!
vendedor
	^ vendedor ! !

!ComprobanteVenta methodsFor: 'accessing' stamp: 'PRD 2/27/2015 10:59'!
vendedor: aVendedor 
	vendedor := aVendedor ! !

!ComprobanteVenta methodsFor: 'calculo' stamp: 'PabloDigonzelli 5/15/2014 22:34'!
vigente
	^ self estado == self class estadoVigente.! !

POSPersistentObject subclass: #Impuesto
	instanceVariableNames: 'porcentaje fijo descripcion condicion operaciones iva'
	classVariableNames: ''
	poolDictionaries: 'POSPool1'
	category: 'TPV-Model'!

!Impuesto class methodsFor: 'as yet unclassified' stamp: 'PRD 12/13/2014 13:24'!
basicInitializeCollectionInSession: aSession

	aSession beginUnitOfWork.
	aSession save:	self creaIva105.
	aSession save:  self creaIva21 .
	aSession save:  self creaPercepcionIB .
	aSession commitUnitOfWork.
! !

!Impuesto class methodsFor: 'as yet unclassified' stamp: 'PRD 12/13/2014 01:47'!
creaIva105
	^ super new initialize
		iva: true;
		porcentaje: 10.50;
		descripcion: 'IVA 10.5'! !

!Impuesto class methodsFor: 'as yet unclassified' stamp: 'PRD 12/13/2014 01:47'!
creaIva21
	^ super new initialize
		iva: true;
		porcentaje: 21.00;
		descripcion: 'IVA 21'
! !

!Impuesto class methodsFor: 'as yet unclassified' stamp: 'PRD 12/13/2014 01:47'!
creaPercepcionIB
	^ super new initialize
		iva: false;
		porcentaje: 2.50;
		descripcion: 'PERCEPCION IB 2.5'! !

!Impuesto class methodsFor: 'as yet unclassified' stamp: 'PRD 12/13/2014 01:47'!
creaPercepcionIB25
	^ super new initialize
		iva: false;
		porcentaje: 0.00;
		descripcion: 'PERCEPCION IB'! !

!Impuesto class methodsFor: 'creation' stamp: 'PRD 10/3/2014 17:37'!
iva
	^ super new initialize iva: true; yourself.! !

!Impuesto methodsFor: 'accessing' stamp: 'PRD 10/3/2014 15:17'!
condicion
	^ condicion! !

!Impuesto methodsFor: 'accessing' stamp: 'PRD 10/3/2014 15:17'!
condicion: anObject
	condicion := anObject! !

!Impuesto methodsFor: 'accessing' stamp: 'PRD 10/3/2014 21:29'!
descripcion
	^ descripcion! !

!Impuesto methodsFor: 'accessing' stamp: 'PRD 10/3/2014 21:39'!
descripcion: aString 
	descripcion:= aString 
	! !

!Impuesto methodsFor: 'as yet unclassified' stamp: 'PRD 10/6/2014 02:23'!
descriptionDescripcion
	<magritteDescription>
	^ MAMemoDescription new
		priority: 200;
		accessor: #descripcion;
		label: 'Descripcion';
		beRequired ;
		visibleInLabel: true;
		visibleInReport: true;
		yourself! !

!Impuesto methodsFor: 'as yet unclassified' stamp: 'PRD 11/28/2014 09:15'!
descriptionFijo
	<magritteDescription>
	^ MANumberDescription  new
		accessor: #fijo;
		label: 'Imp. Fijo';		
		priority: 400;
		beRequired ;
		comment: 'Importe Fijo';
		yourself! !

!Impuesto methodsFor: 'as yet unclassified' stamp: 'PRD 11/28/2014 09:15'!
descriptionPorcentaje
	<magritteDescription>
	^ MANumberDescription  new
		accessor: #porcentaje;
		label: 'Porcentaje';		
		priority: 300;
		beRequired ;
		comment: 'Alicuota';
		yourself! !

!Impuesto methodsFor: 'clasification' stamp: 'PRD 10/3/2014 20:34'!
esCompra
	^ self operaciones includes: COMPRA! !

!Impuesto methodsFor: 'clasification' stamp: 'PRD 10/3/2014 17:56'!
esVenta
	^ self operaciones includes: VENTA! !

!Impuesto methodsFor: 'accessorss' stamp: 'PRD 10/3/2014 17:31'!
fijo
	^ fijo! !

!Impuesto methodsFor: 'accesors' stamp: 'PRD 10/3/2014 17:31'!
fijo: aNumber 
	fijo := aNumber! !

!Impuesto methodsFor: 'as yet unclassified' stamp: 'PRD 10/14/2014 05:04'!
idUnico
	idUnico := self identificadorUnico  .
	^ idUnico! !

!Impuesto methodsFor: 'as yet unclassified' stamp: 'PRD 10/3/2014 21:33'!
identificadorUnico
	^ self descripcion , '|' , self porcentaje printAsImporte .! !

!Impuesto methodsFor: 'accessing' stamp: 'PRD 10/3/2014 17:57'!
initialize
	super initialize.
	iva := false.
	porcentaje := 0.00.
	fijo := 0.00.
	descripcion := ''.
	operaciones := {COMPRA. VENTA.}! !

!Impuesto methodsFor: 'accessing' stamp: 'PRD 10/3/2014 15:13'!
isIva
	^ iva == true! !

!Impuesto methodsFor: 'accessing' stamp: 'PRD 10/3/2014 15:13'!
iva: aTrue 
	iva := aTrue! !

!Impuesto methodsFor: 'as yet unclassified' stamp: 'PRD 10/6/2014 02:32'!
nombre 
	^ self descripcion ! !

!Impuesto methodsFor: 'accessing' stamp: 'PRD 10/3/2014 15:19'!
operaciones
	^ operaciones! !

!Impuesto methodsFor: 'accessing' stamp: 'PRD 10/3/2014 15:19'!
operaciones: anObject
	operaciones := anObject! !

!Impuesto methodsFor: 'accessors' stamp: 'PabloDigonzelli 5/13/2014 00:46'!
porcentaje
	^ porcentaje! !

!Impuesto methodsFor: 'accessors' stamp: 'PabloDigonzelli 5/13/2014 00:39'!
porcentaje: aPorcentaje
	porcentaje := aPorcentaje.! !

!Impuesto methodsFor: 'creation' stamp: 'PRD 10/3/2014 20:26'!
porcentaje: aPorcentaje valor: aNumber tipo: aString 
	self porcentaje: aPorcentaje ; fijo: aNumber .! !

!Impuesto methodsFor: 'item creation' stamp: 'PabloDigonzelli 6/9/2014 14:49'!
tipo: aString porcentaje: aPorcentaje fijo: aValor 
	 ^ self porcentaje: aPorcentaje valor: aValor tipo: aString! !

!Impuesto methodsFor: 'calculo' stamp: 'PRD 10/3/2014 17:37'!
valido
	^ ( (self porcentaje between: 0 and: 100)  ) and: [ self fijo >= 0 ]! !

!Impuesto methodsFor: 'calculos' stamp: 'PabloDigonzelli 6/9/2014 14:49'!
valorImpuestoSobre: aFloat
		 
	|v| 
	 v := self porcentaje ~= 0 ifTrue: [ aFloat * ( self porcentaje / 100 ) asFloat  ] ifFalse: [ 0 ].
	 v :=  v + self fijo. 
	^ v
! !

POSObject subclass: #LetraPermitida
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'POSPool1'
	category: 'TPV-Model'!

!LetraPermitida class methodsFor: 'default' stamp: 'PRD 9/30/2014 18:54'!
default
	^ ' '! !

!LetraPermitida class methodsFor: 'creation' stamp: 'PRD 2/22/2015 20:51'!
empresa: aEmpresa cliente: aCliente
	| letrasEmpresa letrasCliente retval|
	( aEmpresa categoriaImpositiva  = self session categoriaResponsableInscripto )  
		ifTrue: [ letrasEmpresa  := #('A' 'B' 'E' 'M') ]
		ifFalse: [  ( ( aEmpresa categoriaImpositiva  = self session  categoriaMonotributo  ) or: [  aEmpresa categoriaImpositiva  = self session  categoriaExento ] ) 
						ifTrue: [ letrasEmpresa := #('C') ]	
						ifFalse: [ letrasEmpresa := #('B') ] 			     
				].
	letrasEmpresa := #( ' ' 'X'  'R' )  copyWithAll: letrasEmpresa.
	aCliente ifNil: [ ^ letrasEmpresa  ].
	
	( aCliente categoriaImpositiva  = self session categoriaResponsableInscripto ) 
			 ifTrue: [ letrasCliente := #('A' 'B' 'E' 'M' ' ') ] 
			 ifFalse: [ letrasCliente := #('B') ]. 
		
	letrasCliente := #( ' ' 'X'  'R' ) copyWithAll: letrasCliente.
	
	retval := OrderedCollection new.
	
	letrasEmpresa do: [:each  | |l| 	l :=  letrasCliente detect: [:each1 | each1 = each  ] ifNone: [ nil ]. l notNil ifTrue: [ retval add: l  ] ].
	^ retval ! !

POSPersistentObject subclass: #Pais
	instanceVariableNames: 'nombre provincias'
	classVariableNames: ''
	poolDictionaries: 'POSPool1'
	category: 'TPV-Model'!

!Pais class methodsFor: 'as yet unclassified' stamp: 'PRD 9/17/2014 18:55'!
argentina
	^ self collection detect: [:each  | each nombre = 'Argentina' ] ifNone: [ nil]! !

!Pais class methodsFor: 'as yet unclassified' stamp: 'PRD 11/10/2014 22:43'!
collection
	^ Paises ! !

!Pais class methodsFor: 'as yet unclassified' stamp: 'PRD 9/17/2014 19:49'!
default
	^ self argentina! !

!Pais methodsFor: 'accessing' stamp: 'PRD 10/14/2014 20:01'!
addProvincia: aProvincia 
	self provincias detect: [:each | each nombre = aProvincia nombre ] ifNone: [self provincias add:  ( aProvincia  )]. ! !

!Pais methodsFor: 'accessing' stamp: 'PRD 9/17/2014 01:25'!
descriptionNombre
	<magritteDescription>
	^ MAStringDescription new
		priority: 100;
		label: 'Nombre';
		comment: 'Nombre del país';
		tooltip: 'Nombre del país';
		accessor: #nombre;
		beRequired ;
		yourself! !

!Pais methodsFor: 'accessing' stamp: 'PRD 9/17/2014 11:41'!
descriptionProvincias
	<magritteDescription>
	^ MAToManyRelationDescription  new
		priority: 200;
		label: 'Provincias';
		comment: 'Provincias del país';
		tooltip: 'Provincias del país';
		accessor: #provincias;
		classes: { Provincia };
		visibleInReport: false;
		beRequired ;
		yourself! !

!Pais methodsFor: 'as yet unclassified' stamp: 'PRD 9/17/2014 00:05'!
initialize
	super initialize.
	provincias := OrderedCollection new.! !

!Pais methodsFor: 'accessing' stamp: 'PRD 9/17/2014 00:09'!
nombre
	^ nombre! !

!Pais methodsFor: 'accessing' stamp: 'PRD 9/17/2014 00:09'!
nombre: anObject
	nombre := anObject! !

!Pais methodsFor: 'accessing' stamp: 'PRD 9/17/2014 00:09'!
provincias
	^ provincias! !

!Pais methodsFor: 'accessing' stamp: 'PRD 9/17/2014 00:09'!
provincias: anObject
	provincias := anObject! !

POSPersistentObject subclass: #Partida
	instanceVariableNames: 'partida'
	classVariableNames: ''
	poolDictionaries: 'POSPool1'
	category: 'TPV-Model'!

!Partida class methodsFor: 'as yet unclassified' stamp: 'PRD 12/17/2014 01:28'!
basicInitializeCollectionInSession: aSession
	aSession beginUnitOfWork.
	aSession save: self createDebe .
	aSession save: self createHaber .
	aSession commitUnitOfWork.! !

!Partida class methodsFor: 'as yet unclassified' stamp: 'PRD 12/17/2014 01:27'!
createDebe
	^super new partida: #debe
	! !

!Partida class methodsFor: 'as yet unclassified' stamp: 'PRD 12/17/2014 01:27'!
createHaber
	^ super new partida: #haber! !

!Partida methodsFor: 'as yet unclassified' stamp: 'PRD 11/22/2014 14:11'!
= anObject 
	anObject isGlorpProxy ifTrue: [ ^ anObject isKindOf: self class].				.
	( self class == anObject class ) ifFalse: [ ^false ].
	^ self partida = anObject partida! !

!Partida methodsFor: 'as yet unclassified' stamp: 'PRD 12/12/2014 00:47'!
contraPartida
	"comment stating purpose of message"

	^ ( self partida = #debe ) ifTrue: [ ^ self session partidaHaber ] ifFalse: [ self session partidaDebe ]! !

!Partida methodsFor: 'as yet unclassified' stamp: 'PRD 10/17/2014 00:20'!
hash 
	^ self partida hash! !

!Partida methodsFor: 'as yet unclassified' stamp: 'PRD 12/12/2014 00:47'!
isDebe
	"comment stating purpose of message"

	^ self == self session partidaDebe! !

!Partida methodsFor: 'as yet unclassified' stamp: 'PRD 12/12/2014 00:59'!
isHaber
	"comment stating purpose of message"

	^ self == self session partidaHaber! !

!Partida methodsFor: 'as yet unclassified' stamp: 'PRD 2/9/2015 10:56'!
nombre
	^ partida! !

!Partida methodsFor: 'accessing' stamp: 'PabloDigonzelli 6/7/2014 12:35'!
partida
	^ partida! !

!Partida methodsFor: 'accessing' stamp: 'PabloDigonzelli 6/7/2014 12:35'!
partida: anObject
	partida := anObject! !

POSPersistentObject subclass: #Provincia
	instanceVariableNames: 'nombre localidades'
	classVariableNames: ''
	poolDictionaries: 'POSPool1'
	category: 'TPV-Model'!

!Provincia class methodsFor: 'creation' stamp: 'PRD 9/17/2014 00:44'!
argentina
	^ Pais argentina provincias! !

!Provincia class methodsFor: 'creation' stamp: 'PRD 9/17/2014 19:25'!
default
	^ Pais argentina provincias detect: [:each | each nombre = 'Tucumán'  ] ifNone: [nil]! !

!Provincia class methodsFor: 'creating' stamp: 'PRD 9/17/2014 00:44'!
pais: aPais 
	^ aPais provincias! !

!Provincia methodsFor: 'accessing' stamp: 'PRD 9/17/2014 11:43'!
descriptionLocalidades
	<magritteDescription>
	^ MAToManyRelationDescription new 
		priority:300;
		label: 'Localidades';
		accessor: #localidades;
		tooltip: 'Localidades';
		comment: 'Localidades';
		classes: { Localidad } ;
		yourself
		
		! !

!Provincia methodsFor: 'accessing' stamp: 'PRD 9/17/2014 02:20'!
descriptionNombre
	<magritteDescription>
	^ MAStringDescription new
		label:'Nombre';
		accessor: #nombre;
		tooltip: 'Nombre de la provincia';
		comment: 'Nombre de la provincia';
		beRequired;
		yourself! !

!Provincia methodsFor: 'as yet unclassified' stamp: 'PRD 9/17/2014 11:47'!
initialize
	super initialize.
	localidades := OrderedCollection new.! !

!Provincia methodsFor: 'accessing' stamp: 'PRD 9/17/2014 11:45'!
localidades
	localidades isNil ifTrue: [ localidades := OrderedCollection new ].
	^ localidades! !

!Provincia methodsFor: 'accessing' stamp: 'PRD 9/17/2014 11:22'!
localidades: anObject
	localidades := anObject! !

!Provincia methodsFor: 'accessing' stamp: 'PRD 9/17/2014 00:54'!
nombre
	^ nombre! !

!Provincia methodsFor: 'accessing' stamp: 'PRD 9/17/2014 00:51'!
nombre: aString 
	nombre := aString! !

POSPersistentObject subclass: #TipoComprobante
	instanceVariableNames: 'descripcion abreviatura partida letrasPermitidas operacion'
	classVariableNames: ''
	poolDictionaries: 'POSPool1'
	category: 'TPV-Model'!

!TipoComprobante class methodsFor: 'as yet unclassified' stamp: 'PRD 11/8/2014 23:28'!
basicCreaComprobanteDescripcion: aDescripcion abreviatura: aAbreviatura partida: aPartida operacion: aOperacion
	^ super new initialize
		descripcion: aDescripcion;
		abreviatura: aAbreviatura;
		operacion: aOperacion;
		partida: aPartida;
		yourself
! !

!TipoComprobante class methodsFor: 'as yet unclassified' stamp: 'PRD 11/11/2014 12:59'!
basicCreaComprobanteVentaDescripcion: aDescripcion abreviatura: aAbreviatura partida: aPartida
	^ self basicCreaComprobanteDescripcion: aDescripcion abreviatura: aAbreviatura partida: aPartida  operacion: VENTA! !

!TipoComprobante class methodsFor: 'as yet unclassified' stamp: 'PRD 12/12/2014 12:31'!
basicCreaFacturaExportacionVenta
	| p o ses |
	ses := POSSession noSeaside.
	p := ses partidaDebe.
	o := (self basicCreaComprobanteVentaDescripcion: self descripcionFacturaExportacion  abreviatura: 'FE'  partida: p ).
	 ^ o letrasPermitidas: 'E'; yourself. 	
! !

!TipoComprobante class methodsFor: 'as yet unclassified' stamp: 'PRD 12/12/2014 12:31'!
basicCreaFacturaVenta
	| p o ses|
	ses := POSSession noSeaside.
	p := ses partidaDebe.
	o := (self basicCreaComprobanteVentaDescripcion: self descripcionFactura  abreviatura: 'FAC'  partida: p) .
	o letrasPermitidas: 'A,B,C,M'.
	^ o 	 	

! !

!TipoComprobante class methodsFor: 'as yet unclassified' stamp: 'PRD 12/12/2014 12:31'!
basicCreaNotaCreditoVenta
	 | o  ses|
	ses := POSSession noSeaside.
	o := (self basicCreaComprobanteVentaDescripcion: self descripcionNotaCredito  abreviatura: 'NC'  partida: ses partidaHaber ).
	o letrasPermitidas: 'A,B,C,M' .
	^ o 
! !

!TipoComprobante class methodsFor: 'as yet unclassified' stamp: 'PRD 12/12/2014 12:31'!
basicCreaNotaDebitoVenta
	 | o ses |
	ses := POSSession noSeaside.
	
	o := ( self  basicCreaComprobanteVentaDescripcion: self descripcionNotaDebito  abreviatura: 'ND'  partida: ses partidaDebe ).
	 o letrasPermitidas: 'A,B,C,M'  .
	^ o  	
! !

!TipoComprobante class methodsFor: 'as yet unclassified' stamp: 'PRD 12/12/2014 12:31'!
basicCreaRecibo
	 | o p |
	p := POSSession noSeaside partidaHaber.
	o := ( self basicCreaComprobanteDescripcion: self descripcionRecibo  abreviatura: 'REC'  partida: p  operacion: COBRANZA ) .
	o letrasPermitidas: 'A,B,C,X'.
	^o . 	
! !

!TipoComprobante class methodsFor: 'as yet unclassified' stamp: 'PRD 12/12/2014 12:31'!
basicCreaTicketFacturaVenta
	| o ses|
	
	ses := POSSession noSeaside.
	
	o := ( self basicCreaComprobanteVentaDescripcion: self descripcionTicketFactura  abreviatura: 'TF'  partida: ses partidaDebe )  .
	 o letrasPermitidas: 'A,B'.
	^ o 	
! !

!TipoComprobante class methodsFor: 'as yet unclassified' stamp: 'PRD 12/12/2014 12:31'!
basicCreaTicketVenta
	| o ses |
	ses := POSSession noSeaside.
	
	o := ( self basicCreaComprobanteVentaDescripcion: self descripcionTicketVenta  abreviatura: 'TIC'  partida: ses partidaDebe ) .
	o letrasPermitidas: ' '.
	^o 	! !

!TipoComprobante class methodsFor: 'as yet unclassified' stamp: 'PRD 12/2/2014 10:45'!
basicCreaTiposBasicos

	self basicCreaFacturaVenta.
	self basicCreaNotaDebitoVenta.
	self basicCreaNotaCreditoVenta.
"	self basicCreaRecibo."
	self basicCreaTicketVenta.
	self basicCreaTicketFacturaVenta.
"	self basicCreaFacturaExportacionVenta."
	
! !

!TipoComprobante class methodsFor: 'as yet unclassified' stamp: 'PRD 12/17/2014 01:30'!
basicCreaTiposBasicosInSession: aSession

	aSession save: self basicCreaFacturaVenta.
	aSession save: self basicCreaNotaDebitoVenta.
	aSession save: self basicCreaNotaCreditoVenta.
"	aSession save: self basicCreaRecibo."
	aSession save: self basicCreaTicketVenta.
	aSession save: self basicCreaTicketFacturaVenta.
"	aSession save: self basicCreaFacturaExportacionVenta."
	
! !

!TipoComprobante class methodsFor: 'as yet unclassified' stamp: 'PRD 12/17/2014 01:31'!
basicInitializeCollectionInSession: aSession
	aSession beginUnitOfWork.
	self basicCreaTiposBasicosInSession: aSession .
	aSession commitUnitOfWork.
	! !

!TipoComprobante class methodsFor: 'accessing' stamp: 'PRD 12/12/2014 00:44'!
contraPartidas
	^ self getSession contraPartidas! !

!TipoComprobante class methodsFor: 'accessing' stamp: 'PRD 9/30/2014 18:48'!
creaTiposBasicos

	self creaFacturaVenta.
	self creaNotaDebitoVenta.
	self creaNotaCreditoVenta.
	self creaRecibo.
	self creaTicketVenta.
	self creaTicketFacturaVenta.
	self creaFacturaExportacionVenta.
	
! !

!TipoComprobante class methodsFor: 'accessing' stamp: 'PRD 9/8/2014 15:57'!
descripcion: aDescripcion abreviatura: anAbreviatura partida: aPartida
	^ super new initialize descripcion: aDescripcion  ; abreviatura: anAbreviatura  ; partida: aPartida; yourself ! !

!TipoComprobante class methodsFor: 'as yet unclassified' stamp: 'PRD 10/16/2014 15:32'!
descripcionFactura
	^'FACTURA' ! !

!TipoComprobante class methodsFor: 'as yet unclassified' stamp: 'PRD 10/16/2014 15:35'!
descripcionFacturaExportacion
	^ 'FACTURA EXPORTACION' ! !

!TipoComprobante class methodsFor: 'as yet unclassified' stamp: 'PRD 10/16/2014 15:33'!
descripcionNotaCredito
	^'NOTA DE CREDITO' ! !

!TipoComprobante class methodsFor: 'as yet unclassified' stamp: 'PRD 10/16/2014 15:33'!
descripcionNotaDebito
	^'NOTA DE DEBITO' ! !

!TipoComprobante class methodsFor: 'as yet unclassified' stamp: 'PRD 10/16/2014 15:35'!
descripcionRecibo
	^ 'RECIBO' ! !

!TipoComprobante class methodsFor: 'as yet unclassified' stamp: 'PRD 10/16/2014 15:33'!
descripcionTicketFactura
	^'TICKET FACTURA'! !

!TipoComprobante class methodsFor: 'as yet unclassified' stamp: 'PRD 10/16/2014 15:34'!
descripcionTicketVenta
	^ 'TICKET' ! !

!TipoComprobante class methodsFor: 'collection' stamp: 'PRD 12/2/2014 09:49'!
letra: aString 
	^ self collection select: [:t | t letrasPermitidas includes: aString  ]! !

!TipoComprobante class methodsFor: 'as yet unclassified' stamp: 'PRD 12/19/2014 09:40'!
letra: aString inSession: aSession
	| col |
	col := OrderedCollection withAll: ( aSession  collection: self ).
	^ col select: [:t | t letrasPermitidas includes: aString  ]! !

!TipoComprobante class methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/26/2014 14:59'!
new
	^ self shouldBeImplemented ! !

!TipoComprobante class methodsFor: 'as yet unclassified' stamp: 'PRD 12/17/2014 01:31'!
paraEmpresa: aEmpresa cliente: aCliente
	| letras dict s |
	( aEmpresa isNil or: [ aCliente isNil ] ) ifTrue: [ ^ self collection ].

	
	letras := LetraPermitida empresa: aEmpresa cliente: aCliente.
	dict := Dictionary new.
	self collection do: [:each | dict at: each put: each letrasPermitidas].
	s := Set new.
	dict associationsDo: [:each | letras do: [:l | ( each value includes: l  ) ifTrue: [ s add: each key ] ]  ].
	^ s
"	^ ( self collection collect: [:each |  each letrasPermitidas detect: [:l | letras includes: l  ] ifNone:  [nil ]  ] ) select: [ :com | com notNil ]"
	! !

!TipoComprobante class methodsFor: 'as yet unclassified' stamp: 'PRD 2/23/2015 02:23'!
paraEmpresa: aEmpresa cliente: aCliente session: aSession
	| letras dict s |
	( aEmpresa isNil or: [ aCliente isNil ] ) ifTrue: [ ^ aSession collection: self ].

	
	letras := LetraPermitida empresa: aEmpresa cliente: aCliente.
	dict := Dictionary new.
	(aSession collection: self ) do: [:each | dict at: each put: each letrasPermitidas].
	s := Set new.
	dict associationsDo: [:each | letras do: [:l | ( each value includes: l  ) ifTrue: [ s add: each key ] ]  ].
	^ s
"	^ ( self collection collect: [:each |  each letrasPermitidas detect: [:l | letras includes: l  ] ifNone:  [nil ]  ] ) select: [ :com | com notNil ]"
	! !

!TipoComprobante class methodsFor: 'accessing' stamp: 'PRD 12/12/2014 01:05'!
partidas
	^ self getSession partidas! !

!TipoComprobante class methodsFor: 'accessing' stamp: 'PRD 10/15/2014 10:14'!
primeroParaLetra: aString 
	^self collection detect: [:t | t letrasPermitidas includes: aString  ] ifNone: [  ]! !

!TipoComprobante class methodsFor: 'as yet unclassified' stamp: 'PRD 4/17/2015 23:19'!
tipoComprobantePorDefecto: aLetra 
	^ self tipoComprobantePorDefecto: aLetra inSession: self session! !

!TipoComprobante class methodsFor: 'as yet unclassified' stamp: 'PRD 2/22/2015 16:37'!
tipoComprobantePorDefecto: aLetra inSession: aSession 
	| c ti |
	c := self letra: aLetra inSession: aSession.
	c isEmpty ifTrue: [ ^ nil ].
	c detect: [:t | t  descripcion = self descripcionTicketVenta  ] ifFound: [:t1 | ti := t1 ] ifNone: [ 
		c detect: [:t |  t  descripcion = self descripcionFactura   ] ifFound: [:t1 |ti := t1 ] ifNone:  [  
			c detect: [:t |  t  descripcion = self descripcionTicketFactura  ] ifFound: [:t1 | ti := t1 ] ifNone: [ ti := c first ]
		]
	].
	^ ti! !

!TipoComprobante class methodsFor: 'as yet unclassified' stamp: 'PRD 9/30/2014 16:06'!
tiposComprobanteVenta
	^ self collection select: [:each | each operacion = VENTA  ]! !

!TipoComprobante methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/26/2014 14:48'!
abreviatura
	^ abreviatura! !

!TipoComprobante methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/26/2014 14:39'!
abreviatura: aString 
	abreviatura := aString! !

!TipoComprobante methodsFor: 'calculos' stamp: 'PRD 12/12/2014 00:44'!
contraPartida
	^ self session contraPartidas at: (self session partidas indexOf: self partida)! !

!TipoComprobante methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/26/2014 14:48'!
descripcion
	^ descripcion! !

!TipoComprobante methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/26/2014 14:39'!
descripcion: aString 
	descripcion := aString! !

!TipoComprobante methodsFor: 'as yet unclassified' stamp: 'PRD 11/7/2014 04:14'!
idUnico
	idUnico :=self descripcion .
	^ idUnico! !

!TipoComprobante methodsFor: 'as yet unclassified' stamp: 'PRD 11/7/2014 01:13'!
initialize
	super initialize.
	letrasPermitidas := OrderedCollection new.! !

!TipoComprobante methodsFor: 'comparing' stamp: 'PabloDigonzelli 5/26/2014 14:48'!
isIdentical: aTipoComprobante 
	^(self descripcion = aTipoComprobante descripcion) and: [ ( self abreviatura = aTipoComprobante abreviatura) and: (self partida = aTipoComprobante partida) ]! !

!TipoComprobante methodsFor: 'calculos' stamp: 'PabloDigonzelli 6/8/2014 14:45'!
isRecibo
	^ false! !

!TipoComprobante methodsFor: 'calculos' stamp: 'PRD 11/7/2014 20:44'!
letrasPermitidas
	^ ( letrasPermitidas substrings: ',' )! !

!TipoComprobante methodsFor: 'accessing' stamp: 'PRD 10/16/2014 20:06'!
letrasPermitidas: aString 
	letrasPermitidas  := aString! !

!TipoComprobante methodsFor: 'as yet unclassified' stamp: 'PRD 9/27/2014 15:32'!
nombre
	^ self descripcion! !

!TipoComprobante methodsFor: 'accessing' stamp: 'PRD 10/3/2014 17:43'!
operacion
	^ operacion! !

!TipoComprobante methodsFor: 'accessing' stamp: 'PRD 9/8/2014 18:11'!
operacion: anObject
	operacion := anObject! !

!TipoComprobante methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/26/2014 14:43'!
partida
	^ partida! !

!TipoComprobante methodsFor: 'accessing' stamp: 'PRD 12/12/2014 01:04'!
partida: aPartida
	( self session partidas includes: aPartida ) ifTrue: [ partida := aPartida]
											 ifFalse: [ ^ Error signal: 'Partida no definida ']! !

POSPersistentObject subclass: #TipoMovimientoCaja
	instanceVariableNames: 'descripcion abreviatura partida'
	classVariableNames: ''
	poolDictionaries: 'POSPool1'
	category: 'TPV-Model'!

!TipoMovimientoCaja class methodsFor: 'as yet unclassified' stamp: 'PRD 1/21/2015 12:27'!
basicCreaEgresoPorVentaInSession: aSession

	aSession save: ( self creaEgresoPorVentaInSession: aSession ).
		
! !

!TipoMovimientoCaja class methodsFor: 'as yet unclassified' stamp: 'PRD 4/15/2015 01:52'!
basicCreaFondoFijoInSession: aSession
	aSession save: ( self creaFondoFijoInSession: aSession ).
! !

!TipoMovimientoCaja class methodsFor: 'as yet unclassified' stamp: 'PRD 1/21/2015 12:27'!
basicCreaIngresoPorVentaInSession: aSession
	aSession save: ( self creaIngresoPorVentaInSession: aSession ).
! !

!TipoMovimientoCaja class methodsFor: 'as yet unclassified' stamp: 'PRD 4/15/2015 01:52'!
basicInitializeCollectionInSession: aSession
	aSession beginUnitOfWork.
	self basicCreaEgresoPorVentaInSession: aSession .
	self basicCreaIngresoPorVentaInSession: aSession .
	self basicCreaFondoFijoInSession: aSession .

	aSession commitUnitOfWork.! !

!TipoMovimientoCaja class methodsFor: 'as yet unclassified' stamp: 'PRD 12/12/2014 12:00'!
creaEgresoPorVenta

	^ super new initialize descripcion: 'Egreso por Ventas'; abreviatura: 'Egr.Venta' ; partida: POSSession noSeaside partidaHaber; yourself. ! !

!TipoMovimientoCaja class methodsFor: 'as yet unclassified' stamp: 'PRD 4/28/2015 13:30'!
creaEgresoPorVentaInSession: aSession

	^ super new initialize descripcion: 'Egreso por Ventas'; abreviatura: 'Egr.Venta' ; partida: aSession possession partidaHaber; yourself. ! !

!TipoMovimientoCaja class methodsFor: 'as yet unclassified' stamp: 'PRD 4/28/2015 13:30'!
creaFondoFijoInSession: aSession
	^ super new initialize descripcion: 'Ingreso por FondoFijo'; abreviatura: 'Ing.FF' ; partida: aSession possession partidaDebe; yourself. ! !

!TipoMovimientoCaja class methodsFor: 'as yet unclassified' stamp: 'PRD 12/12/2014 11:59'!
creaIngresoPorVenta
	|   p ses|
	
	ses := POSSession noSeaside.
	p := ses partidaDebe.

	^ super new initialize descripcion: 'Ingreso por Ventas'; abreviatura: 'Ing.Venta' ; partida: p; yourself. ! !

!TipoMovimientoCaja class methodsFor: 'as yet unclassified' stamp: 'PRD 4/28/2015 13:30'!
creaIngresoPorVentaInSession: aSession
	^ super new initialize descripcion: 'Ingreso por Ventas'; abreviatura: 'Ing.Venta' ; partida: aSession possession partidaDebe; yourself. ! !

!TipoMovimientoCaja class methodsFor: 'as yet unclassified' stamp: 'PRD 12/12/2014 01:05'!
partidas
	^ self getSession partidas! !

!TipoMovimientoCaja methodsFor: 'accessing' stamp: 'PRD 10/7/2014 08:19'!
abreviatura
	^ abreviatura! !

!TipoMovimientoCaja methodsFor: 'accessing' stamp: 'PRD 10/7/2014 08:19'!
abreviatura: anObject
	abreviatura := anObject! !

!TipoMovimientoCaja methodsFor: 'accessing' stamp: 'PRD 10/7/2014 08:19'!
descripcion
	^ descripcion! !

!TipoMovimientoCaja methodsFor: 'accessing' stamp: 'PRD 10/7/2014 08:19'!
descripcion: anObject
	descripcion := anObject! !

!TipoMovimientoCaja methodsFor: 'as yet unclassified' stamp: 'PRD 2/9/2015 10:50'!
descriptionAbreviatura
	<magritteDescription>
	^ MAStringDescription new 
		label: 'Abreviatura';
		comment: 'Abreviatura';
		priority: 200;
		accessor: #abreviatura;
		yourself
	! !

!TipoMovimientoCaja methodsFor: 'as yet unclassified' stamp: 'PRD 2/9/2015 10:49'!
descriptionDescripcion
	<magritteDescription>
	^ MAStringDescription new 
		label: 'Descripcion';
		accessor: #descripcion;
		comment: 'Descripcion';
		priority: 100;
		yourself
	! !

!TipoMovimientoCaja methodsFor: 'as yet unclassified' stamp: 'PRD 2/9/2015 10:53'!
descriptionPartida
	<magritteDescription>
	^ MASingleOptionDescription new 
		priority: 300;
		label: 'Partida';
		accessor: #partida;
		comment: 'Partida del tipo de movimiento de caja';
		optionsAndLabels: ( (self session collection: Partida) collect: [:each | Association key: each value: each nombre ] );
		yourself! !

!TipoMovimientoCaja methodsFor: 'as yet unclassified' stamp: 'PRD 1/22/2015 00:06'!
esEgreso
	^ self partida = self session partidaHaber! !

!TipoMovimientoCaja methodsFor: 'as yet unclassified' stamp: 'PRD 1/22/2015 00:05'!
esIngreso
	^ self partida = self session partidaDebe! !

!TipoMovimientoCaja methodsFor: 'as yet unclassified' stamp: 'PRD 1/7/2015 12:34'!
nombre
	^ self descripcion! !

!TipoMovimientoCaja methodsFor: 'as yet unclassified' stamp: 'PRD 10/7/2014 08:01'!
partida
	^ partida! !

!TipoMovimientoCaja methodsFor: 'as yet unclassified' stamp: 'PRD 12/12/2014 01:05'!
partida: aPartida
	( self session partidas includes: aPartida ) ifTrue: [ partida := aPartida]
											 ifFalse: [ ^ Error signal: 'Partida no definida ']! !

!TipoMovimientoCaja methodsFor: 'accessing' stamp: 'PRD 10/7/2014 08:32'!
signoPartida
	^ ( self partida == HABER ) ifTrue: [ -1] ifFalse: [ 1] ! !

Object subclass: #Coneccion
	instanceVariableNames: 'conn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!Coneccion methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/4/2015 13:04'!
creaConneccion
	self subclassResponsibility ! !

Coneccion subclass: #GlorpConeccion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!GlorpConeccion class methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/4/2015 13:12'!
session: aPOSGlorpSession
	^ self new initialize session: aPOSGlorpSession ! !

!GlorpConeccion methodsFor: 'sql' stamp: 'PabloDigonzelli 5/4/2015 14:16'!
beginUnitOfWork
	self session beginUnitOfWork ! !

!GlorpConeccion methodsFor: 'sql' stamp: 'PabloDigonzelli 5/4/2015 14:35'!
commitUnitOfWork
	self session commitUnitOfWork ! !

!GlorpConeccion methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/4/2015 14:08'!
connect
	^ self creaConeccion ! !

!GlorpConeccion methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/4/2015 14:14'!
creaConeccion
	^ self! !

!GlorpConeccion methodsFor: 'sql' stamp: 'PabloDigonzelli 5/4/2015 14:15'!
executeSQLString: aString 
	^ self session gsession accessor executeSQLString: aString ! !

!GlorpConeccion methodsFor: 'glorp' stamp: 'PabloDigonzelli 5/4/2015 14:29'!
hasUnitOfWork
	^ self session hasUnitOfWork ! !

!GlorpConeccion methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/4/2015 14:05'!
initialize
	super initialize.
! !

!GlorpConeccion methodsFor: 'Glorp' stamp: 'PabloDigonzelli 5/4/2015 14:18'!
readOneOf: aClass where: aBlockClosure 
	^ self session readOneOf: aClass where: aBlockClosure ! !

!GlorpConeccion methodsFor: 'glorp' stamp: 'PabloDigonzelli 5/5/2015 17:12'!
rollbackUnitOfWork
	self session rollbackUnitOfWork .! !

!GlorpConeccion methodsFor: 'sql' stamp: 'PabloDigonzelli 5/4/2015 14:16'!
save 
	self gsession beginUnitOfWork ! !

!GlorpConeccion methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/4/2015 14:17'!
save: anObject 	
	self session save: anObject! !

!GlorpConeccion methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/4/2015 14:06'!
session
	^ session! !

!GlorpConeccion methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/4/2015 14:06'!
session: anObject
	session := anObject! !

Coneccion subclass: #MSSQLConeccion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!MSSQLConeccion class methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/4/2015 13:10'!
dsn: aDSN user: aUser password: aPassword
	^ self new initialize dsn: aDSN ; user: aUser ; password: aPassword ; yourself ! !

!MSSQLConeccion methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/4/2015 13:04'!
creaConeccion
	conn := ODBCConnection dsn: dsn user: user password: password.
	conn connect.
	^ conn! !

!MSSQLConeccion methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/4/2015 13:04'!
initialize
	super initialize.
	dsn := 'dadosprb'.
	user := 'sa'.
	password := '50Wifaro'.
	^ self creaConeccion! !

Object subclass: #Exporta
	instanceVariableNames: 'conn localconn directorio refname localrefname fields localfields key localkey nilisEmpty keys localkeys'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!Exporta class methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/4/2015 23:17'!
createInstance
	self subclassResponsibility 
			! !

!Exporta class methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/4/2015 23:18'!
diferencias
	| e |
	e := self createInstance .
	e exporta.
	e exportaLocal.		
			
	^ e diferencias		
			
! !

!Exporta class methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/13/2015 15:33'!
differences
	| e |
	e := self createInstance .
	e exporta.
	e exportaLocal.		
			
	^ e differences		
			
! !

!Exporta class methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/13/2015 23:30'!
exporta
	| e |
	e := self createInstance.
	e exporta.
	e exportaLocal.
	^ e! !

!Exporta class methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/6/2015 11:30'!
prueba1
	| e |
	POSSession reset.

	e := self new.
	e directorio: 'c:\temp'.

	e refname: 'SB1010'.
	e localrefname: 'Item'.

	"codigo,descripcion,clasificacionpid,codigobarra,venta,pid	"
	e fields: #('B1_COD' 'B1_DESC' 'B1_GRUPO' 'B1_CODBAR' 'B1_ATIVO' 'R_E_C_N_O_').
	e localfields: #('codigo' 'descripcion' 'clasificacionpid' 'codigobarra' 'venta' 'pid').
	e key: #R_E_C_N_O_.
	e localkey: #pid.		
	
	^ e
			
			
! !

!Exporta class methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/13/2015 23:47'!
sincronize
	| e |
	e := self exporta.
	^ e sincronize: e localrefname keys: e keys! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/14/2015 23:05'!
basicSincronizeSession1: ses table: aTablename rows: coldiff keys: aCollectionOfKeys
	|   col item impuesto im |
	col := OrderedCollection new.
	ses beginUnitOfWork.
	coldiff
		do: [ :o | 
			item := ses readOneOf: Item where:  [ :each | each pid = (o at: 'ITEMPID') ].
			impuesto := ses readOneOf: Impuesto where:  [ :each | each pid = (o at: 'IMPUESTOPID') ].
			im := item impuestos includes: [ :each | each  impuesto = impuesto ].
			im ifFalse: [  item add: impuesto. ses save: item ]].
	ses commitUnitOfWork.
	^ col! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/14/2015 23:07'!
basicSincronizeSession: ses table: aTablename rows: coldiff keys: aCollectionOfKeys
	| bloque object col |
	col := OrderedCollection new.
	ses beginUnitOfWork.
	coldiff
		do: [ :o | 
			bloque := self contstructBlock: aTablename object: o keys: aCollectionOfKeys.
			object := bloque value: ses.
			object ifNil: [ object := self objectFromJSON: o ] ifNotNil: [ :arg | self sincroObject: object withJSON: o ].
			ses save: object.
			col add: object ].
	ses commitUnitOfWork.
	^ col! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/12/2015 00:59'!
compara: aJSON with: anotherJSON at: aField
	| field2 valor1 valor2 |

	field2 := localfields at: (fields indexOf: aField).
	valor1 := (self valorJSON: aJSON of: aField).
	valor2 := (self valorJSON: anotherJSON of: field2).
	^ valor1 = valor2! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/6/2015 15:02'!
comparisionKeys
	| comparisionKeys |
	comparisionKeys ifNil: [ comparisionKeys := self fields ] .
	^ comparisionKeys! !

!Exporta methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/4/2015 14:04'!
conn
	conn ifNil: [ 	conn := MSSQLConeccion dsn: 'dadosprb' user: 'sa' password: '50Wifaro' . conn connect ].
	^ conn ! !

!Exporta methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/2/2015 19:28'!
conn: anObject
	^ conn := anObject! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/14/2015 00:33'!
contstructBlock: aTableName object: anObject keys: aCollectionOfKeys

	| str sep str1 sep1 |
	str := '[:ses | ses readOneOf: ' , aTableName , ' where: [ :each | '.
		
	str1 := ''.		
	aCollectionOfKeys do: [ :k | 
		 sep := (str1 = '') ifTrue: [ '' ] ifFalse: [ ' AND: [ ' ].
		 sep1 := (sep = '') ifTrue: [ '' ] ifFalse: [ ']' ].	
		 str1 := str1 , (sep , 'each ' , (self localFieldFor: k) greaseString , ' = ' , (anObject at: k) greaseString) , sep1 ].
	str := str , str1 , ']]'.
	
	^ Compiler evaluate: str
	
! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/13/2015 20:45'!
contstructSQLString: aTableName object: anObject keys: aCollectionOfKeys

	| sqlString sqlString1 sep |
	sqlString := 'select * from ' , aTableName , ' where '.
	sqlString1 := ''.
	
	aCollectionOfKeys do: [ :k | 
		 sep := (sqlString1 = '') ifTrue: [ '' ] ifFalse: [ ' and ' ].
		 sqlString1 := (sep , (self localFieldFor: k) , ' = ' , (anObject at: k) greaseString) ].
	sqlString := sqlString , sqlString1 .
	^ sqlString 
	
! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/13/2015 15:34'!
dictionaryFromJSON: collectionOfJSON simbolo: aSimbolo
	| items |
	items := Dictionary new.
	collectionOfJSON 
		do: [ :each | 
			items at: (each perform: aSimbolo) ifAbsentPut: [ OrderedCollection new ].
			(items at: (each perform: aSimbolo)) add: each ].
	^ items! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/6/2015 11:27'!
dictionaryFromLocalArray: each
	| r index valor |
	r := Dictionary new.
	self localfields do: [ :f | 
		index := self localfields indexOf: f.
		valor := (each at: index).
		(valor class = Date) ifTrue: [ valor := (valor yyyymmdd asString copyReplaceAll: '-' with: '') ].
		valor ifNil: [ valor := '' ].
		r at: f asSymbol put: valor ].
	^ r! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/3/2015 21:23'!
diferencias
	
	^ self diferenciasUsingKey: key! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/5/2015 17:17'!
diferenciasEntreDict1: items1 dict2: items2 simbol1: aSimbol
	| item2 adds upds |
	adds := OrderedCollection new.
	upds := OrderedCollection new.
	items1
		do: [ :item1 | 
			item2 := items2 at: (item1 at: aSimbol) ifAbsent: [ nil ].
			item2 isNil
				ifTrue: [ adds add: item1 ]
				ifFalse: [ 
					(self isDifferentJSON: item1 fromJSON: item2)
						ifTrue: [ upds add: item1 ] ] ].
	^ Array with: adds with:upds with:OrderedCollection new ! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/4/2015 13:26'!
diferenciasUsingKey: simbolo
	| json1 items1 items2 json2 arr |

	json1 := self importa.
	items1 := self indexa: (json1 at: self refname) simbol: key.
	json2 := self importaLocal.
	items2 := self indexa: (json2 at: self localrefname) simbol: localkey.
	arr := self
				diferenciasEntreDict1: items1
				dict2: items2
				simbol1: simbolo asSymbol.
	^ self novedades: localrefname asClass addas: (arr at: 1) upds: (arr at: 2)! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/12/2015 10:37'!
diferenciasWithoutKey
	| json1 items1 items2 json2 arr simbolo |

	json1 := self importa.
	items1 := self indexa: (json1 at: self refname) simbol: key.
	json2 := self importaLocal.
	items2 := self indexa: (json2 at: self localrefname) simbol: localkey.
	arr := self
				diferenciasEntreDict1: items1
				dict2: items2
				simbol1: simbolo asSymbol.
	^ self novedades: localrefname asClass addas: (arr at: 1) upds: (arr at: 2)! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/13/2015 23:57'!
differences
	| json1 json2 items1 items2   col2 diff |
	json1 := self importa.
	json2 := self importaLocal.
	items1 := self dictionaryFromJSON: (json1 at: refname) simbolo: key.
	items2 := self dictionaryFromJSON: (json2 at: localrefname) simbolo: localkey.
	diff := OrderedCollection new.
	items1
		associationsDo: [ :item1 | 
			col2 := items2 at: item1 key ifAbsent: [ nil ].
			col2
				ifNil: [ diff addAll: item1 value ]
				ifNotNil: [ diff addAll: (self differencesOfJSONBetween: item1 value and: col2) ] ].
	^ diff 	"	arr := self diferenciasEntreDict1: items1 dict2: items2 simbol1: simbolo asSymbol."	"^ self novedades: localrefname asClass addas: (arr at: 1) upds: (arr at: 2)"! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/13/2015 15:34'!
differencesOfJSONBetween: col1 and: col2
	^ self differencesOfJSONBetween: col1 and: col2 keys: fields ! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/14/2015 00:20'!
differencesOfJSONBetween: col1 and: col2 keys: aCollectionOfKeys
	| diff indice j2 valor1 valor2 res indice1 |
	diff := OrderedCollection new.
	col1
		do: [ :j1 | 
			j2 := col2
				do: [ :each | 
					res := true.
					aCollectionOfKeys
						do: [ :k | 
							indice := fields indexOf: k.		
							indice1 := (localfields at: indice).
							valor1 := (self valorJSON: j1 of: k).
							valor2 := (self valorJSON: each of: indice1).
							res := res and: [ valor1 = valor2 ] ].
					res
						ifTrue:  [ (diff includes: j1) ifTrue: [ diff remove: j1 ] ]
						ifFalse: [ diff add: j1 ] ] ].
	^ diff! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/4/2015 12:57'!
directorio
	directorio ifNil: [ directorio := 'c:\temp' ].
	^ directorio! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/1/2015 16:24'!
directorio: aDirectorio
	directorio := aDirectorio! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/3/2015 11:34'!
exporta
	self exporta: refname

! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/12/2015 11:04'!
exporta: name
	| rs col |
	rs := self conn execute: self sqlString.
	col := self odbcResultSetToCollectionOfJSON: rs.
	^ self exportaData: col name: name! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/3/2015 11:17'!
exportaData: col name: name
	| fw d json |
	d := Dictionary new.
	d at: name put: col.
	json := NeoJSONWriter toString: d.
	fw := FileStream fileNamed: (self filename: name).
	fw nextPutAll: json.
	fw close.
	^ json
	

! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/3/2015 11:34'!
exportaLocal
	self exportaLocal: localrefname

! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/5/2015 14:36'!
exportaLocal: name
	|  arr col |
	conn := self localconn.
	arr := conn executeSQLString: self sqlLocalString.
	col := self localArrayToCollectionOfJSON: arr.
	^ self exportaData: col name: name! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/13/2015 18:54'!
fieldFor: aLocalField
	
	
	^ fields at: (fields indexOf: aLocalField).! !

!Exporta methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/2/2015 19:38'!
fields
	^ fields! !

!Exporta methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/2/2015 19:38'!
fields: anObject
	fields := anObject! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/2/2015 19:55'!
filename: name
	^ self directorio , '\' , name , '.json'! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/3/2015 12:37'!
importa
	^ self importaJSONFromFileNamed: (self filename: refname)! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/2/2015 22:19'!
importa: aFilename
	^ self importaJSONFromFileNamed: aFilename! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/2/2015 13:48'!
importaJSONFromFileNamed: aFileName

	| fr json object  |
	fr := FileStream fileNamed: aFileName.
	json := fr contents.
	object := (NeoJSONObject fromString: json).
	fr close.
	^ object	
! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/3/2015 12:37'!
importaLocal
	^ self importaJSONFromFileNamed: (self filename: localrefname)! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/2/2015 13:45'!
indexa: anArrayOfJSONObjects simbol: aSymbol

	| d |
	d := Dictionary new.
	
	anArrayOfJSONObjects do: [ :each | d at: (each at: aSymbol ) put: each  ].
	^ d! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/3/2015 16:06'!
initialize
	super initialize.
	nilisEmpty := true.! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/6/2015 15:03'!
isDifferentJSON: aJSON fromJSON: anotherJSON
	^ self isDifferentJSON: aJSON fromJSON: anotherJSON  keys: self comparisionKeys! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/12/2015 01:34'!
isDifferentJSON: aJSON fromJSON: anotherJSON keys: anArrayOfKeys
	| i1 o2  |
	^ anArrayOfKeys 
		anySatisfy: [ :k | 
			i1 := fields indexOf: k.
			o2 := localfields at: i1.
			false = (self compara: aJSON with: anotherJSON at: k) ]! !

!Exporta methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/3/2015 13:51'!
key
	^ key! !

!Exporta methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/3/2015 13:36'!
key: aSimbolo
	key := aSimbolo! !

!Exporta methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/13/2015 23:45'!
keys
	keys ifNil: [ keys := OrderedCollection new. 
					  keys add: key ].
	^ keys! !

!Exporta methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/13/2015 23:37'!
keys: anObject
	keys := anObject! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/3/2015 12:17'!
localArrayToCollectionOfJSON: rs
	| r json col |
	col := OrderedCollection new.
	rs
		do: [ :each | 
			r := self dictionaryFromLocalArray: each.
			json := NeoJSONWriter toString: r.
			col add: (NeoJSONObject fromString: json) ].
	^ col! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/13/2015 19:06'!
localFieldFor: aField
	
	
	^ localfields at: (fields indexOf: aField).! !

!Exporta methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/4/2015 14:08'!
localconn
	localconn ifNil: [ localconn :=  (GlorpConeccion session: POSSession noSeaside ) connect].
	^ localconn! !

!Exporta methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/4/2015 13:15'!
localconn: anObject
	localconn := anObject! !

!Exporta methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/2/2015 19:43'!
localfields
	^ localfields! !

!Exporta methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/2/2015 19:43'!
localfields: anObject
	localfields := anObject! !

!Exporta methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/3/2015 13:52'!
localkey
	^ localkey! !

!Exporta methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/3/2015 13:36'!
localkey: aSimbolo 
	localkey := aSimbolo! !

!Exporta methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/13/2015 23:45'!
localkeys
	localkeys ifNil: [ localkeys := OrderedCollection new. 
					  		 localkeys add: key ].
	^ localkeys! !

!Exporta methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/13/2015 23:37'!
localkeys: anObject
	localkeys := anObject! !

!Exporta methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/2/2015 19:43'!
localrefname
	^ localrefname! !

!Exporta methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/2/2015 19:43'!
localrefname: anObject
	localrefname := anObject! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/6/2015 10:50'!
newObject
	^ self subclassResponsibility ! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/13/2015 02:16'!
novedades: aClass addas: adds upds: upds
	| ses object col series resto lote |
	ses := self localconn.
	col := OrderedCollection new.
	ses hasUnitOfWork
		ifTrue: [ ses rollbackUnitOfWork ].
	lote := 50.
	series := (upds size / lote) greaseInteger.
	resto := upds size - (series * lote).
	1 to: series do: [ :s | 
		ses beginUnitOfWork.
		(upds copyFrom: (s - 1) * lote + 1 to: s * lote)
			do: [ :u | 
				object := ses readOneOf: aClass where: [ :it | it pid = (u at: key) ].
				self sincroObject: object withJSON: u.
				ses save: object.
				col add: object ].
		ses commitUnitOfWork ].
	ses beginUnitOfWork.
	(upds copyFrom: series * lote + 1 to: series * lote + resto)
		do: [ :u | 
			object := ses readOneOf: aClass where: [ :it | it pid = (u at: key) ].
			self sincroObject: object withJSON: u.
			ses save: object.
			col add: object ].
	ses commitUnitOfWork.	"	upds
		do: [ :each | 
			ses beginUnitOfWork .
			object := ses readOneOf: aClass where: [ :it | it pid = (each at: key) ].
			self sincroObject: object withJSON: each."	"col add: object"	"ses save: object.
			ses commitUnitOfWork   ]."
	series := (adds size / lote) greaseInteger.
	resto := adds size - (series * lote).
	1 to: series do: [ :s | 
		ses beginUnitOfWork.
		(adds copyFrom: (s - 1) * lote + 1 to: s * lote)
			do: [ :each | 
				object := self objectFromJSON: each.
				ses save: object.
				col add: object ].
		ses commitUnitOfWork ].

	ses beginUnitOfWork.
	(adds copyFrom: series * lote + 1 to: series * lote + resto)
		do: [ :each | 
			object := self objectFromJSON: each.
			ses save: object.
			col add: object ].
	ses commitUnitOfWork.	"	adds do: [ :each | ses beginUnitOfWork.
					object := (self objectFromJSON: each).
					ses save: object.
					ses commitUnitOfWork ."	"col add: (self objectFromJSON: each)"	"]."	"	col do: [ :each | ses save: each  ].
	ses commitUnitOfWork ."
	^ col! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/12/2015 18:49'!
objectFromJSON: data
	| object |
	object := self newObject.
	self sincroObject: object withJSON: data.
	^ object! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/12/2015 11:12'!
odbcResultSetToCollectionOfJSON: rs
	| r json col dict |
	col := OrderedCollection new.
	[ rs atEnd ]
		whileFalse: [ 
			r := rs next.
			dict := Dictionary new.
			self fields do: [ :f | dict at: f asSymbol put: (r at: f asSymbol)  ].
			json := NeoJSONWriter toString: dict.
			col add: (NeoJSONObject fromString: json)].
	conn close.
	^ col! !

!Exporta methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/2/2015 19:28'!
refname
	^ refname! !

!Exporta methodsFor: 'accessing' stamp: 'PabloDigonzelli 5/2/2015 19:28'!
refname: anObject
	refname := anObject! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/4/2015 13:34'!
release
	conn close.
	localconn reset.! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/4/2015 13:41'!
sincroObject: item withJSON: data
	self subclassResponsibility ! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/14/2015 00:46'!
sincronize: aTablename keys: aCollectionOfKeys
	| ses col lote series resto diff coldiff |
	ses := self localconn.
	ses hasUnitOfWork
		ifTrue: [ ses rollbackUnitOfWork ].
	diff := self differences.
	col := OrderedCollection new.
	lote := 50.
	series := (diff size / lote) greaseInteger.
	resto := diff size - (series * lote).
	1 to: series do: [ :s | 
		coldiff := diff copyFrom: (s - 1) * lote + 1 to: s * lote.
		col
			addAll:
				(self
					basicSincronizeSession: ses
					table: aTablename
					rows: coldiff
					keys: aCollectionOfKeys) ].
	coldiff := diff copyFrom: series * lote + 1 to: series * lote + resto.
	col
		addAll:
			(self
				basicSincronizeSession: ses
				table: aTablename
				rows: coldiff
				keys: aCollectionOfKeys).
	^ col! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/3/2015 11:24'!
sqlLocalString
	^ self sqlStringTable: localrefname fields: localfields
! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/3/2015 11:24'!
sqlString
	^ self sqlStringTable: refname fields: fields
! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/3/2015 11:37'!
sqlStringTable: aTablename fields: collectionOfFields
	| string |
	string := ' '.
	collectionOfFields do: [:f | string := string, f , ','  ].
	string := string allButLast .
	^ 'SELECT ' , string , ' FROM ' , aTablename.! !

!Exporta methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/4/2015 13:22'!
valorJSON: aJSON of: aField
	^ aJSON at: aField! !

Exporta subclass: #ExportaCliente
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!ExportaCliente class methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/14/2015 11:37'!
createInstance
	| e |
	e := self new initialize.
	e directorio: 'c:\temp'.
	e refname: 'SA1010'.
	e localrefname: 'Cliente'.
	"codigo,descripcion,clasificacionpid,codigobarra,venta,pid	"
	e fields: #('CODIGO'  'A1_CGC' 'A1_NOME' 'A1_TIPO' 'A1_END' 'A1_CEP' 'A1_TABELA' 'R_E_C_N_O_').
	e localfields: #('idUnico' 'cuit' 'razonsocial' 'categoriaimpositivaid' 'calle' 'codigopostal' 'listapid' 'pid').
	e key: #R_E_C_N_O_.
	e localkey: #pid.
	^ e! !

!ExportaCliente methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/6/2015 10:53'!
newObject
	^ Cliente new.! !

!ExportaCliente methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/5/2015 20:24'!
sincroObject: cli withJSON: data
	cli pid: (data at: 'R_E_C_N_O_').
	cli razonSocial: (data at: 'A1_NOME').
	cli cuit: ((data at: 'A1_CGC') = '' ifTrue: [0] ifFalse: [(data at: 'A1_CGC') asNumber]).
	cli idUnico: (data at: 'CODIGO').
	cli direccion: ( DireccionCliente new calle: (data at: 'A1_END'); codigoPostal: (data at: 'A1_CEP') ; yourself).

! !

!ExportaCliente methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/14/2015 11:37'!
sqlString
	^ 'SELECT (A1_COD + A1_LOJA) AS CODIGO,A1_CGC,A1_NOME,A1_TIPO,A1_END,A1_CEP,A1_TABELA,R_E_C_N_O_ FROM SA1010'
! !

!ExportaCliente methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/14/2015 10:58'!
valorJSON: aJSON of: aField
	aField = #A1_TIPO
		ifTrue: [ ((aJSON at: aField) = 'I')  ifTrue: [ ^ CategoriaImpositiva session categoriaResponsableInscripto pid ] ].
		
	^ aJSON at: aField! !

Exporta subclass: #ExportaCodigoBarra
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!ExportaCodigoBarra class methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/15/2015 10:12'!
createInstance
	| e |
	e := self new initialize.
	e directorio: 'c:\temp'.
	e refname: 'SLK010'.
	e localrefname: 'CodigoBarra'.
	e fields: #('LK_CODBAR' 'LK_QUANT' 'R_E_C_N_O_').
	e localfields: #('codigoBarra' 'cantidad' 'pid').
	e key: #R_E_C_N_O_.
	e localkey: #pid.

	^ e! !

!ExportaCodigoBarra methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/15/2015 10:10'!
newObject
	^ CodigoBarra  new.! !

!ExportaCodigoBarra methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/15/2015 10:11'!
sincroObject: condicionPago withJSON: data
	condicionPago pid: (data at: 'R_E_C_N_O_').
	condicionPago codigoBarra: (data at: 'LK_CODBAR').
	condicionPago cantidad: (data at: 'LK_QUAN')! !

Exporta subclass: #ExportaCondicionPago
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!ExportaCondicionPago class methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/14/2015 18:28'!
createInstance
	| e |
	e := self new initialize.
	e directorio: 'c:\temp'.
	e refname: 'SE4010'.
	e localrefname: 'CondicionPago'.
	e fields: #( 'E4_DESCRI' 'E4_COND' 'R_E_C_N_O_').
	e localfields: #('descripcion' 'condicion' 'pid').
	e key: #R_E_C_N_O_.
	e localkey: #pid.
	^ e! !

!ExportaCondicionPago methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/14/2015 18:23'!
newObject
	^ CondicionPago new.! !

!ExportaCondicionPago methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/14/2015 18:28'!
sincroObject: condicionPago withJSON: data
	condicionPago pid: (data at: 'R_E_C_N_O_').
	condicionPago descripcion: (data at: 'E4_DESCRI').
	condicionPago condicion: (data at: 'E4_COND').
! !

Exporta subclass: #ExportaImpuesto
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!ExportaImpuesto class methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/13/2015 23:38'!
createInstance
	| e |
	e := self new initialize.
	e directorio: 'c:\temp'.
	e refname: 'SFB010'.
	e localrefname: 'Impuesto'.
	"porcentaje fijo descripcion condicion operaciones iva"
	e fields: #('FB_DESCR' 'FB_ALIQ' 'R_E_C_N_O_').
	e localfields: #('descripcion' 'porcentaje' 'pid').
	e key: #R_E_C_N_O_.
	e localkey: #pid.
	^ e
			
! !

!ExportaImpuesto methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/11/2015 22:20'!
newObject
	^ Impuesto new.! !

!ExportaImpuesto methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/12/2015 01:04'!
sincroObject: impuesto withJSON: data
	impuesto pid: (data at: 'R_E_C_N_O_').
	impuesto descripcion: (data at: 'FB_DESCR').
	impuesto porcentaje: (data at: 'FB_ALIQ').
	impuesto iva: true.! !

!ExportaImpuesto methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/12/2015 00:54'!
sqlString
	"^ 'SELECT FB_DESCR,FB_ALIQ,R_E_C_N_O_ FROM SFB010 WHERE FB_CLASSE = '"
		
	| s |
	s := WriteStream on: String new.
	s nextPutAll: 'SELECT FB_DESCR,FB_ALIQ,R_E_C_N_O_,FB_FILIAL AS IVA FROM SFB010 WHERE FB_CLASSE = ' .
	s nextPut: $'.
	s nextPutAll: 'I'.
	s nextPut: $'.
	^ s contents
! !

!ExportaImpuesto methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/12/2015 01:24'!
valorJSON: aJSON of: aField
	aField = #B1_ALIQ
		ifTrue: [  ^ ((aJSON at: aField) asFloat) ].
		
	^ aJSON at: aField! !

Exporta subclass: #ExportaImpuestoItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!ExportaImpuestoItem class methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/14/2015 00:29'!
createInstance
	| e |
	e := self new initialize.
	e directorio: 'c:\temp'.
	e refname: 'SIMPIT'.
	e localrefname: 'ImpuestoItem'.
	"porcentaje fijo descripcion condicion operaciones iva"
	e fields: #('ITEMPID' 'IMPUESTOPID').
	e localfields: #('itempid' 'impuestopid').
	e key: #ITEMPID.
	e localkey: #itempid.
	e keys: #(#ITEMPID #IMPUESTOPID).
	e localkeys: #(#itempid #impuesto).

	^ e! !

!ExportaImpuestoItem methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/15/2015 10:05'!
basicSincronizeSession: ses table: aTablename rows: coldiff keys: aCollectionOfKeys
	|   col item impuesto im |
	col := OrderedCollection new.
	ses beginUnitOfWork.
	coldiff
		do: [ :o | 
			item := ses readOneOf: Item where:  [ :each | each pid = (o at: 'ITEMPID') ].
			impuesto := ses readOneOf: Impuesto where:  [ :each | each pid = (o at: 'IMPUESTOPID') ].
			im := item impuestos includes: [ :each | each  impuesto = impuesto ].
			im ifFalse: [  item addImpuesto: impuesto. ses save: item ]].
	ses commitUnitOfWork.
	^ col! !

!ExportaImpuestoItem methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/15/2015 10:10'!
newObject
	! !

!ExportaImpuestoItem methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/12/2015 10:48'!
sincroObject: impuesto withJSON: data
	impuesto itempid: (data at: 'ITEMPID').
	impuesto impuestopid: (data at: 'IMPUESTOPID').
! !

!ExportaImpuestoItem methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/14/2015 23:32'!
sqlString
	^ 'SELECT   SB1010.R_E_C_N_O_ AS ITEMPID, SFB010.R_E_C_N_O_ AS IMPUESTOPID FROM  SB1010 	INNER JOIN 
                         SFC010 ON SB1010.B1_XTESI = SFC010.FC_TES 	INNER JOIN
                         SFB010 ON SFC010.FC_IMPOSTO = SFB010.FB_CODIGO'! !

Exporta subclass: #ExportaItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!ExportaItem class methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/4/2015 23:15'!
createInstance
	| e |
	e := self new initialize.
	e directorio: 'c:\temp'.
	e refname: 'SB1010'.
	e localrefname: 'Item'.
	"codigo,descripcion,clasificacionpid,codigobarra,venta,pid	"
	e fields: #('B1_COD' 'B1_DESC' 'B1_GRUPO' 'B1_CODBAR' 'B1_ATIVO' 'R_E_C_N_O_').
	e localfields: #('codigo' 'descripcion' 'clasificacionpid' 'codigobarra' 'venta' 'pid').
	e key: #R_E_C_N_O_.
	e localkey: #pid.
	^ e
			
! !

!ExportaItem methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/6/2015 10:53'!
newObject
	^ Item new.! !

!ExportaItem methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/12/2015 01:04'!
sincroObject: item withJSON: data
	item pid: (data at: 'R_E_C_N_O_').
	item descripcion: (data at: 'B1_DESC').
	item codigo: (data at: 'B1_COD').
	item venta: (data at: 'B1_ATIVO') = 'S'.
	item codigoBarra: (data at: 'B1_CODBAR').
! !

!ExportaItem methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/4/2015 17:43'!
valorJSON: aJSON of: aField
	aField = #B1_ATIVO
		ifTrue: [  ^ ( (aJSON at: aField ) = 'S') ].
	^ aJSON at: aField! !

Exporta subclass: #ExportaItemListaPrecio
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!ExportaItemListaPrecio class methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/6/2015 16:56'!
createInstance
	| e |
	e := self new initialize.
	e directorio: 'c:\temp'.
	e refname: 'DA1010'.
	e localrefname: 'ItemListaPrecio'.
	"nombre vencimiento tipo habilitada itemsLista"
	e fields: #('LISTAID' 'IDUNICO' 'ITEMPID' 'DA1_PRCVEN' 'R_E_C_N_O_').
	e localfields: #('listaid' 'idunico' 'itempid' 'precio' 'pid').
	e key: #R_E_C_N_O_.
	e localkey: #pid.
	^ e! !

!ExportaItemListaPrecio methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/6/2015 15:30'!
newObject
	^ ItemListaPrecio new.! !

!ExportaItemListaPrecio methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/6/2015 18:26'!
sincroObject: itemlista withJSON: data
	itemlista pid: (data at: 'R_E_C_N_O_').
	itemlista
		listaPrecio:
			(ListaPrecio session readOneOf: ListaPrecio where: [ :each | each pid = (data at: 'LISTAID') greaseInteger ]).
	itemlista idUnico: (data at: 'IDUNICO').
	itemlista item: (Item session readOneOf: Item where: [ :each | each pid = (data at: 'ITEMPID') greaseInteger ]).
	itemlista precio: (data at: 'DA1_PRCVEN')	"listaPrecio precio item"! !

!ExportaItemListaPrecio methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/6/2015 16:53'!
sqlString
	^ 'SELECT DA0010.R_E_C_N_O_ AS LISTAID, (DA1010.DA1_CODTAB + DA1010.DA1_ITEM) AS IDUNICO, SB1010.R_E_C_N_O_ AS ITEMPID, DA1010.DA1_PRCVEN,  DA1010.R_E_C_N_O_ FROM DA1010 INNER JOIN
             DA0010 ON DA1010.DA1_CODTAB = DA0010.DA0_CODTAB INNER JOIN SB1010 ON DA1010.DA1_CODPRO = SB1010.B1_COD'
		
	

! !

Exporta subclass: #ExportaListaPrecio
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPV-Model'!

!ExportaListaPrecio class methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/14/2015 00:16'!
createInstance
	| e |
	e := self new initialize.
	e directorio: 'c:\temp'.
	e refname: 'DA0010'.
	e localrefname: 'ListaPrecio'.
	"nombre vencimiento tipo habilitada itemsLista"
	e fields: #('DA0_DESCRI' 'DA0_DATATE' 'DA0_ATIVO' 'R_E_C_N_O_').
	e localfields: #( 'nombre' 'vencimiento' 'habilitada' 'pid').
	e key: #R_E_C_N_O_.
	e localkey: #pid.
	^ e
	! !

!ExportaListaPrecio methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/6/2015 10:51'!
newObject
	^ ListaPrecio new.! !

!ExportaListaPrecio methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/14/2015 00:21'!
sincroObject: lista withJSON: data
	lista pid: (data at: 'R_E_C_N_O_').
	lista nombre: (data at: 'DA0_DESCRI').
	lista idUnico: (data at: 'DA0_CODTAB').
	(data at: 'DA0_DATATE') = ''
		ifTrue: [ lista vencimiento: nil ]
		ifFalse: [ 
			lista
				vencimiento:
					(DateAndTime
						year: ((data at: 'DA0_DATATE') copyFrom: 1 to: 4)
						month: ((data at: 'DA0_DATATE') copyFrom: 5 to: 6)
						day: ((data at: 'DA0_DATATE') copyFrom: 7 to: 8)) ].
	lista habilitada: ((data at: 'DA0_ATIVO') = '1').
! !

!ExportaListaPrecio methodsFor: 'as yet unclassified' stamp: 'PabloDigonzelli 5/14/2015 00:23'!
valorJSON: aJSON of: aField
	aField = #DA0_ATIVO
		ifTrue: [  ^ ( (aJSON at: aField ) = '1') ].
	aField = #DA0_DADATE
		ifTrue: [  ^ ( (aJSON at: aField ) = '1') ].

	^ aJSON at: aField! !
